8.1.0-dev.50 | 2025-08-12 17:42:46 -0700

  * Add NEWS entry for field length limiting (Tim Wojtulewicz, Corelight)

  * Tag truncated values with a flag, plus pack threading::Value better (Tim Wojtulewicz, Corelight)

  * Remove length limiting on string fields for HTTP (Tim Wojtulewicz, Corelight)

  * Make total_size counter a member in logging::Manager (Tim Wojtulewicz, Corelight)

  * Remove using numeric_limits and just check for zero instead (Tim Wojtulewicz, Corelight)

  * Expand the size of the log-size filters for x509 (Tim Wojtulewicz, Corelight)

  * Add options to filter at the stream level as well as globally (Tim Wojtulewicz, Corelight)

  * Add a weird that gets emitted when strings/containers are over the limits (Tim Wojtulewicz, Corelight)

  * Add metrics to track string and container fields limited by length (Tim Wojtulewicz, Corelight)

  * Replace unused stream argument from RecordToLogRecord with WriterInfo (Tim Wojtulewicz, Corelight)

    This also adds a WriterInfo argument to ValToLogVal and passes the one from
    RecordToLogRecord into it.

  * Implement string- and container-length filtering at the log record level (Tim Wojtulewicz, Corelight)

8.1.0-dev.38 | 2025-08-12 12:38:24 -0700

  * Bump pre-commit hooks (Benjamin Bannier, Corelight)

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

8.1.0-dev.35 | 2025-08-12 11:01:12 -0700

  * Pass DNS complete_flag along as a uint8_t instead of a String (Tim Wojtulewicz, Corelight)

  * Update docs submodule with 8.1 deprecation removals (Tim Wojtulewicz, Corelight)

  * Update zeekjs submodule with 8.1 deprecation fixes (Tim Wojtulewicz, Corelight)

  * Remove deprecations tagged for v8.1 (Tim Wojtulewicz, Corelight)

8.1.0-dev.29 | 2025-08-11 11:37:22 -0700

  * smb2/read: Parse only 1 byte for data_offset, ignore reserved1 (Arne Welzel, Corelight)

    A user provided a SMB2 pcap with the reserved1 field of a ReadResponse
    set to 1 instead of 0. This confused the padding computation due to
    including this byte into the offset. Properly split data_offset and
    reserved1 into individual byte fields.

    Closes #4730

8.1.0-dev.27 | 2025-08-10 21:28:33 -0700

  * GH-4176: cluster: Add on_subscribe() and on_unsubscribe() hooks (Arne Welzel, Corelight)

    Closes #4176

8.1.0-dev.24 | 2025-08-08 14:23:51 +0200

  * GH-4176: cluster: Add on_subscribe() and on_unsubscribe() hooks (Arne Welzel, Corelight)

8.1.0-dev.22 | 2025-08-07 08:39:27 -0700

  * Update zeek-aux to remove BRO_DIST from plugin skeleton (Tim Wojtulewicz, Corelight)

  * cmake_minimum_required() should come before project() (Tim Wojtulewicz, Corelight)

8.1.0-dev.19 | 2025-08-07 10:48:40 +0200

  * btest/tap-analyzer: Update existing test and add new one for UpdateConnVal() (Arne Welzel, Corelight)

    This also changes the output of connection UIDs from the tap analyzer to be
    prefixed with C for easier correlation with other logs.

  * SessionAdapter: Keep tap_analyzers until destruction (Arne Welzel, Corelight)

    connection_state_remove() is invoked after Done(), so it's not a good
    idea to remove the tap analyzers before in case they have up-to-date
    information for the connection val.

  * tcp,udp,icmp adapters: Move TapPacket() to earlier (Arne Welzel, Corelight)

    Writing a test, the packet was tapped after protocol analysis at least
    for TCP. Ensure tapping happens before. The adapter->Process() moving
    after pkt->session made me a bit wondering if things are underspecified
    here, but seems reasonable to set the session on pkt before adapter->Process().

  * tcp,udp,icmp adapters: Fix UpdateConnVal() superclass call (Arne Welzel, Corelight)

    Now that SessionAdapter implements UpdateConnVal(), the individual
    adapters need to call that instead of Analyzer::UpdateConnVal()

    Thanks clang-tidy.

8.1.0-dev.14 | 2025-08-06 14:37:50 +0100

  * Add proto to analyzer.log (Johanna Amann, Corelight)

    The analyzer.log file was missing the protocol field to distinguish
    tcp/udp connections.

8.1.0-dev.12 | 2025-08-06 09:10:08 -0400

  * GH-4722: Fix record coercion with compatible types (Evan Typanski, Corelight)

    Fixes #4722

8.1.0-dev.10 | 2025-08-06 14:27:32 +0200

  * TapAnalyzer: Fix docstring (Arne Welzel, Corelight)

    Relates to #4337 #4725 #4734

  * btest/plugins/tap-analyzer: Update baseline (Arne Welzel, Corelight)

    Relates to #4337 #4725 #4734

8.1.0-dev.7 | 2025-08-05 20:00:19 +0200

  * TapAnalyzer: More verdict to action rename (Arne Welzel, Corelight)

    Relates to #4725 #4337

8.1.0-dev.5 | 2025-08-05 19:48:50 +0200

  * IPBasedAnalyzer: Call TapPacket() when skipping (Arne Welzel, Corelight)

    When skip_further_processing() is called, a TapAnalyzer should still see
    the packets as skipped with SkipReason "skipping".

  * SessionAdapter: Introduce TapAnalyzer for session adapter (Arne Welzel, Corelight)

    This commit introduces a mechanism to attach light weight analyzers to
    the root analyzer of sessions in order to tap into the packets delivered
    to child analyzer.

8.1.0-dev.2 | 2025-08-04 09:35:41 -0700

  * Compile contributors for Zeek 8.0 in the NEWS file (Christian Kreibich, Corelight)

  * Start of 8.1.0 development (Tim Wojtulewicz, Corelight)

8.0.0-dev.827 | 2025-08-01 17:10:13 +0200

  * ci/windows: No ZeroMQ cluster backend (Arne Welzel, Corelight)

    Doesn't seems there's libzmq available, so just skip building.

  * cluster/zeromq: Bail on missing ZeroMQ by default (Arne Welzel, Corelight)

8.0.0-dev.824 | 2025-08-01 14:49:35 +0200

  * Remove zeek::Span and use std::span instead (Dominik Charousset, Corelight)

8.0.0-dev.821 | 2025-07-31 14:32:00 -0700

  * Update CT/CA lists to versions from NSS 3.114 (Tim Wojtulewicz, Corelight)

8.0.0-dev.817 | 2025-07-31 10:34:43 -0700

  * Fix use-after-move reported by clang-tidy (Tim Wojtulewicz, Corelight)

    This was introduced by 9eb94ee151ec437fd076ef16d016af372391af65.

8.0.0-dev.815 | 2025-07-31 16:10:33 +0100

  * Add tests for the deprecated-dpd-log.zeek policy script (Johanna Amann, Corelight)

    This re-adds baselines for the old dpd.log to check functionality until
    its removal in 8.1

  * Move c$service_violation to deprecated-dpd-log.zeek (Johanna Amann, Corelight)

    This moves c$service_violation to the deprecated-dpd-log policy script.

    This is the only script in the distribution that uses the field, and it
    is unlikely to be used externally. It is also responsible for a
    significant amount of memory use by itself.

8.0.0-dev.812 | 2025-07-31 07:57:52 -0700

  * Bump `auxil/spicy` to latest development snapshot (Benjamin Bannier, Corelight)

8.0.0-dev.809 | 2025-07-30 10:28:06 +0200

  * RecordType: Ensure &default fields are always re-initialized (Arne Welzel, Corelight)

    This started working partly after the deferral logic introduced with
    Zeek 6.0 so this finishes it :-)

  * Attr: Deprecate using &default and &optional together on record fields (Arne Welzel, Corelight)

    If &default implies re-initialization of the field, using them together
    doesn't make much sense.

  * RecordType: Allow deferring &default=vector(), set(), table() fields (Arne Welzel, Corelight)

8.0.0-dev.805 | 2025-07-30 10:07:50 +0200

  * fixes for specialized ZAM operations needing to check whether record fields exist (Vern Paxson, Corelight)

8.0.0-dev.802 | 2025-07-29 21:00:52 +0100

  * DNS-fuzzer: raise new_connection event (Johanna Amann, Corelight)

    The conn protocol scripts now assume that new_connection is run before
    connection_state_remove. Update the DNS fuzzer to raise the
    new_connection event.

  * Move Conn::set_conn() from connection_state_remove to new_connection (Johanna Amann, Corelight)

    c$conn is often needed for connection events, but it being established
    in connection_state_removed can be a problem because event handlers have
    to remember to call Con::set_conn().

    This commit moves to call Conn::set_conn() in new_connection.

8.0.0-dev.797 | 2025-07-29 18:23:35 +0200

  * cluster::Event: Move implementation into cluster/Event.{h,cc} (Arne Welzel, Corelight)

  * cluster: Move cluster::detail::Event to cluster::Event (Arne Welzel, Corelight)

    This class is a parameter of virtual methods of the Backend API for users
    to implement and also a parameter to the HookPublishEvent() API. Seems it
    shouldn't be in detail and instead we should own it.

    Alternatively, could mark the cluster APIs as not-stable-yet, but I
    think we can move forward and make it non-detail for 8.0.

8.0.0-dev.794 | 2025-07-29 07:41:13 -0700

  * Fix ConnKey deprecation warnings from generic fuzzer (Tim Wojtulewicz, Corelight)

8.0.0-dev.792 | 2025-07-29 07:19:25 -0700

  * Fix types passed to some of the IRC analyzer events (Tim Wojtulewicz, Corelight)

8.0.0-dev.790 | 2025-07-29 07:18:39 -0700

  * Fix build failure with std::ranges on Debian 11 (Tim Wojtulewicz, Corelight)

8.0.0-dev.788 | 2025-07-29 11:29:11 +0200

  * cluster.bif: Improve Cluster::publish() docstring (Arne Welzel, Corelight)

  * btest/cluster/zeromq: Add tests for overload behavior (Arne Welzel, Corelight)

    The overload-drop.zeek and overload-no-drop.zeek tests have proxy,
    worker-1 and worker-2 publish to the manager topic. For the drop
    case, we verify that both, the senders, but also the manager drops
    events. For the no-drop test, the HWMs are set such that all events
    are buffered.

    The overload-worker-proxy-topic*.zeek tests are similar, but instead
    of publishing to the manager topic, proxy, worker-1 and worker-2 publish
    to the proxy and worker topics to overload each other. This had
    previously resulted in lockups and these tests verify that this doesn't
    happen anymore.

  * cluster/zeromq: Metric for msg errors (Arne Welzel, Corelight)

  * cluster/zeromq: Drop events when overloaded (Arne Welzel, Corelight)

    When either the XPUB socket's hwm is reached, or the onloop queue is
    full, drop the events. Users can set ths xpub_sndhwm and
    onloop_queue_hwm to 0 to avoid these drops at the risk of unbounded
    memory growth.

  * cluster/zeromq: Comments and move lookups to InitPostScript() (Arne Welzel, Corelight)

  * cluster/zeromq: Rework lambdas to member functions (Arne Welzel, Corelight)

  * cluster/zeromq: Support local XPUB/XSUB hwm and buf configurability (Arne Welzel, Corelight)

  * cluster/OnLoop: Support DontBlock and Force flags for queueing (Arne Welzel, Corelight)

    Also allow max_queue_size to be 0 for unlimited queueing.

  * cluster/ThreadedBackend: Injectable OnLoopProcess instance (Arne Welzel, Corelight)

    This allows injecting a custom onloop process to configure the
    max_queue_size at instantiation time. Also allow access to the
    instance directly and deprecate the QueueForProcessing() helper

8.0.0-dev.778 | 2025-07-29 10:12:18 +0200

  * ConnStats: Expose num_packets_unprocessed (Arne Welzel, Corelight)

    Not sure it's the best place to put, but we don't have packet analysis stats
    bif and also num_packets is already there, so seems reasonable to put the
    num_packets_unprocessed into

  * packet_analysis/Manager: Rename GetUnprocessedCount() to PacketsUnprocessed() (Arne Welzel, Corelight)

    Mostly to align with PacketsProcessed()

8.0.0-dev.775 | 2025-07-29 10:05:20 +0200

  * Update .git-blame-ignore-revs (Arne Welzel, Corelight)

  * analyzer/protocol: Reformat with spicy-format (Arne Welzel, Corelight)

  * pre-commit-config: Bump spicy-format to 0.26.0 (Arne Welzel, Corelight)

8.0.0-dev.770 | 2025-07-28 14:18:15 -0700

  * dce-rpc: Make named_pipe filed docs extensive (Arne Welzel, Corelight)

    Closes #3935

8.0.0-dev.768 | 2025-07-28 14:16:16 -0700

  * Fix parsing of EDNS rcode (Johanna Amann, Corelight)

    The EDNS rcode was incorrectly calculated. The extended rcode is formed
    by taking the upper 8 bits of the extended rcode field, plus the lower 4
    bits of the existing rcode.

    This also adds a new trace with an extended rcode, and a testcase
    parsing it.

    Reported by dwhitemv25.

    Fixes GH-4656

8.0.0-dev.766 | 2025-07-28 14:15:19 -0700

  * Expand coverage of IRC analyzer with more commands (Tim Wojtulewicz, Corelight)

  * Add support for ircv3 tags (Tim Wojtulewicz, Corelight)

    This also replaces the irc-dcc-send.trace file in our pcap library with
    a cleaner one that includes ircv3 tags.

8.0.0-dev.763 | 2025-07-28 13:57:18 -0700

  * Move ID::type in structure to fill memory padding (Tim Wojtulewicz, Corelight)

  * Use sorted forward_list instead of multimap for ID option change handlers (Tim Wojtulewicz, Corelight)

8.0.0-dev.760 | 2025-07-28 13:12:47 -0700

  * Remove intermediate cipher vectors in ssl-analyzer.pac (Tim Wojtulewicz, Corelight)

  * Reduce the size of Func::Body quite a bit with some extra packing (Tim Wojtulewicz, Corelight)

  * Switch to using std::ranges algorithms (Tim Wojtulewicz, Corelight)

  * Enable modernize-std-numbers clang-tidy checker, fix findings (Tim Wojtulewicz, Corelight)

  * Switch to using c++20 constraints instead of std::enable_if (Tim Wojtulewicz, Corelight)

8.0.0-dev.754 | 2025-07-28 12:24:41 -0400

  * Deprecate `record_type_to_vector` (Evan Typanski, Corelight)

    After #4682, record_fields is ordered so this is redundant. Furthermore,
    it is incorrectly documented, as it says nested records are flattened.

8.0.0-dev.751 | 2025-07-25 09:13:51 -0700

  * Use size_t for byte sizes in SerializationFormat (Tim Wojtulewicz, Corelight)

  * Add ODesc::Size() that returns size_t, deprecate ODesc::Len() (Tim Wojtulewicz, Corelight)

8.0.0-dev.748 | 2025-07-25 10:58:16 +0200

  * RecordType: Allow field init deferral of deferrable record constructors (Arne Welzel, Corelight)

    The ctx: conn_id_ctx &default=conn_id_ctx() field was not optimized
    as deferrable even though by default its an empty record and so deferring
    initialization seems safe. Open-code the special record constructor
    expression case in ExprFieldInit so that the ctx field is not default
    initialized at record construction anymore. I am wondering a bit if the
    same applies to &default=set() and &default=table().

  * Conn: Use conn_id_ctx singleton (Arne Welzel, Corelight)

  * Conn: Add InitPostScript() and conn_id_ctx singleton (Arne Welzel, Corelight)

  * ID: Add conn_id_ctx (Arne Welzel, Corelight)

    Seemed a bit unfortunate to use id::connection and id::conn_id, but
    then do something different for conn_id_ctx.

8.0.0-dev.742 | 2025-07-24 12:46:16 -0700

  * Update broker submodule to pull in clang 20 fix [nomail] (Tim Wojtulewicz, Corelight)

8.0.0-dev.740 | 2025-07-24 10:39:42 -0700

  * Add process_start_time_seconds and process_pid metrics (Tim Wojtulewicz, Corelight)

8.0.0-dev.738 | 2025-07-24 08:00:57 -0700

  * CI: Only run weekly tasks as part of cron (Tim Wojtulewicz, Corelight)

8.0.0-dev.736 | 2025-07-24 09:48:54 +0200

  * GH-4645: conn_key/fivetuple: Handle one-way ICMP conns in DoConnKeyFromVal() (Arne Welzel, Corelight)

    When a conn_id represents a ICMP "connection", we need to determine the
    is_one_way flag for InitTuple() in order to skip any flipping of address
    and ports for one-way ICMP connections.

8.0.0-dev.734 | 2025-07-24 07:55:31 +0100

  * PPPoE: add session id logging (Johanna Amann, Corelight)

    This adds a new PacketAnalyzer::PPPoE::session_id bif, which extracts
    the PPPoE session ID from the current packet.

    Furthermore, a new policy script is added which adds the pppoe session
    id to the connection log.

8.0.0-dev.730 | 2025-07-23 15:26:08 -0700

  * Fix a few other minor issues reported by Coverity (Tim Wojtulewicz, Corelight)

  * Add a few extra null checks, plus a missing initialization that led to a bad null check (Tim Wojtulewicz, Corelight)

  * Fix some integer overflow issues reported by Coverity (Tim Wojtulewicz, Corelight)

  * Ignore a couple of known-unused results reported by Coverity (Tim Wojtulewicz, Corelight)

  * Fix some bit-shifting overflow/UB issues reported by Coverity (Tim Wojtulewicz, Corelight)

  * Reset the value of a status variable in SQLite backend before using it in a loop (Tim Wojtulewicz, Corelight)

  * Fix a potential memory leak reported by Coverity (Tim Wojtulewicz, Corelight)

  * Avoid some string copies in IRC analyzer (Tim Wojtulewicz, Corelight)

  * Add some additional std::moves reported by Coverity (Tim Wojtulewicz, Corelight)

  * Fix an unsigned integer comparison reported by Coverity (Tim Wojtulewicz, Corelight)

  * Fix uninitialized class member Coverity findings (Tim Wojtulewicz, Corelight)

  * Handle uncaught exception during setup (Tim Wojtulewicz, Corelight)

  * Update gen-zam submodule for Coverity findings (Tim Wojtulewicz, Corelight)

8.0.0-dev.716 | 2025-07-23 14:03:47 -0700

  * Fix swapped storage metrics names (Tim Wojtulewicz, Corelight)

  * Add flag to force synchronous mode when calling storage script-land functions (Tim Wojtulewicz, Corelight)

8.0.0-dev.713 | 2025-07-23 19:31:13 +0200

  * NEWS: ZeekControl, ZeroMQ and WebSocket (Arne Welzel, Corelight)

  * Update zeekctl module for ClusterBackend and UseWebSocket (Arne Welzel, Corelight)

  * control: Use Cluster::publish() for replying (Arne Welzel, Corelight)

    Switching to ZeroMQ as cluster backend and dabbling with zeekctl
    and WebSocket, replies didn't arrive due to the usage of
    Broker::publish() rather than Cluster::publish(). Additionally,
    add the node name to the topic on which we reply so that the
    receiver can figure out which node sent the reply. It could've
    been a separate event parameter, but the topic appears just fine.

  * Fix clang-tidy findings in embedded C++ from bif files (Tim Wojtulewicz, Corelight)

8.0.0-dev.707 | 2025-07-23 08:21:17 -0700

  * CI: Add weekly task for running builds with newest compilers (Tim Wojtulewicz, Corelight)

8.0.0-dev.705 | 2025-07-23 08:20:30 -0700

  * Output more information when cloning repos for include_plugins CI task (Tim Wojtulewicz, Corelight)

8.0.0-dev.703 | 2025-07-23 13:37:56 +0200

  * Type/RecordType: Make table returned by GetRecordFieldsVal() ordered (Arne Welzel, Corelight)

    Seems only reasonable to provide that guarantee as pointed out in #4674.

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

8.0.0-dev.700 | 2025-07-22 11:40:19 -0700

  * Update zeek-af_packet-plugin submodule to fix initialization [nomail] (Tim Wojtulewicz, Corelight)

8.0.0-dev.698 | 2025-07-22 08:04:59 -0700

  * Return weird if a log line is over a configurable size limit (Tim Wojtulewicz, Corelight)

8.0.0-dev.693 | 2025-07-18 14:28:29 -0700

  * Add SQLite page_count and file_size metrics (Tim Wojtulewicz, Corelight)

  * Add btests to cover storage metrics (Tim Wojtulewicz, Corelight)

  * Add storage metrics for operations, expirations, data transferred (Tim Wojtulewicz, Corelight)

  * Fix ordering of telemtry metrics when running under test (Tim Wojtulewicz, Corelight)

  * Make RunPragma take an optional value parser to return data (Tim Wojtulewicz, Corelight)

  * Make SQLite::Step take a callback function for parsing result data (Tim Wojtulewicz, Corelight)

8.0.0-dev.684 | 2025-07-17 12:58:57 -0700

  * Update libkqueue submodule [nomail] (Tim Wojtulewicz, Corelight)

8.0.0-dev.682 | 2025-07-17 09:09:28 -0700

  * Use std::string/string_view versions of starts_with/ends_with where appropriate (Tim Wojtulewicz, Corelight)

    The util:: versions of these methods remain as a thin wrapper around them so
    they can be used with const char* arguments. Otherwise callers have to manually
    make string_view objects from the input.
    s Please enter the commit message for your changes. Lines starting

8.0.0-dev.680 | 2025-07-17 08:40:49 -0700

  * Add nolint for enum size for HILTI_RT_ENUM use (Tim Wojtulewicz, Corelight)

8.0.0-dev.677 | 2025-07-16 17:46:48 +0200

  * Spicy: Fix missing include. (Robin Sommer, Corelight)

  * Bump Spicy. (Robin Sommer, Corelight)

  * GH-4481: Spicy: Add functions to check if Zeek provides an analyzer of a given name. (Robin Sommer, Corelight)

    ```
    ## Checks if there is a Zeek analyzer of a given name.
    ##
    ## analyzer: the Zeek-side name of the analyzer to check for
    ## if_enabled: if true, only checks for analyzers that are enabled
    ##
    ## Returns the type of the analyzer if it exists, or ``Undef`` if it does not.
    public function has_analyzer(analyzer: string, if_enabled: bool = True): bool &cxxname="zeek::spicy::rt::has_analyzer";

    ## Differentiates between the types of analyzers Zeek provides.
    public type AnalyzerType = enum { Protocol, File, Packet, };

    ## Returns the type of a Zeek analyzer of a given name.
    ##
    ## analyzer: the Zeek-side name of the analyzer to check
    ## if_enabled: if true, only checks for analyzers that are enabled
    ##
    ## Returns the type of the analyzer if it exists, or ``Undef`` if it does not.
    public function analyzer_type(analyzer: string, if_enabled: bool = True): AnalyzerType &cxxname="zeek::spicy::rt::analyzer_type";

    ```

8.0.0-dev.673 | 2025-07-16 12:38:09 +0200

  * NEWS: Add entry about SMTP::enable_rfc822_msg_file_analysis (Arne Welzel, Corelight)

  * btest: Add tests for full email extraction (cccs-jsjm)

  * SMTP: Adapt scripts for enable_rfc822_msg_file_analysis (Arne Welzel, Corelight)

    Specifically, set a MIME part's parent_id to the rfc822_msg_fuid if it
    is set and take into account the current rfc822_msg_fuid for describe_file()
    to avoid fuid collisions of the top-level RFC822 message and the first
    MIME part.

  * SMTP: Add missing Undelivered() call (Arne Welzel, Corelight)

  * SMTP: Add enable_rfc822_msg_file_analysis (Arne Welzel, Corelight)

    Enabling this option will instantiate a new fa_file instance for every
    top-level RFC 822 message in an SMTP transaction.

8.0.0-dev.667 | 2025-07-15 17:37:41 -0700

  * GH-4559: Prefer explicit construction to coercion in record initialization (Benjamin Bannier, Corelight)

8.0.0-dev.665 | 2025-07-15 17:36:31 -0700

  * Add missing header to allow std::sort() on GCC 15.1 (Christian Kreibich, Corelight)

  * Make PUT on SQLite backend implicitly overwrite expired entries (Benjamin Bannier, Corelight)

  * Prevent SQLite storage backend from serving expired entries (Benjamin Bannier, Corelight)

  * Update package-manager submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update binpac submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

8.0.0-dev.656 | 2025-07-14 13:09:11 -0700

  * Fix some missing #includes resulting from removal of ghc::filesystem (Tim Wojtulewicz, Corelight)

  * Remove ghc::filesystem submodule, switch to std::filesystem (Tim Wojtulewicz, Corelight)

8.0.0-dev.653 | 2025-07-14 11:26:06 -0700

  * Documentation: connection_SYN_packet (Johanna Amann, Corelight)

    Slightly clarify documentation related to the connection_SYN_packet
    event.

8.0.0-dev.651 | 2025-07-14 09:31:19 -0700

  * Use ranges::reverse_view to fix a few reverse ranged-for loops (Tim Wojtulewicz)

  * Disable a few new modernize clang-tidy checkers, enabled by C++20 (Tim Wojtulewicz)

  * btest: Switch putty.org usage in tests to official URL (Arne Welzel, Corelight)

    Closes #4655

8.0.0-dev.646 | 2025-07-13 19:22:52 -0700

  * Move util::Deferred into util-types.h (Tim Wojtulewicz, Corelight)

8.0.0-dev.643 | 2025-07-11 15:35:33 -0400

  * Cleanup unused baselines (Evan Typanski, Corelight)

8.0.0-dev.641 | 2025-07-11 12:13:45 -0700

  * Add NEWS entry about C++ 20 [nomail] [skip ci] (Tim Wojtulewicz, Corelight)

8.0.0-dev.639 | 2025-07-11 12:58:06 -0400

  * crash fixes for constructs that expect add/delete expressions to return values (Vern Paxson, Corelight)

8.0.0-dev.636 | 2025-07-10 15:42:52 -0700

  * Reduce some false-positive warnings from GCC to warnings with -Werror (Tim Wojtulewicz, Corelight)

    This also works around some of the same warnings. These are known bugs
    in GCC 11+ and GCC 13.x.

  * Add zeek-namespaced alias for jthread (Tim Wojtulewicz, Corelight)

    Apple Clang (as of version 17.0.0) does not support jthread unless
    you enable experimental libcpp features by defining
    _LIBCPP_ENABLE_EXPERIMENTAL or passing -fexperimental_library to
    the compiler. Even if you don't do those, our 3rdparty jthread
    library fails to build because of a bunch of namespace/naming
    collisions. I moved our 3rdparty one to the `nonstd` namespace, and
    am using an alias under __APPLE__ to avoid the collisions.

  * Include RequireCXXStd.cmake from main CMakeLists.txt (Tim Wojtulewicz, Corelight)

  * Update submodules to C++20-enabled versions (Tim Wojtulewicz, Corelight)

8.0.0-dev.631 | 2025-07-10 08:55:39 -0700

  * Modify known-services policy script to add storage framework support (Tim Wojtulewicz, Corelight)

    This adds a flag to enable using the storage framework instead of Broker stores,
    plus a btest for both broker and the the storage framework.

8.0.0-dev.629 | 2025-07-10 09:38:32 +0200

  * Spicy: Add linker scope to debugging output. (Robin Sommer, Corelight)

  * Spicy: Remove declarations for unimplemented functions. (Benjamin Bannier, Corelight)

  * Spicy: Bump `auxil/spicy/` to latest development snapshot. (Benjamin Bannier & Robin Sommer, Corelight)

  * Spicy: Let `zeek::protocol_handle_close()` send a TCP EOF. (Benjamin Bannier, Corelight)

    Zeek's analyzer API makes it hard to determine during analyzer
    shutdown whether a regular end-of-data has been reached, or if we're
    aborting in the middle of a session (e.g., because Zeek missed the
    remaining packets): the corresponding analyzer method, `EndOfData()`
    gets called in both cases.

    In an earlier change, we had stopped signaling Spicy analyzers a
    regular finish when that `EndOfData()` method executes, because doing
    so could trigger a parse error if it wasn't a regular shutdown—-which
    isn't desired, a user request was to just silently stop processing in
    this case.

    However, that behavior now seems unfortunate in the case that one
    deliberately calls `zeek::protocol_handle_close()` to terminate an
    analyzer: this feels like a regular shutdown that should just
    immediately happen. We achieve this now in this function by
    additionally signaling the shutdown at the TCP layer as an "end of
    file", which, for Spicy analyzers, happens to run the final, orderly
    tear-down.

    Not exactly great, but ti seems to thread the needle to achieve the
    desired semantics in both cases.

8.0.0-dev.622 | 2025-07-09 15:10:03 -0700

  * ZAM optimizer fix for += / -= set operations (Vern Paxson, Corelight)

  * Bump `spicy-format` pre-commit hook (Benjamin Bannier, Corelight)

    pre-commit ignores Cargo.lock files for Rust projects, so any movement
    in a Rust project's dependencies can break a hook, even if no code in
    the hook changed. I have tried to work with upstream on a fix, but they
    basically told me they weren't interested and to get lost.

    This bumps the `spicy-format` pre-commit hook to a new version which
    explicitly deals with bumps of its dependencies. Having to do this
    semi-regularly is not fun, and ideally somebody interested in using this
    hook would help set up infrastructure in the hook so it just pulls
    pre-built binaries. This is not directly supported by pre-commit, but
    many projects work around this by declaring a Python module which then
    pulls pre-build binaries which already exist for spicy-format.

8.0.0-dev.618 | 2025-07-08 17:45:16 -0700

  * Clarify the cookie field's origin in the RDP log. (Christian Kreibich, Corelight)

8.0.0-dev.615 | 2025-07-08 17:53:56 +0200

  * Add NEWS entry for generic packet thresholds (Jan Grashoefer, Corelight)

  * Allow for multiple generic packet thresholds (Jan Grashoefer, Corelight)

    Co-authored-by: Arne Welzel <arne.welzel@corelight.com>

  * Add btest for conn_generic_packet_threshold_crossed event (Jan Grashoefer, Corelight)

  * Update dump-events btest baseline (Jan Grashoefer, Corelight)

    Changes in endpoint stats are a side-effect caused by the ConnSize
    analyzer updating the conn record triggering the threshold event. The
    phenomenon is described in https://github.com/zeek/zeek/issues/4214.

  * Add conn_generic_packet_threshold_crossed event (Jan Grashoefer, Corelight)

8.0.0-dev.609 | 2025-07-08 11:42:05 +0100

  * PPPoE: don't forward more bytes than header indicates (Johanna Amann, Corelight)

    This changes the PPPoE parser so that it doesn't forward extra bytes
    that might be appended after the payload. Instead, it raises a weird if
    the payload size doesn't match the size indicated by the header.

    This is in line with what other protocol parsers (like UDP) are doing.

    Addresses GH-4602

8.0.0-dev.605 | 2025-07-08 10:40:45 +0200

  * Bump ZeekJS to work with new Location constructor (Arne Welzel, Corelight)

  * remove non-functional column information from Location objects (Vern Paxson, Corelight)

  * isolate Location specifics to private class variables to enforce correct line number ordering (Vern Paxson, Corelight)

8.0.0-dev.601 | 2025-07-07 20:07:30 +0200

  * script_opt/IDOptInfo: Add NOLINT(bugprone-branch-clone) (Arne Welzel, Corelight)

8.0.0-dev.599 | 2025-07-07 18:17:15 +0200

  * Bump zeekjs to v0.18.0 (Arne Welzel, Corelight)

8.0.0-dev.597 | 2025-07-07 18:13:44 +0200

  * fix for error in ZAM's constant propagation logic (Vern Paxson, Corelight)

8.0.0-dev.594 | 2025-07-03 20:43:51 +0200

  * scripts: Use tpe instead of type_, again (Arne Welzel, Corelight)

    The .rst generation doesn't escape the trailing `_` and the docs build
    gets upset due to using `type` as a reference target then.

    For the better or worse, revert to using tpe. Though I acknowledge this
    means we need to be careful with trailing underscores because our docs
    build is so fragile.

    Partly reverts b9eabbabbab912c8f45c49013865a88c1256f342.

8.0.0-dev.592 | 2025-07-03 18:41:29 +0200

  * NEWS: Adapt for conn_id$ctx introduction (Arne Welzel, Corelight)

  * conn_key/fivetuple: Drop support for non conn_id records (Arne Welzel, Corelight)

    Previously, we supported any records that happened to have orig_h,
    resp_h, etc. fields, but it's not exactly clear why we ever did. Users
    that relied on this can instantiate an explicit conn_id instance, too.

  * Conn: Move conn_id init and flip to IPBasedConnKey (Arne Welzel, Corelight)

    This loosens the coupling of the script-layer conn_id record and
    the code in Conn a bit, moving more into the IPBasedConnKey class.

    I'm not quite sure whether moving the flipping logic is worth it,
    but assuming Conn could become non-IP in the future, it might.

  * IPBasedConnKey: Add GetTransportProto() helper (Arne Welzel, Corelight)

  * input/Manager: Ignore empty record types (Arne Welzel, Corelight)

    Somewhere record types with zero fields get the optional attribute
    apparently. The input/sqlite/basic test failed due to complaining
    that ctx is optional. It isn't optional and when it has zero fields
    we can just ignore it, too.

    Also adds a input framework test with an explicit empty record type

  * external: Bump commit hashes for external suites (Arne Welzel, Corelight)

    get_file_handle() may include c$id and perturbs their values when adding new
    fields. I think that's reasonable, as files transferred in one VLAN should
    be treated separate from files transferred in a different VLAN.

  * ip/vlan_fivetuple: Populate nested conn_id_context, not conn_id (Arne Welzel, Corelight)

    This also enforces conn_id and conn_id_ctx types instead of being
    able to handle any conn_id-like record.

  * ConnKey: Extend DoPopulateConnIdVal() with ctx (Arne Welzel, Corelight)

    This prepares the move where ConnKey implementations should fill out
    ctx rather than filling conn_id directly. The API continues to receive
    both, conn_id and ctx, as adding fields to `conn_id` is reasonable
    use-case even if it's just for logging purposes.

  * btest: Update tests and baselines after adding ctx to conn_id (Arne Welzel, Corelight)

  * init-bare: Add conn_id_ctx to conn_id (Arne Welzel, Corelight)

    This nested record can be used to discriminate orig_h or resp_h being
    observed in different "contexts". A context can be based on VLAN tags,
    but any custom ConnKey implementation should populate the ctx field,
    allowing to write context-aware Zeek scripts without needing to know
    what the context really is.

8.0.0-dev.581 | 2025-07-02 07:47:32 +0100

  * Spicy SSL analyzer: non-functional tweaks (Johanna Amann, Corelight).

    Move the negotiated version outside of the possible range of protocol values,
    and move exceptions to &requires & throw instead of directly calling
    spicy::decline. This is stylistic with no functional changes.

8.0.0-dev.577 | 2025-07-01 14:19:26 -0400

  * Touchup TODOs in the Redis analyzer (Evan Typanski, Corelight)

    Also renames `KnownCommand` to `RedisCommand` to avoid conflicts.

  * Handle more Redis RESP3 protocol pieces (Evan Typanski, Corelight)

    This passes the "minimum protocol version" along in the reply and adds
    support for attributes, which were added relatively recently.

  * Stringify all Redis-RESP serialized data (Evan Typanski, Corelight)

  * GH-4504: Handle Redis protocol `message` separately (Evan Typanski, Corelight)

    Closes #4504

    Messages are not typical responses, so they need special handling. This
    is different between RESP2 and 3, so this is the first instance where
    the script layer needs to tell the difference.

8.0.0-dev.571 | 2025-07-01 11:03:23 +0200

  * Bump pre-commit hooks (Benjamin Bannier, Corelight)

8.0.0-dev.569 | 2025-07-01 09:20:43 +0200

  * SQLite: Reset expiration time on overwrite (Tim Wojtulewicz, Corelight)

8.0.0-dev.566 | 2025-06-30 14:19:26 -0700

  * Make clang-tidy warnings report as errors to cause CI build to fail (Tim Wojtulewicz, Corelight)

  * Fix a clang-tidy finding in cluster telemetry code (Tim Wojtulewicz, Corelight)

  * Fix clang-tidy readability-isolate-declaration warnings (Benjamin Bannier, Corelight)

    I missed one of these in review so a machine is probably better at
    catching them.

    I fixed the existing instances which where largely in code which look
    dated. Where possible I slightly reorganized the code so we do not have
    to leave values uninitialized, but did not touch up anything else.

8.0.0-dev.562 | 2025-06-30 17:55:58 +0200

  * cluster/WebSocket: Include X-Application-Name in cluster.log (Arne Welzel, Corelight)

    A bit ad-hoc formatting for the log, but that's mostly because cluster.log
    only has message field and I don't think having a dedicated application_name
    column is worth it. That could also be added by custom scripts if it's really
    wanted for a given deployment.

8.0.0-dev.560 | 2025-06-30 13:29:07 +0200

  * cluster/Telemetry: Cache CallExpr locations (Arne Welzel, Corelight)

  * cluster/Telemetry: Avoid unneeded StringVal() construction (Arne Welzel, Corelight)

  * Val: Switch TablePatternMatcher to std::string_view (Arne Welzel, Corelight)

    ...and add TableVal::LookupPattern(std::string_view sv).

  * RE: Add MatchAll() and MatchSet() for std::string_view (Arne Welzel, Corelight)

  * cluster/websocket: Fix and test for invalid X-Application-Name (Arne Welzel, Corelight)

  * cluster/telemetry: Move topic_normalization redef to zeromq (Arne Welzel, Corelight)

8.0.0-dev.551 | 2025-06-26 20:21:31 +0100

  * Spicy SSL analyzer: make record layer version parsing more strict (Johanna Amann, Corelight)

    The Spicy based SSL analyzer was, so far, more permissive with the
    record layer versions that it would accept.

    This change brings the parsing of record layer versions in line with the
    binpac based analyzer. This behavioral difference was discovered due to
    a test that changed with the recent dpd log changes.

8.0.0-dev.548 | 2025-06-26 18:49:31 +0200

  * extend script coverage profiling to track whether conditionals evaluate to true/false (Vern Paxson, Corelight)

8.0.0-dev.546 | 2025-06-26 14:30:37 +0200

  * btest/cluster/telemetry: Add smoke testing for telemetry (Arne Welzel, Corelight)

  * cluster/WebSocket: Fetch X-Application-Name header as app label (Arne Welzel, Corelight)

  * cluster/WebSocket: Pass X-Application-Name to dispatcher (Arne Welzel, Corelight)

    This is going to be used to add labels to telemetry if the
    X-Application-Name header is set.

  * broker/WebSocketShim: Add calls to Telemetry hooks (Arne Welzel, Corelight)

    WebSocket clients with Broker do not use the normal Broker backend, so
    we need to add the telemetry invocations explicitly.

  * cluster/WebSocket: Configure telemetry for WebSocket backends (Arne Welzel, Corelight)

  * broker: Hook up generic cluster telemetry (Arne Welzel, Corelight)

  * cluster: Introduce telemetry component (Arne Welzel, Corelight)

8.0.0-dev.538 | 2025-06-26 09:58:39 +0100

  * Only pass session ticket data in ssl_session_ticket_handshake event (Johanna Amann, Corelight)

    This commit fixes the parsing of the data field in the SSL analyzer. So
    far, this field contained two extra bytes at the beginning, which
    contain the length of the following data.

8.0.0-dev.535 | 2025-06-25 19:27:01 +0200

  * Update zeek.bif (bhaskarbhar)

  * Update init-bare.zeek (bhaskarbhar)

  * Remove `list` from Zeek grammar (Evan Typanski, Corelight)

    Using it would make Zeek segfault (at least in locals). It has been an
    error for 15 years.

8.0.0-dev.530 | 2025-06-25 10:35:53 -0400

  * Remove `list` from Zeek grammar (Evan Typanski, Corelight)

    Using it would make Zeek segfault (at least in locals). It has been an
    error for 15 years.

8.0.0-dev.528 | 2025-06-25 14:17:35 +0200

  * btest/plugins: Add test for custom ConnKey factory (Arne Welzel, Corelight)

    This just counts DoInits() and adds that information to the conn_id
    record, but without including it into the hash. Mostly for smoke
    testing.

  * NEWS updates for pluggable connection tuples. (Christian Kreibich, Corelight)

  * Add a VLAN-aware flow tuple implementation. (Christian Kreibich, Corelight)

    This is a first "real" implementation of a custom tuple, adding additional
    fields over the standard five-tuple.

    Includes test cases.

  * Deprecate ConnTuple and related APIs. (Christian Kreibich, Corelight)

    Given IP-aware ConnKeys, ConnTuples aren't really required any more. ConnTuple
    had two benefits:

    - It preserved the original src/dst orientation from the packet headers it was
    based on, which IPBasedConnKey now tracks and provides accessor methods for.

    - In IPBasedAnalyzer::AnalyzePacket() its instance survived past the std:move()
    of the key into NewConn(), which we sidestep by keeping the original src address
    and port around until we need after the connection is obtained.

  * Deprecate the old Connection constructor and detail::ConnKey class. (Christian Kreibich, Corelight)

    The new key-based Connection constructor replaces the former, and the new
    ConnKey class tree replaces the latter.

  * Switch to virtualized use of new zeek::ConnKey class tree (Christian Kreibich, Corelight)

    This touches quite a few places, but each just swaps out existing
    APIs and/or zeek::detail::ConnKey instances.

  * Provide a connkey factory for Zeek's default five-tuples. (Christian Kreibich, Corelight)

    Since the base factory is pure virtual this is now the first full
    implementation, but still a bit of a special case because it implements Zeek's
    default behavior and doesn't add "custom" content to the tuple.

  * Add IP-specific ConnKey implementation. (Christian Kreibich, Corelight)

    The InitTuple() implementation here is a placeholder for a fuller one following
    later, when we do away with the need for ConnTuple.

  * Establish plugin infrastructure for ConnKey factories. (Christian Kreibich, Corelight)

    ConnKey factories are intermediaries that encapsulate the details of how to
    instantiate ConnKeys, which codify the hash input for connection lookups.

  * Add new ConnKey abstraction. (Christian Kreibich, Corelight)

8.0.0-dev.517 | 2025-06-25 09:33:46 +0200

  * telemetry: Rename endpoint label to node label (Arne Welzel, Corelight)

    Using a label named "endpoint" is not intuitive and requires explaining to
    users that it's really just the Cluster::node value. Change the label to
    "node", so that we don't need to do the explaining.

    This probably breaks some existing users of the Prometheus metrics, but after
    looking more at metrics recently, "endpoint" really is a thorn in my eye.

8.0.0-dev.514 | 2025-06-24 15:38:18 -0700

  * Add get_tags_by_category BIF method (bhaskarbhar)

  * Add NEWS entry about deprecation of --with-binpac and --with-bifcl (Tim Wojtulewicz, Corelight)

8.0.0-dev.511 | 2025-06-24 12:51:08 -0700

  * Deprecate --with-binpac/--with-bifcl configure options (Tim Wojtulewicz, Corelight)

  * Remove deprecated --disable-archiver configure argument (Tim Wojtulewicz, Corelight)

8.0.0-dev.508 | 2025-06-24 19:07:14 +0200

  * btest/broker/publish-errors: Avoid exit(0) (Arne Welzel, Corelight)

    Calling exit() doesn't properly shutdown the manager instances and TSAN reports a
    leaked thread. Just avoid this for now by using terminate() instead.

8.0.0-dev.506 | 2025-06-24 17:44:06 +0200

  * DNS: Implement NAPTR RR support (Arne Welzel, Corelight)

    My phone is sending NAPTR queries and we reported an unknown RR type 35
    in weird.log for the response, so figured I'd just add it.

  * DNS: Move extract_char_string() helper around (Arne Welzel, Corelight)

8.0.0-dev.503 | 2025-06-24 17:14:28 +0200

  * cluster/zeromq: Short-circuit DoPublishLogWrite() when not initialized (Arne Welzel, Corelight)

    After moving the log_push initialization from the constructor to the
    DoInit() method, it's now possible that DoPublishLogWrites() is invoked
    even if DoInit() was never called. Handle this by short-circuiting. This
    is sort of an error, but can happen during tests if scripts are loaded
    somewhat arbitrarily.

  * cluster/zeromq: Hook up and enable IPV6 by default (Arne Welzel, Corelight)

    ZeroMQ's IPv6 support isn't enabled by default, resulting in
    "No such device" errors when attempting to listen on an IPv6
    address. This change adds a ipv6 option to the ZeroMQ module
    and enables it by default. Further, adds a test configuring
    everything to listen on IPv6 ::1 as well, and one test to provoke
    the original error. This also regularizes some error messages.

    The addr_to_uri() calls weren't actually needed, but they apparently do
    not hurt and the result is easier on the eyes, so use them :-)

  * cluster/zeromq/connect: Make failures fatal (Arne Welzel, Corelight)

    The cluster is borked if the initialization fails, so may as well just
    completely abort Zeek at that point with a fatal error. There's no real
    point in continuing to run.

  * cluster/zeromq: Move log_push creation to DoInit() (Arne Welzel, Corelight)

    The log_push socket should be affected by the IPV6 option, so need to
    delay its creation a bit.

8.0.0-dev.498 | 2025-06-24 16:30:52 +0200

  * GH-4587: Build builtin Spicy analyzers in debug mode if debug mode is enabled (Benjamin Bannier, Corelight)

8.0.0-dev.496 | 2025-06-24 14:00:39 +0100

  * Default canonifier change to only remove first timestamp in line (Johanna Amann, Corelight)

    In the past, we used a default canonifier, which removes everything that
    looks like a timestamp from log files. The goal of this is to prevent
    logs from changing, e.g., due to local system times ending up in log
    files.

    This update changes the default canonifier, so that only the first
    timestamp in a line is removed. This should skip timestamps that are
    likely to change while keeping timestamps that are parsed
    from protocol information.

  * Align SMB timestamp calculation between operating systems (Johanna Amann, Corelight)

    The way that SMB timestamps were calculated used a "long double" for
    the conversion calculation.

    OS-X and Linux seem to have different sizes for long doubles. On the
    Linux distributions that I have available, a long double is 128bits, vs
    64 bits in OS-X.

    This leads to slight discrepancies in the timestamps. This commit
    changes this calculation to use a double on both systems, which is 64
    bits and eliminates this difference.

8.0.0-dev.493 | 2025-06-23 10:52:22 -0700

  * Switch IPv6_Hdr_Chain to a vector of objects instead of pointers (Tim Wojtulewicz, Corelight)

8.0.0-dev.491 | 2025-06-23 10:39:31 -0700

  * Remove unneeded include dirs in zeromq CMakeLists.txt (Tim Wojtulewicz, Corelight)

8.0.0-dev.489 | 2025-06-23 10:36:38 -0700

  * Deprecate BRO_PLUGIN_INSTALL_PATH constant (Tim Wojtulewicz, Corelight)

  * Make constants in IP::ParseResult uppercase, deprecate the old ones (Tim Wojtulewicz, Corelight)

  * Fix comparison against CapLen results in IPTunnel (Tim Wojtulewicz, Corelight)

  * Fix clang-tidy warnings in headers (Tim Wojtulewicz, Corelight)

    This entry is a large collection of commits.

  * Change clang-tidy configuration to also scan headers (Tim Wojtulewicz, Corelight)

  * Don't pass local source/binary directory to zeek_add_plugin for Redis backend (Tim Wojtulewicz, Corelight)

  * Update bifcl/binpac/gen-zam submodules with clang-tidy fixes (Tim Wojtulewicz, Corelight)

  * Avoid linting headers in external paths (Tim Wojtulewicz, Corelight)

8.0.0-dev.447 | 2025-06-22 15:49:11 +0200

  * GH-4594: Align WebSocket error in cluster with one in Broker (Benjamin Bannier, Corelight)

    The schema of cluster WebSocket error messages deviated from the
    existing one in Broker which breaks seamless migration from the Broker
    WebSocket bindings.

    This patch aligns the serialization in cluster with the one in Broker.
    This is technically a breaking change of the cluster schema, but since
    it never worked like documented and is still experimental this is
    probably fine.

8.0.0-dev.445 | 2025-06-22 15:48:21 +0200

  * GH-4571: broker: Handle Broker::publish() with non Broker::Event (Arne Welzel, Corelight)

8.0.0-dev.443 | 2025-06-18 13:27:06 +0100

  * Change x509 not_before/not_after to not be based on local timezone (Johanna Amann, Corelight)

    Not the not_before/not_after fields output GMT based times.

    Also adds a new btest diff canonifier which only removes the first
    timestamp in a line.

  * Mark ZeekString vector helper methods deprecated (Tim Wojtulewicz, Corelight)

8.0.0-dev.439 | 2025-06-18 13:12:59 +0200

  * Enable Spicy SSL analyzer in nightly CI job against Spicy `HEAD` (Benjamin Bannier, Corelight)

  * Clean up use of references in Spicy SSL analyzer (Benjamin Bannier, Corelight)

    The Spicy SSL analyzer was using references pretty heavily, probably to
    work around now fixed issues with `inout` parameters in older Spicy
    versions. At least for units this seems not needed anymore, and was also
    partially incorrect, e.g., the Spicy docs call out that when using
    `inout` parameters, passed and expected types should match exactly so
    passing a reference as an `inout` value seems incorrect. Additionally,
    one use case for references in Spicy is to use their interior
    mutability, i.e., a reference never needs to be passed `inout` since
    their can always be mutated.

    Internally units are stored as reference-counted values, and references
    to units are not much cheaper since they also need to be refcounted.
    With that there seems litle reason to use references in this analyzer at
    all, and this patch drops their use completely; instead we either pass
    values, or values declared `inout`.

    We leave the use of references for sharing sinks in place.

  * GH-2091: Add workaround for zeek/spicy#2091 (Benjamin Bannier, Corelight)

8.0.0-dev.435 | 2025-06-17 09:25:30 +0200

  * GH-4573: IOSource: Remove IsPacketSource (Arne Welzel, Corelight)

    This wasn't used in tree and even the PktSrc class doesn't override this
    to return true, so just remove it outright without deprecation.

8.0.0-dev.433 | 2025-06-16 14:58:12 +0200

  * btest/logging: Fly-by cleanup (Arne Welzel, Corelight)

  * GH-4562: logging/Ascii: Fix abort() for non-existing postrotation functions (Arne Welzel, Corelight)

    When looking up the postprocessor function from shadow files, id::find_func()
    would abort() if the function wasn't available instead of falling back
    to the default postprocessor.

    Fix by using id::find() and checking the type explicitly and also adding a
    strict type check while at it.

    This issue was tickled by loading the json-streaming-logs package,
    Zeek creating shadow files containing its custom postprocessor function,
    then restarting Zeek without the package loaded.

  * Bump `auxil/spicy` to latest development snapshot (Benjamin Bannier, Corelight)

8.0.0-dev.428 | 2025-06-16 13:47:54 +0200

  * btest/cluster/websocket: Add cert-less test (Arne Welzel, Corelight)

8.0.0-dev.425 | 2025-06-11 13:18:36 -0700

  * Add missing #include to packet_analysis/Component.h (Tim Wojtulewicz, Corelight)

8.0.0-dev.423 | 2025-06-11 11:12:18 -0700

  * Remove some unused #includes from spicy code (Tim Wojtulewicz, Corelight)

  * Remove using util.h in various headers in favor of util-types.h (Tim Wojtulewicz, Corelight)

  * Move type definitions/aliases from util.h to a separate file (Tim Wojtulewicz, Corelight)

8.0.0-dev.419 | 2025-06-11 09:00:46 -0700

  * Bugfix: AsString() on an EnumVal will segfault (Christian Kreibich, Corelight)

8.0.0-dev.417 | 2025-06-11 17:24:11 +0200

  * GH-4522: smtp: Fix last_reply column in smtp.log for BDAT LAST (Arne Welzel, Corelight)

    The response to BDAT LAST was never recognized, resulting in the
    BDAT LAST commands not being logged in a timely fashion and receiving
    the wrong status.

    This likely doesn't handle complex pipeline scenarios, but it fixes
    the wrong behavior for smtp_reply() not handling simple BDAT commands
    responses.

    Thanks @cccs-jsjm for the report!

8.0.0-dev.414 | 2025-06-10 12:08:36 -0700

  * Move netbios_ssn_session_timeout to a script-level constant (Tim Wojtulewicz, Corelight)

8.0.0-dev.412 | 2025-06-10 18:50:39 +0200

  * btest/opt/ZAM-bif-tracking: Disable by default (Arne Welzel, Corelight)

8.0.0-dev.410 | 2025-06-09 18:00:33 -0700

  * Btests: don't use -C in Zeek invocations that don't actually need it (Christian Kreibich, Corelight)

  * Remove executable file permission bits from a bunch of our pcaps (Christian Kreibich, Corelight)

8.0.0-dev.406 | 2025-06-06 11:45:33 -0700

  * Move initialization of RandTest members to header (Tim Wojtulewicz, Corelight)

  * Update .clang-tidy to have modernize-* enabled with some exclusions (Tim Wojtulewicz, Corelight)

  * Fix clang-tidy modernize findings (Tim Wojtulewicz, Corelight)

  * Update bifcl submodule with clang-tidy fixes [nomail] (Tim Wojtulewicz, Corelight)

8.0.0-dev.389 | 2025-06-06 10:43:07 -0700

  * Make Zeekygen docs generation (-X) imply parse-only (-a) (Christian Kreibich, Corelight)

8.0.0-dev.382 | 2025-06-06 17:33:39 +0200

  * Fix `&ordered` attribute not preserved in table initializer assignments (赵富鹏)

8.0.0-dev.380 | 2025-06-06 10:26:17 +0200

  * docker: Add `net-tools` and `procps` dependencies (Edoardo Mich)

    Add `net-tools` and `procps` to the final.Dockerfile, to avoid warning in
    zeekctl commands like: "failed to find local IP addresses [...]" and the
    error in `zeekctl top` command caused respectively by missing `ifconfig`
    and `top` commands.

8.0.0-dev.378 | 2025-06-05 20:31:00 -0700

  * Follow-ups to configure output reformatting (Tim Wojtulewicz, Corelight)

8.0.0-dev.375 | 2025-06-05 12:43:26 -0700

  * Add busy_timeout script-level option, override any busy_timeout pragma (Tim Wojtulewicz, Corelight)

  * Handle potential contention when running sqlite expiration (Tim Wojtulewicz, Corelight)

  * Add expiration to sqlite-cluster.btest (Tim Wojtulewicz, Corelight)

  * Use unique_ptr to avoid needing to call sqlite3_reset manually (Tim Wojtulewicz, Corelight)

  * Move Deferred class from ZeroMQ to util (Tim Wojtulewicz, Corelight)

  * Temporarily disable pppoe-over-qinq-test for spicy-ssl (Johanna Amann, Corelight)

    The analyzer.log changes exposed a new bug in the Spicy SSL
    implemenataion.

    Relates to GH-4547

8.0.0-dev.367 | 2025-06-05 08:22:25 -0700

  * Silence -Wnontrivial-memcall warning in ConnKey methods (Tim Wojtulewicz, Corelight)

8.0.0-dev.363 | 2025-06-05 07:15:59 +0100

  * dpd.log to analyzer.log changes:

    Logging of failed analyzers has been overhauled. `dpd.log` was replaced by
    a new `analyzer.log` that presents a more unified and consistent view of
    failed analyzers. The previous `analyzer.log` was renamed to
    `analyzer-debug.log`.

    For protocol analyzers, `analyzer.log` now reports initially confirmed
    analyzers that Zeek subsequently removed from the connection due to a
    protocol violation.

    For file and packet analyzers, all errors will be logged to `analyzer.log`.

    As part of this work, a new `analyzer_failed` event has been introduced.
    This event is raised when an analyzer is removed because of raising a
    violation.

    `analyzer.log` was renamed to `analyzer_debug.log`, and is no longer
    created by default. The log file will be created if the
    `frameworks/analyzer/debug-logging.zeek` policy script is loaded.

    The namespace for options in the script changed to
    `Analyzer::DebugLogging`. Furthermore the default options changed to enable
    more detailed output by default.

    The `service_violation` field of the connection record was marked as
    deprecated.  A new `failed_analyzers` field was inroduced instead, with
    slightly different semantics.  Where c$failed_analyzers tracks analyzers
    that were removed due to a violation, c$service_violation tracks violations
    - and doesn't care if an analyzer was actually removed due to it.
    (Johanna Amann, Corelight)

  * Move detect-protocol from frameworks/dpd to frameworks/analyzer

    detect-protocol.zeek was the last non-deprecated script left in
    policy/frameworks/dpd. It was moved to policy/frameworks/analyzer. A
    script that loads the script from the new location with a deprecation
    warning was added. (Johanna Amann, Corelight)

8.0.0-dev.353 | 2025-06-04 09:38:20 -0700

  * Add some notes about missing/disabled cppcoreguildlines clang-tidy checkers (Tim Wojtulewicz, Corelight)

  * Fix clang-tidy cppcoreguidelines-macro-usage findings (macro functions) (Tim Wojtulewicz, Corelight)

  * Fix clang-tidy cppcoreguidelines-macro-usage findings (macros as constants) (Tim Wojtulewicz, Corelight)

  * script_opt: Add missing virtual destructor (cppcoreguidelines-virtual-class-destructor) (Tim Wojtulewicz, Corelight)

  * Parallelize coverage/bare-mode-errors (Johanna Amann, Corelight)

    Currently, coverage/bare-mode-errors is one of the slowest tests in the
    entire test suite. This is caused by the fact that it has to repeatedly
    launch Zeek for every script that we ship. This is done sequentially.

    This commit changes this test to use xargs to spawn 20 parallell
    processes.

8.0.0-dev.346 | 2025-06-04 08:39:54 -0400

  * Fix Spicy re-enable builtin analyzer debug message (Evan Typanski, Corelight)

8.0.0-dev.341 | 2025-06-03 11:54:04 -0700

  * Redis: Add support for sending AUTH commands during connection (Tim Wojtulewicz, Corelight)

  * Redis: disconnect cleanly if INFO request fails (Tim Wojtulewicz, Corelight)

  * Fix segfault if storage sync open_backend returns bad code (Tim Wojtulewicz, Corelight)

  * Add ToStdString and ToStdStringView to ZeekString (Tim Wojtulewicz, Corelight)

8.0.0-dev.335 | 2025-06-02 14:52:44 -0700

  * Update libunistd submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update Windows CI image to Visual Studio 2022 (Tim Wojtulewicz, Corelight)

8.0.0-dev.332 | 2025-06-02 14:31:29 -0700

  * CI: Force rebuild of opensuse tumbleweed docker image (Tim Wojtulewicz, Corelight)

    Something is off with the libhiredis package that's installed
    as part of the current image, and 'zypper patch' is failing to
    update it during the prepare step. Force a rebuild so the
    updated package is part of the image to start with.

8.0.0-dev.330 | 2025-06-02 14:30:41 -0700

  * Bump Spicy to pull in fix. (Robin Sommer, Corelight)

    Includes a new regression test.

    Closes #4501.

8.0.0-dev.328 | 2025-06-02 11:45:03 -0700

  * Bump zeekjs to v0.17.1 (Arne Welzel, Corelight)

        b340648 version: 0.17.1
        ccd32e1 ci/docker: Use Fedora 42, retire Fedora 40
        6893431 Nodejs: Use argv.data() over &argv[0]

8.0.0-dev.326 | 2025-06-02 11:43:56 -0700

  * Fix incorrectly copied comment [skip CI] (Benjamin Bannier, Corelight)

8.0.0-dev.324 | 2025-06-02 17:32:39 +0200

  * Event: Bail on add_missing_remote_network_timestamp without add_network_timestamp (Arne Welzel, Corelight)

  * btest/plugin: Test custom metadata publish (Arne Welzel, Corelight)

    Usage demo for plugin writers to add custom event metadata and access in
    in Zeek scripts.

  * NEWS: Add note about generic event metadata (Arne Welzel, Corelight)

  * cluster: Remove deprecated Event constructor (Arne Welzel, Corelight)

    It is now unused, ditch it. This wasn't available in an LTS release yet
    and anyhow is in the detail namespace.

  * cluster: Remove some explicit timestamp handling (Arne Welzel, Corelight)

    Backend::MakeClusterEvent() for now is the only place to add implicit
    network timestamp metadata within the cluster component.

  * broker/Manager: Fetch and forward all metadata from events (Arne Welzel, Corelight)

    Also use the generic metadata version for publishing, keep the
    ts-based API for now, but only add timestamps when
    EventMetadata::add_network_timestamp is T. I'm not sure what the
    right way forward here is, maybe deprecating Broker's publish event
    variations and funneling through cluster.

  * Event/init-bare: Add add_missing_remote_network_timestamp logic (Arne Welzel, Corelight)

    Make defaulting to the local network timestamp for remote events opt-in.

  * cluster/Backend/DoProcessEvent: Use generic metadata, not just timestamps (Arne Welzel, Corelight)

  * cluster/Event: Support moving args and metadata from event (Arne Welzel, Corelight)

  * cluster/serializer/broker: Support generic metadata (Arne Welzel, Corelight)

    Instead of handling just the network timestamp, support extraction of
    the whole metadata vector that broker events hold.

  * cluster/Event: Generic metadata support (Arne Welzel, Corelight)

    Instead of a timestamp attribute, switch to holding a EventMetadataVectorPtr
    like zeek::Event instances do. Keep the old constructor until the end of
    the patch series.

  * Event: Use -1.0 for undefined/unset timestamps (Arne Welzel, Corelight)

    This can happen if either there's no network timestamp associated with
    an event, or there's currently no event being dispatched. Using 0.0
    isn't great as it's the normal start timestamp before reading a network
    packet. Using -1.0 gives the caller a chance to check and realize what's
    going on.

  * cluster: Use shorter obj_desc versions (Arne Welzel, Corelight)

  * Desc: Add obj_desc() / obj_desc_short() overloads for IntrusivePtr (Arne Welzel, Corelight)

    When using these helpers in code, one barely has raw pointers and the
    repeated `.get()` call cumbersome and noisy.

8.0.0-dev.309 | 2025-06-02 10:17:14 +0200

  * Prefer `std::move` over copy (Benjamin Bannier, Corelight)

8.0.0-dev.307 | 2025-06-02 10:12:14 +0200

  * minor BTest maintenance updates for -O gen-C++ (Vern Paxson, Corelight)

  * fix for more robustly finding BTests to assess for -O gen-C++ (Vern Paxson, Corelight)

  * fix for -O gen-C++ dealing with type constants of unnamed compound types (Vern Paxson, Corelight)

8.0.0-dev.303 | 2025-06-02 09:51:53 +0200

  * intel/seen/manage-event-groups: Policy script for toggling intel event groups (Arne Welzel, Corelight)

    Co-authored-by: Mohan Dhawan <mohan@corelight.com>

  * intel: Add indicator_inserted and indicator_removed hooks (Arne Welzel, Corelight)

    This change adds two new hooks to the Intel framework that can be used
    to intercept added and removed indicators and their type.

    These hooks are fairly low-level. One immediate use-case is to count the
    number of indicators loaded per Intel::Type and enable and disable the
    corresponding event groups of the intel/seen scripts.

    I attempted to gauge the overhead and while it's definitely there, loading
    a file with ~500k DOMAIN entries takes somewhere around ~0.5 seconds hooks
    when populated via the min_data_store store mechanism. While that
    doesn't sound great, it actually takes the manager on my system 2.5
    seconds to serialize and Cluster::publish() the min_data_store alone
    and its doing that serially for every active worker. Mostly to say that
    the bigger overhead in that area on the manager doing redundant work
    per worker.

    Co-authored-by: Mohan Dhawan <mohan@corelight.com>

8.0.0-dev.299 | 2025-05-30 13:06:42 -0700

  * fix for crash when interpreting transformed ASTs that include multi-field record assignments/additions (Vern Paxson, Corelight)

  * Remove unused ZAM compiler method (Vern Paxson, Corelight)

8.0.0-dev.296 | 2025-05-30 12:16:27 -0700

  * Add utility methods to make CMake summary output nicer (Tim Wojtulewicz, Corelight)

8.0.0-dev.294 | 2025-05-30 10:29:29 -0700

  * CI: Add PR label for skipping all CI jobs (Tim Wojtulewicz, Corelight)

  * CI: Add PR label for running cluster tests (Tim Wojtulewicz, Corelight)

8.0.0-dev.291 | 2025-05-30 08:39:28 -0700

  * CI: Add new task to run clang-tidy as part of nightly builds (Tim Wojtulewicz, Corelight)

  * CI: Update to clang 19 on ubuntu 24.04, add clang-tidy package (Tim Wojtulewicz, Corelight)

8.0.0-dev.288 | 2025-05-30 17:24:05 +0200

  * GH-4494: logging/ascii/json: Make TS_MILLIS signed, add TS_MILLIS_UNSIGNED (Arne Welzel, Corelight)

    It seems TS_MILLIS is specifically for Elasticsearch and starting with
    Elasticsearch 8.2 epoch_millis does (again?) support negative epoch_millis,
    so make Zeek produce that by default.

    If this breaks a given deployment, they can switch Zeek back to TS_MILLIS_UNSIGNED.

    https://discuss.elastic.co/t/migration-from-es-6-8-to-7-17-issues-with-negative-date-epoch-timestamp/335259
    https://github.com/elastic/elasticsearch/pull/80208

    Thanks for @timo-mue for reporting!

8.0.0-dev.286 | 2025-05-30 08:12:43 -0700

  * Add move operations for LogWriteHeader (Tim Wojtulewicz, Corelight)

  * Add missing setting of type in session::Key move operations (Tim Wojtulewicz, Corelight)

  * Update .clang-tidy to have performance-* enabled with some exclusions (Tim Wojtulewicz, Corelight)

  * Fix clang-tidy performance-* warnings (Tim Wojtulewicz, Corelight)

8.0.0-dev.271 | 2025-05-30 16:48:43 +0200

  * Update doc submodule [nomail] [skip ci] (Arne Welzel, Corelight)

8.0.0-dev.270 | 2025-05-30 16:44:23 +0200

  * Bump doc submodule for ext/zeek.py modifications (Arne Welzel, Corelight)

  * RecordType:DescribeReST: Render RecordType using zeek:field directive (Arne Welzel, Corelight)

8.0.0-dev.267 | 2025-05-30 11:43:57 +0200

  * IXWebsocket: Bump to version with memset() sock addr fix (Arne Welzel, Corelight)

  * cluster/websocket: Deprecate $listen_host, introduce $listen_addr (Arne Welzel, Corelight)

  * GH-4474: cluster/websocket-ixwebsocket: Determine proper address_family (Arne Welzel, Corelight)

8.0.0-dev.262 | 2025-05-28 08:29:33 -0700

  * Remove obsolete --with-bind configure flag (Tim Wojtulewicz, Corelight)

8.0.0-dev.259 | 2025-05-27 12:49:05 -0700

  * Add a few std::moves to fix Coverity warnings (Tim Wojtulewicz, Corelight)

  * Fix possible memory leak in broker::Manager (Tim Wojtulewicz, Corelight)

  * fixup! Use SCN* constants when reading into sized integer types (Tim Wojtulewicz, Corelight)

  * from_json: Statically lookup err index in result type (Tim Wojtulewicz, Corelight)

  * Use SCN* constants when reading into sized integer types (Tim Wojtulewicz, Corelight)

  * Remove setting unused variable value in FTP::parse_eftp (Tim Wojtulewicz, Corelight)

8.0.0-dev.252 | 2025-05-27 11:59:00 -0700

  * Update .clang-tidy to have bugprone-* enabled with some exclusions (Tim Wojtulewicz, Corelight)

  * Fix clang-tidy bugprone-* warnings (Tim Wojtulewicz, Corelight)

8.0.0-dev.229 | 2025-05-27 17:46:35 +0100

  * Add explicit TLS support for FTP (Johanna Amann, Corelight)

    This is defined in RFC 4217; TLS is initialized by the client sending an
    `AUTH TLS` command.

8.0.0-dev.227 | 2025-05-27 10:18:49 -0400

  * spicy-redis: Separate error replies from success (Evan Typanski, Corelight)

  * spicy-redis: Cleanup scripts and tests (Evan Typanski, Corelight)

    - Recomputes checksums for pcaps to keep clean
    - Removes some tests that had big pcaps or weren't necessary
    - Cleans up scripting names and minor points
    - Comments out Spicy code that causes a build failure now with a TODO to
      uncomment it

  * spciy-redis: Bring Redis analyzer into Zeek proper (Evan Typanski, Corelight)

  * spicy-redis: Abort parsing if server data comes first (Evan Typanski, Corelight)

    Redis seems to only want client data first to request server data. The
    DPD signature seems to pick up on some cases where server data comes
    first, but is otherwise "valid" RESP. See if this helps lower FP rates.

  * spicy-redis: Add recursion depth to server data (Evan Typanski, Corelight)

  * spicy-redis: Make client data only accept bulk strings (Evan Typanski, Corelight)

  * spicy-redis: Add dpd signature and clean pcaps (Evan Typanski, Corelight)

  * spicy-redis: Add some commands and touch up parsing (Evan Typanski, Corelight)

  * spicy-redis: Add some script logic for logging (Evan Typanski, Corelight)

  * spicy-redis: Separate client/server (Evan Typanski, Corelight)

    This makes the parser more official and splits the client/server out
    from each other.

  * spicy-redis: Touchup logging and Spicy issues (Evan Typanski, Corelight)

  * spicy-redis: Add synchronization and pipeline support (Evan Typanski, Corelight)

  * spicy-redis: Begin Spicy Redis analyzer (Evan Typanski, Corelight)

8.0.0-dev.209 | 2025-05-26 16:08:44 +0200

  * btest: Add test for Cluster::hello zero-timestamp (Arne Welzel, Corelight)

  * EventMgr/Enqueue: Add automatic timestamp metadata to local events, only (Arne Welzel, Corelight)

    It seems less surprising if only local events receive automatic network
    timestamp metadata. For remote events the automatic value will most
    likely be misleading.

  * cluster and broker: Propagate zero-timestamp as metadata, too. (Arne Welzel, Corelight)

    This will be cleaned up later to just pass all contained metadata from
    a cluster event to the queued event, but for now do this here, otherwise
    we break some internal tests.

8.0.0-dev.204 | 2025-05-23 12:13:41 -0700

  * Redis: bump version of hiredis required (Tim Wojtulewicz, Corelight)

  * Redis: return proper error if connection fails (Tim Wojtulewicz, Corelight)

8.0.0-dev.201 | 2025-05-23 20:57:54 +0200

  * Add generic event metadata, part 1 (Arne Welzel, Corelight)

    The ``ts`` member of ``Event`` was removed in favor of a more generic
    approach that can hold any event metadata. Further, the Zeek script-layer
    API for registering event metadata types was added.

    Event instances do not network timestamp metadata by default anymore.
    This feature can be re-enabled via EventMetadata::add_network_timestamp=T.

8.0.0-dev.191 | 2025-05-23 08:32:00 -0700

  * Remove FindClangTidy.cmake, update cmake submodule (Tim Wojtulewicz, Corelight)

8.0.0-dev.188 | 2025-05-22 16:54:58 -0700

  * SQLite: Add TODO note about possibly using sqlite3_busy_timeout (Tim Wojtulewicz, Corelight)

  * SQLite: Fix typo in variable name causing pragmas not to retry on busy (Tim Wojtulewicz, Corelight)

  * SQLite: Use tableval iteration instead of ToMap for pragmas (Tim Wojtulewicz, Corelight)

  * SQLite: Fix logging/error messages around executing pragmas (Tim Wojtulewicz, Corelight)

  * Disable sqlite-cluster btest (Tim Wojtulewicz, Corelight)

    This test is being flaky on some platforms and still having problems
    with executing pragmas at startup. Disable it for now until it can be
    fixed.

8.0.0-dev.181 | 2025-05-21 12:47:01 -0700

  * Update baseline of sqlite-basic btest after recent changes (Tim Wojtulewicz, Corelight)

8.0.0-dev.179 | 2025-05-21 09:40:31 -0700

  * SQLite: Move integrity_check to pragma table (Tim Wojtulewicz, Corelight)

  * SQLite: Add backend option for pragma timeout (Tim Wojtulewicz, Corelight)

  * SQLite: Rename tuning_params to pragma_commands, move running pragmas to utility method (Tim Wojtulewicz, Corelight)

  * SQLite: Retry pragma statements at startup to avoid contention (Tim Wojtulewicz, Corelight)

  * SQLite: Check for locked database as well as busy databases (Tim Wojtulewicz, Corelight)

  * SQLite: Fix some string-sizing issues (Tim Wojtulewicz, Corelight)

  * SQLite: Run pragmas on connection before creating table (Tim Wojtulewicz, Corelight)

  * SQLite: Add busy_timeout pragma to default options (Tim Wojtulewicz, Corelight)

  * Prefix sqlite-based btests with sqlite- to match redis tests (Tim Wojtulewicz, Corelight)

  * Add sqlite cluster storage btest (Tim Wojtulewicz, Corelight)

8.0.0-dev.168 | 2025-05-21 13:38:46 +0200

  * http/detect-sql-injection: Fix zeekygen comment (Arne Welzel, Corelight)

        Discarded extraneous Zeekygen comment: $src field; and always provides a victim IP address in the $dst field.

  * btest/coverage/test-all-policy-zeekygen: Load test-all-policy with zeekygen enabled (Arne Welzel, Corelight)

    There should not be warnings produced. The default ZEEK_DISABLE_ZEEKYGEN=1
    setting in the btest configuration hid some issues previously.

8.0.0-dev.164 | 2025-05-20 12:02:09 -0700

  * Add extra input files to ftp fuzzer corpus (Tim Wojtulewicz, Corelight)

  * Use bool instead of int flag in FTP analyzer's parse_eftp method (Tim Wojtulewicz, Corelight)

  * Fix undefined behavior in FTP analyzer's parse_port method (Tim Wojtulewicz, Corelight)

  * Fix invalid-read in FTP analyzer's parse_port method (Tim Wojtulewicz, Corelight)

8.0.0-dev.159 | 2025-05-20 20:30:18 +0200

  * Update cluster-layout.zeek usage in btests (Arne Welzel, Corelight)

  * testing/btest/Files: Add generic broker/cluster-layout.zeek (Arne Welzel, Corelight)

    This is a cluster-layout.zeek template that can be copied into a testing
    directory if needed. The idea is that a developer sets environment
    variables within their btest and the Cluster::nodes variable is
    implicitly extended by appropriate nodes.

    For example, using @TEST-PORT BROKER_LOGGER1_PORT will add an appropriate
    logger-1 node to Cluster::nodes, based on the existence of the
    BROKER_LOGGER1_PORT environment variable.

8.0.0-dev.146 | 2025-05-20 16:25:58 +0200

  * site/local: Switch to detect-sql-injection (Arne Welzel, Corelight)

  * Add a revised script for detecting HTTP SQL injection, deprecate original (Vern Paxson, Corelight)

8.0.0-dev.142 | 2025-05-19 12:32:56 -0700

  * EventTrace: Fix operator==() UBSAN downcast error (Arne Welzel, Corelight)

    New test triggered the following error:

        runtime error: downcast of address 0x57021a323ea0 which does not point to an object of type 'const FileVal' 0x57021a323ea0: note: object is of type 'zeek::FuncVal'

8.0.0-dev.140 | 2025-05-19 11:04:29 -0700

  * Change from_json to return an error rather than print it. (Steve Smoot, Corelight)

8.0.0-dev.136 | 2025-05-19 20:01:30 +0200

  * btest/core: Add event-trace test (Arne Welzel, Corelight)

  * zeek-setup: Free event_trace_mgr after generating trace (Arne Welzel, Corelight)

  * EventTraceMgr: Rename etm to event_trace_mgr (Arne Welzel, Corelight)

  * EventTraceMgr: Move fclose() to destructor (Arne Welzel, Corelight)

  * Update cmake submodule (Tim Wojtulewicz, Corelight)

8.0.0-dev.130 | 2025-05-19 10:25:34 -0700

  * Remove unnecessary #includes across the repo (Tim Wojtulewicz, Corelight)

8.0.0-dev.121 | 2025-05-19 09:43:59 -0700

  * Rename CI-related github labels for PRs (Tim Wojtulewicz, Corelight)

8.0.0-dev.118 | 2025-05-16 10:27:27 -0700

  * Remove including <cinttypes> from util.h (Tim Wojtulewicz, Corelight)

  * Remove telemetry #includes from OpaqueVal.h (Tim Wojtulewicz, Corelight)

  * Reduce includes in plugin/Component.h (Tim Wojtulewicz, Corelight)

  * Remove zeek/Stats.h include from NetVar.h (Tim Wojtulewicz, Corelight)

  * Include StmtBase/StmtEnums in Func.h instead of Stmt.h (Tim Wojtulewicz, Corelight)

    This requires changes in lots of other files that were depending on Func.h
    to provide that include for them.

  * Use modern names for standard headers (Tim Wojtulewicz, Corelight)

  * Remove fix for CentOS 7 from TCP_Flags.h (Tim Wojtulewicz, Corelight)

  * Fix usage of std::string in http analyzer (Tim Wojtulewicz, Corelight)

  * Reorder top section of net_util.h to batch includes together (Tim Wojtulewicz, Corelight)

  * Use quotes instead of <> for zeek includes (Tim Wojtulewicz, Corelight)

  * Fix Obj.h include in IntrusivePtr.h to have full path (Tim Wojtulewicz, Corelight)

8.0.0-dev.106 | 2025-05-16 13:39:56 +0200

  * Generate --event-trace output explicitly rather than in EventTraceMgr destructor (Vern Paxson, Corelight)

8.0.0-dev.104 | 2025-05-15 12:15:42 -0700

  * Require non-system version of libkrb5 on macOS (Tim Wojtulewicz, Corelight)

8.0.0-dev.102 | 2025-05-15 16:44:16 +0200

  * IXWebSocket: Point at upstream, bump to v11.4.6 (Arne Welzel, Corelight)

8.0.0-dev.100 | 2025-05-15 10:21:53 +0100

  * Add STLS command to POP3 DPD signature.

    Pop3 connections that use StartTLS now should be detected on non-default ports.
	  (Jan Grashoefer, Corelight)

8.0.0-dev.96 | 2025-05-13 19:50:47 +0200

  * fix for ZAM optimization when an aggregate is modified inside of a loop (Vern Paxson, Corelight)

8.0.0-dev.94 | 2025-05-13 10:03:46 -0700

  * Allow macOS to search for libkrb5, but disallow system version of library (Tim Wojtulewicz, Corelight)

8.0.0-dev.92 | 2025-05-13 18:26:22 +0200

  * btest/cluster/websocket: Update tests for new event signature (Arne Welzel, Corelight)

  * GH-4440: cluster/websocket: Propagate code and reason to websocket_client_lost() (Arne Welzel, Corelight)

    This allows to get visibility into the reason why ixwebsocket or the
    client decided to disconnect.

  * cluster/websocket: Support configurable ping interval (Arne Welzel, Corelight)

    Primarily for testing purposes and maybe the hard-coded 5 seconds is too
    aggressive for some deployments, so makes sense for it to be
    configurable.

  * GH-4440: IXWebSocket: Bump to improve O^2 rxbuf erase() (Arne Welzel, Corelight)

8.0.0-dev.87 | 2025-05-12 11:33:38 -0700

  * Fix clang-tidy `bugprone-inc-dec-in-conditions` report in Spicy plugins glue compiler (Benjamin Bannier, Corelight)

  * Fix clang-tidy `performance-enum-size` reports in Spicy plugin's glue compiler (Benjamin Bannier, Corelight)

  * Remove unneeded copies in Spicy plugin glue compiler (Benjamin Bannier, Corelight)

  * Adjust for renamed function flavor in Spicy development version (Benjamin Bannier, Corelight)

    With zeek/spicy#2048 the flavor for functions was renamed from
    `Standard` to `Function`. This patch adapts the code for that while
    still allowing using earlier Spicy versions.

8.0.0-dev.82 | 2025-05-09 17:25:38 +0200

  * speed up file analysis, remove IncrementByteCount (Justin Azoff)

    Avoid creating and recreating count objects for each chunk of file
    analyzed.  This replaces counts inside of records with c++ uint64_ts.

8.0.0-dev.80 | 2025-05-09 09:51:48 +0200

  * Updating submodules binpac, broker and zeek-aux [nomail] (Arne Welzel, Corelight)

8.0.0-dev.78 | 2025-05-08 15:14:25 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

8.0.0-dev.76 | 2025-05-08 15:07:09 -0700

  * Bugfix: accurately track Broker buffer overflows w/ multiple peerings (Christian Kreibich, Corelight)

8.0.0-dev.74 | 2025-05-08 13:46:54 -0700

  * Downgrade broker clone FatalError to an Error (Tim Wojtulewicz, Corelight)

8.0.0-dev.72 | 2025-05-08 13:18:52 +0200

  * probabilistic/BitVector: Add include <cstdint> (Arne Welzel, Corelight)

  * Bump spicy to fix build with GCC 15.1 (Arne Welzel, Corelight)

  * CI: Drop fedora-40 (Arne Welzel, Corelight)

  * CI: Add fedora-42 (Arne Welzel, Corelight)

8.0.0-dev.67 | 2025-05-08 09:25:19 +0200

  * Include cstdint header to support uint8_t/uint64_t in GCC 15+ (i2z1)

8.0.0-dev.64 | 2025-05-07 15:39:17 -0700

  * Move options to redis backend options instead of module-level options (Tim Wojtulewicz, Corelight)

  * Add operation_timeout and command_timeout storage backend options (Tim Wojtulewicz, Corelight)

8.0.0-dev.61 | 2025-05-07 14:09:42 -0700

  * Fix Broker metrics naming bugs that snuck in w/ last-minute renaming [skip ci] (Christian Kreibich, Corelight)

8.0.0-dev.59 | 2025-05-07 10:29:37 -0700

  * Fix policy/protocols/conn/failed-service-logging.zeek (Johanna Amann, Corelight)

    In GH-4422 it was pointed out that the protocols/conn/failed-service-logging.zeek
    policy script only works when
    `DPD::track_removed_services_in_connection=T` is set.

    This was caused by a logic error in the script. This commit fixes this
    logic error and introduces an additional test that checks that
    failed-service-logging works even when the option is not set to true.

  * Update opt.ZAM-bif-tracking baseline (Tim Wojtulewicz, Corelight)

8.0.0-dev.56 | 2025-05-07 17:23:54 +0200

  * btest/cluster/generic/publish-any: Apply Christian's fix from broker/publish-any (Arne Welzel, Corelight)

  * wstest/terminate-while-queueing: Patch close_socket() (Arne Welzel, Corelight)

    I believe there's a bug/usage issue in the websockets library
    where during send(), EOF is detected and stored, but the receiving
    thread is then discarding the last received frame. Avoid the bug
    by replacing the close_socket() implementation of the websockets
    library just for that test and leave detecting the EOF condition
    to the receiving thread.

8.0.0-dev.53 | 2025-05-07 08:16:46 -0700

  * Add Storage::is_connected BIF (Tim Wojtulewicz, Corelight)

  * Move cast_handle from storage-async.bif to BackendHandleVal static method (Tim Wojtulewicz, Corelight)

8.0.0-dev.50 | 2025-05-07 13:21:39 +0200

  * cluster/websocket: Stop and wait for reply thread during Terminate() (Arne Welzel, Corelight)

    The terminate-while-queueing test added for #4428 failed spuriously
    indicating that sometimes WebSocket clients receive code 1000 instead of 1001.
    This happens if the ixwebsocket server is shutdown before the reply thread had a
    chance to process queued close messages.

    Fix by signaling and waiting for the dispatcher's reply thread to terminate
    before returning from Terminate().

8.0.0-dev.46 | 2025-05-06 14:20:54 +0200

  * testing/btest: Fix double commented @TEST- lines (Arne Welzel, Corelight)

        sed -i 's/^# # @/# @/g'

8.0.0-dev.44 | 2025-05-06 14:20:22 +0200

  * GH-4420: Websocket: Close onloop during Terminate() (Arne Welzel, Corelight)

    Terminate() is called when Zeek shuts down. If WebSocket client threads
    were blocked in QueueForProcessing() due to reaching queue limits, these
    previously would not exit QueueForProcessing() and instead block
    indefinitely, resulting in the ixwebsocket library blocking and its
    garbage collection thread running at 100%. Not great.

    Closing the onloop instance will unblock the WebSocket client threads
    for a timely shutdown.

    Closes #4420

  * OnLoop: notify_all() instead of notify_one() (Arne Welzel, Corelight)

    There might be more than one thread blocked waiting for room in the
    queue, ensure they all wake up when shutting down.

8.0.0-dev.40 | 2025-05-05 13:40:20 -0700

  * Add baseline for find_first test, update comments, and reorder function imports (yexiaochuan)

  * Add find_first string function (yexiaochuan)

8.0.0-dev.37 | 2025-05-05 11:11:57 -0700

  * Add commands to the static methods for the Redis implementation (Tim Wojtulewicz, Corelight)

  * Redis: Check server version when connecting (Tim Wojtulewicz, Corelight)

8.0.0-dev.34 | 2025-05-05 10:44:27 -0700

  * Use std::string_view in Redis::DoExpire to avoid copies (Tim Wojtulewicz, Corelight)

8.0.0-dev.32 | 2025-05-05 14:40:11 +0200

  * QUIC: Extract reset_crypto() function (Arne Welzel, Corelight)

  * QUIC: Rename ConnectionIDInfo to Context (Arne Welzel, Corelight)

    Lets just call it what it is given that it contains more than just
    connection IDs.

  * QUIC: Switch initial_destination_conn_id to optional (Arne Welzel, Corelight)

  * QUIC: Use initial destination conn_id for decryption (Arne Welzel, Corelight)

    Ensure the client side also uses the initial destination connection ID
    for decryption purposes instead of the one from the current long header
    packet. PCAP from local WiFi hotspot.

  * QUIC: Handle CRYPTO frames across multiple INITIAL packets (Arne Welzel, Corelight)

    Instead of sending the accumulated CRYPTO frames after processing an
    INITIAL packet, add logic to determine the total length of the TLS
    Client or Server Hello (by peeking into the first 4 byte). Once all
    CRYPTO frames have arrived, flush the reassembled data to the TLS
    analyzer at once.

  * QUIC: Do not consume EncryptedLongPacketPayload (Arne Welzel, Corelight)

    The payload is already consumed within the InitialPacket unit. Consuming
    it again resulted in UDP datagrams with multiple packets to ignore
    the remaining packets in the same UDP datagram. The baseline changes
    showing I being followed by a new H indicates that the INITIAL packet
    was followed by a HANDSHAKE packet, but previously Zeek discarded
    these.

  * QUIC: Fix ACK frame parsing (Arne Welzel, Corelight)

8.0.0-dev.22 | 2025-04-30 17:56:03 +0200

  * Add a new HookPublishEvent() plugin hook (Arne Welzel, Corelight)

    This hook can be implemented and enabled by plugins in order to
    intercept Cluster::publish() calls.

8.0.0-dev.17 | 2025-04-30 17:23:06 +0200

  * ZAM-bif-tracking: Remove ZeroMQ dependency (Arne Welzel, Corelight)

8.0.0-dev.15 | 2025-04-29 17:50:31 -0700

  * fixed incorrect ZAM optimization of expressions seen in single-statement inlined functions (Vern Paxson, Corelight)

8.0.0-dev.13 | 2025-04-29 08:52:55 -0700

  * External tests: add removed logs to CT list to prevent baseline changes (Johanna Amann, Corelight)

  * Update Mozilla CA list and CT list to NSS 3.110 (Tim Wojtulewicz, Corelight)

8.0.0-dev.10 | 2025-04-29 15:00:44 +0200

  * coalesce smtp handlers for ADDR (Mohan Dhawan, Corelight)

  * Add fine-grained groups for Intel events (Mohan Dhawan, Corelight)

8.0.0-dev.7 | 2025-04-28 19:41:01 +0200

  * broker/WebSocketShim: Check RegisterFd() return (Arne Welzel, Corelight)

  * cluster/OnLoop: Fix coverity report about proc accessed without lock (Arne Welzel, Corelight)

    Coverity complains proc is set under a lock, but accessed in Process()
    without a lock. Fix this by setting it in Close() also without locking.
    The proc member should only ever be accessed my the main thread.

8.0.0-dev.4 | 2025-04-28 18:24:09 +0200

  * GH-3045: broker/Data/data_to_val: Fail on vectors/lists with holes (Arne Welzel, Corelight)

    Instead of simply removing holes from vectors or lists when converting
    from Val to Broker format, error out as the receiver has no chance to
    reconstruct where the hole might have been.

    We could encode holes with broker::none, but this will put unnecessary
    burden on language bindings and users due to the potential optionality.
    Think a std::vector<uint64_t> that technically needs to be a
    std::vector<std::optional<uint64_t>> to represent optional elements
    properly.

    Closes #3045

8.0.0-dev.2 | 2025-04-25 16:11:36 -0700

  * Fix use-after-move in recent broker changes (Tim Wojtulewicz, Corelight)

  * Start of 8.0.0 development (Tim Wojtulewicz, Corelight)

7.2.0-dev.659 | 2025-04-25 10:33:32 -0700

  * Ignore case when matching prefix in http analyzer (Kshitiz Bartariya)

7.2.0-dev.657 | 2025-04-25 10:25:01 -0700

  * Updates for the various Broker changes (Christian Kreibich, Corelight)

  * Add versions of bundled dependencies (Tim Wojtulewicz, Corelight)

  * Lower listen/connect retry intervals in Broker and the cluster framework to 1sec (Christian Kreibich, Corelight)

    The former defaults (30sec, 1min) can slow down cluster startup and recovery
    considerably, and other systems have more aggressive intervals still.

  * Bump cluster testsuite (Christian Kreibich, Corelight)

    This pulls in an update for the backpressure disconnect tests, which now need to
    set the policy explicitly.

  * Switch Broker's default backpressure policy to drop_oldest, bump buffer sizes (Christian Kreibich, Corelight)

    At every site where we've dug into backpressure disconnect findings, it has been
    the case that the default values were too small. 8192, so 4x the old default,
    suffices at every site to drown out premature disconnects.

    With metrics now available for the send buffers regardless of backpressure
    overflow policy, this also switches the default from "disconnect" to
    "drop_oldest" (for both peers and websockets), meaning that peerings remain
    untouched but the oldest queued message simply gets dropped when a new message
    is enqueued. With this policy, the number of backpressure overflows is then
    simply the count of discarded messages, something that users can tune to see
    drop to zero in everyday use.  Another benefit is that marginal overflows cause
    less message loss than when an entire buffer's worth (plus potentially more
    in-flight messages) gets thrown out with a disconnect.

  * Deprecate Broker::congestion_queue_size and stop using it internally (Christian Kreibich, Corelight)

    Since a reorg in the Broker library (commit b04195183) that revamped flow
    control and that we pulled in with Zeek 5.0, this setting hasn't done
    anything. Broker's endpoint::make_subscriber() and
    endpoint::make_status_subscriber() take a queue size argument (with a default
    value) that simply gets dropped in the eventual subscriber::make() call. See:

    https://github.com/zeek/broker/commit/b04195183515a1db8eb493011a744ba787239e98#diff-5c0d2baa7981caeb6a4080708ddca6ad929746d10c73d66598e46d7c2c03c8deL34-R178

7.2.0-dev.649 | 2025-04-25 10:23:30 -0700

  * Lower listen/connect retry intervals in Broker and the cluster framework to 1sec (Christian Kreibich, Corelight)

  * Bump cluster testsuite (Christian Kreibich, Corelight)

  * Switch Broker's default backpressure policy to drop_oldest, bump buffer sizes (Christian Kreibich, Corelight)

  * Deprecate Broker::congestion_queue_size and stop using it internally (Christian Kreibich, Corelight)

7.2.0-dev.644 | 2025-04-25 10:02:58 -0700

  * Add basic btest to verify that Broker peering telemetry is available. (Christian Kreibich, Corelight)

  * Add cluster framework telemetry for Broker's send-buffer use (Christian Kreibich, Corelight)

    See NEWS or scripts/base/frameworks/cluster/broker-telemetry.zeek for details.

  * Add peer buffer update tracking to the Broker manager's event_observer (Christian Kreibich, Corelight)

  * Rename the Broker manager's LoggerAdapter (Christian Kreibich, Corelight)

  * Avoid race in the cluster/broker/publish-any btest (Christian Kreibich, Corelight)

7.2.0-dev.638 | 2025-04-25 06:41:06 -0700

  * Skip linting on highwayhash and src/3rdparty files (Tim Wojtulewicz, Corelight)

7.2.0-dev.636 | 2025-04-25 06:40:46 -0700

  * Minor changes to storage framework script docs (Tim Wojtulewicz, Corelight)

7.2.0-dev.634 | 2025-04-25 08:40:29 -0400

  * Bump Spicy (Evan Typanski, Corelight)

7.2.0-dev.632 | 2025-04-25 12:03:44 +0200

  * btest/cluster/websocket: Move no-subscriptions test (Arne Welzel, Corelight)

    ...and also add one for broker.

  * cluster/websocket: Leverage ReadyToPublishCallback() (Arne Welzel, Corelight)

    Change WebSocket client handling to return only when the ready to
    publish callback has been invoked.

  * cluster/zeromq: Implement DoReadyToPublishCallback() (Arne Welzel, Corelight)

    The ZeroMQ heuristic for "ready to publish" is to create an unique and
    ephemeral subscription using the XSUB socket and observe it arrive on the
    XPUB socket. At this point, visibility into other node's subscriptions
    is provided.

  * cluster/Backend: Add ReadyToPublishCallback() API (Arne Welzel, Corelight)

    Provide a mechanism to allow a cluster backend report when it is ready
    for publish operations. This is primarily useful for ZeroMQ which has
    sender-side filtering and is only really ready for publishing when it
    has learned about subscriptions from other nodes.

7.2.0-dev.627 | 2025-04-25 09:03:01 +0200

  * broker/WebSocketShim/tests: Comment out two endpoint tests (Arne Welzel, Corelight)

    Running the remote tests on a loaded system results in timeouts, even
    after bumping the tiemouts to 10 seconds. Comment them out for now.

  * broker/WebSocketShim/tests: Replace hard-coded timeout values with vars (Arne Welzel, Corelight)

7.2.0-dev.624 | 2025-04-24 14:03:52 +0200

  * cluster/websocket: Raise websocket_client_lost() after terminate (Arne Welzel, Corelight)

    Just in case events are created during backend->Terminate(). These
    should come before the Cluster::websocket_client_lost() event.

  * cluster/ThreadedBackend: Invoke onloop->Process() during DoTerminate() (Arne Welzel, Corelight)

    Also, document how to use ThreadedBackend's DoTerminate()

  * cluster/ThreadedBackend: Remove Process() (Arne Welzel, Corelight)

    This must have been left-over from before OnLoopProcess existed. It
    wasn't called or used anymore.

  * zeromq: Call super class DoTerminate() after stopping thread (Arne Welzel, Corelight)

    The internal ZeroMQ thread would call QueueForProcessing() thereby
    accessing the onloop member. As ThreadedBackend::DoTerminate() unsets it,
    this was a) reported as a data race by TSAN and b) potentially caused
    missed events that were still to be queued.

7.2.0-dev.617 | 2025-04-24 08:17:08 +0200

  * cluster/websocket: Short-circuit clients without subscriptions (Arne Welzel, Corelight)

  * cluster/websocket: Factor out active subscription handling (Arne Welzel, Corelight)

7.2.0-dev.613 | 2025-04-23 12:14:48 -0700

  * Statically lookup field offsets for connection values in UDP and ICMP analyzers (Tim Wojtulewicz, Corelight)

  * Skip calling islower before toupper (Tim Wojtulewicz, Corelight)

7.2.0-dev.608 | 2025-04-23 17:18:20 +0200

  * COPYING-3rdparty: Add some missing submodules [skip ci] (Arne Welzel, Corelight)

  * Bump Spicy. (Robin Sommer, Corelight)

7.2.0-dev.604 | 2025-04-23 08:08:00 -0700

  * Fix crash related to Broker stores (Dominik Charousset, Corelight)

7.2.0-dev.602 | 2025-04-23 15:55:46 +0200

  * cluster/cluster.bif: Fix CountVal casted to PortVal (Arne Welzel, Corelight)

    Thanks UBSAN!

7.2.0-dev.600 | 2025-04-23 15:07:47 +0200

  * CI: No more Ubuntu 20.04 [skip ci] (Arne Welzel, Corelight)

    Ubuntu 20.04's default Python doesn't deal well with the type annotations
    used in btest/Files/wstest.py. Given that it's about to be EOL, just remove it.

7.2.0-dev.598 | 2025-04-23 14:28:15 +0200

  * Add NEWS entry for WebSocket functionality (Arne Welzel, Corelight)

  * btest/cluster: Add broker logging test for sanity (Arne Welzel, Corelight)

    Not very related to the PR, but created to help provoke an issue
    with the broker changes.

  * broker/WebSocketShim: Add tests for endpoint, hubs and subscribers (Arne Welzel, Corelight)

    These are really testing broker functionality, mostly added to ensure
    the behavior is as expected by the WebSocketShim functionality.

  * broker: Deprecate NodeID(), use SetNodeId() (Arne Welzel, Corelight)

  * cluster/Backend: Do not inline Init() (Arne Welzel, Corelight)

  * cluster: Add Backend::SetNodeId() (Arne Welzel, Corelight)

  * cluster/websocket: Make websocket dispatcher queue size configurable (Arne Welzel, Corelight)

    Limit the number WebSocket events queued from external clients to
    dispatcher instances to produce back pressure to the clients if
    Zeek's IO loop is overloaded.

  * cluster/zeromq: Attempt publish during termination (Arne Welzel, Corelight)

    Explicitly notify the internal thread about the shutdown via the
    inproc socket pair. This ensures that the internal thread processes
    all previous messages on the inproc socket before terminating.

    This fixes the scenario where a backend is created, a few messages published
    and then immediately terminated as can be done with WebSocket clients.
    Previously, some of the messages published might have still been in the
    inproc socket's queue and were simply discarded.

    Adds the same test for Broker and ZeroMQ backends.

  * broker/main: Reference Cluster::publish() for auto_publish() deprecation (Arne Welzel, Corelight)

    In hindsight, this is the better thing to do and with Zeek 7.2 we should
    be confident enough that it'll work.

  * broker/main: Deprecate Broker::listen_websocket() (Arne Welzel, Corelight)

    Optimistically deprecate Broker::listen_websocket() and promote
    Cluster::listen_websocket() instead.

  * cluster/websocket: Remove comment about broker (Arne Welzel, Corelight)

  * btest/cluster/websocket: Add tests using broker (Arne Welzel, Corelight)

    Add tests to verify Cluster::listen_websocket() with the Broker backend
    is functional.

  * btest/cluster/websocket: Move ZeroMQ test and use wstest.py (Arne Welzel, Corelight)

    Adapt the test to be the same as Broker, to have "expected" behavior.

  * btest/files: Introduce wstest.py (Arne Welzel, Corelight)

    This adds a minimal helper library for reusing some of the code to
    test WebSocket client access to Zeek using Python.

  * cluster/websocket: Special case broker backend for shim usage (Arne Welzel, Corelight)

    When Cluster::backend is configured with CLUSTER_BACKEND_BROKER, switch
    WebSocketClients to CLUSTER_BACKEND_BROKER_WEBSOCKET_SHIM instead.

    Instead of the special case, we could also add something to Backend
    called NewWebSocketBackend(), but if it only affects broker, I think
    the special case is okay for now.

  * broker: Add WebSocketShim backend (Arne Welzel, Corelight)

    This adds a cluster backend implementation using broker's hub primitive
    to connect WebSocket clients with the local broker endpoint for pub/sub
    functionality.

  * broker/Manager: Add MakeHub() and ReleaseHub() (Arne Welzel, Corelight)

    These are used by WebSocket clients to create broker::hub instances

  * Bump broker submodule (Arne Welzel, Corelight)

  * cluster/Backend: Add ProcessError() (Arne Welzel, Corelight)

    Allow backends to pass errors to a strategy. Locally, these raise
    Cluster::Backend::error() events that are logged to the reporter
    as errors.

  * cluster/Backend: Rename EnqueueLocalEvent() to ProcessLocalEvent() (Arne Welzel, Corelight)

  * cluster/Backend: Rename HandleRemoteEvent() to ProcessEvent() (Arne Welzel, Corelight)

    ...also add Backend::ProcessEvent() for backends to trigger event
    processing without needing to use ProcessEventMessage().

  * cluster/websocket: Fix websocket_client_added id value (Arne Welzel, Corelight)

  * broker: Include log event identifier in stderr output (Arne Welzel, Corelight)

  * cluster/websocket: Debug output fixes (Arne Welzel, Corelight)

  * Update zeek-aux submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.2.0-dev.571 | 2025-04-22 08:44:28 -0700

  * Update c-ares to v1.34.5 and vcpkg to a version that includes it (Tim Wojtulewicz, Corelight)

7.2.0-dev.569 | 2025-04-21 17:14:44 -0700

  * Use Broker peering directionality when re-peering after backpressure overflows (Christian Kreibich, Corelight)

  * Expand Broker APIs to allow tracking directionality of peering establishment (Christian Kreibich, Corelight)

7.2.0-dev.565 | 2025-04-18 11:36:17 -0700

  * Use longer path when including krb5.h to match the cmake lookup (Tim Wojtulewicz, Corelight)

  * Update cmake submodule for krb5 fixes [nomail] (Tim Wojtulewicz, Corelight)

7.2.0-dev.562 | 2025-04-17 17:48:45 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.2.0-dev.560 | 2025-04-17 09:28:50 -0700

  * Update src/3rdparty submodule to disable clang-format (Tim Wojtulewicz, Corelight)

  * Disable linting for files generated by bison (Tim Wojtulewicz, Corelight)

    These files will report lots of findings in the code that we have no
    control over.

  * Make sure clang-tidy and iwyu are added to all targets (Tim Wojtulewicz, Corelight)

7.2.0-dev.556 | 2025-04-17 08:59:11 -0700

  * Add libnode-dev to docs github runner, update docs to include ZeekJS (Tim Wojtulewicz, Corelight)

7.2.0-dev.554 | 2025-04-17 16:56:34 +0200

  * pre-commit: Ensure testing files have @TEST lines commented (Arne Welzel, Corelight)

  * testing/btest/*js: Comment all @TEST lines (Arne Welzel, Corelight)

  * testing/btest/*test: Comment all @TEST lines (Arne Welzel, Corelight)

  * testing/btest/*evt: Comment all @TEST lines (Arne Welzel, Corelight)

  * testing/btest/*zeek: Comment all @TEST lines (Arne Welzel, Corelight)

7.2.0-dev.548 | 2025-04-17 15:20:27 +0200

  * Remove finish_run() (Jan Grashoefer, Corelight)

  * Deprecate session manager's Done() (Jan Grashoefer, Corelight)

  * Clear sessions when session manager is done (Jan Grashoefer, Corelight)

    It looks like there is no reason to keep sessions in the map beyond the
    point where the session manager is considered done. This hopefully
    simplifies the shutdown control flow a tiny bit.

7.2.0-dev.544 | 2025-04-16 15:40:52 -0700

  * Suppress warnings from compilation of external ixwebsocket dependency (Benjamin Bannier, Corelight)

    Clang warns about declared but unused parameters somewhere in the guts of
    IXWebSocket (internal code, not its headers). We are not interested in
    this or similar warnings since we do not control this code, so suppress
    all warnings for this target.

7.2.0-dev.541 | 2025-04-16 09:34:09 +0200

  * ldap: Clean up from code review (Arne Welzel, Corelight)

  * ldap: Add Sicily Authentication constants (Arne Welzel, Corelight)

  * GH-4275: ldap: Only switch into MS_KRB5 mode if responseToken exists (Arne Welzel, Corelight)

7.2.0-dev.536 | 2025-04-15 18:31:28 +0200

  * IXWebSocket: Bump to latest upstream master (Arne Welzel, Corelight)

    The PR for the threading issue was merged. Still keeping the submodule
    to point at our own fork as I have a hunch there might be more.

7.2.0-dev.534 | 2025-04-15 08:57:48 -0700

  * CI: Add krb5 to FreeBSD (Tim Wojtulewicz, Corelight)

  * Switch libkrb5 check to exclude only Darwin (Tim Wojtulewicz, Corelight)

7.2.0-dev.530 | 2025-04-14 10:11:59 -0700

  * Add STORAGE_ prefixes for backends and serializers (Tim Wojtulewicz, Corelight)

  * Add versioning to JSON serializer (Tim Wojtulewicz, Corelight)

  * Remove unnecessary includes in Val.h (Tim Wojtulewicz, Corelight)

  * Move byte_buffer types from cluster and storage into util (Tim Wojtulewicz, Corelight)

  * Remove unnecessary <array> and <memory> includes from util.h (Tim Wojtulewicz, Corelight)

  * Mark storage classes as final where appropriate (Tim Wojtulewicz, Corelight)

  * Add JSON storage serializer, use with existing backends/tests (Tim Wojtulewicz, Corelight)

  * Make ValFromJSON return zeek::expected instead of a variant (Tim Wojtulewicz, Corelight)

  * Ground work for pluggable storage serializers (Tim Wojtulewicz, Corelight)

7.2.0-dev.520 | 2025-04-14 18:58:55 +0200

  * Bump zeekjs to v0.17.0 (Arne Welzel, Corelight)

  * Update bifcl submodule [nomail] (Tim Wojtulewicz, Corelight)

7.2.0-dev.517 | 2025-04-13 17:11:40 +0200

  * cluster/Backend: Add name and lookup component tag (Arne Welzel, Corelight)

    This adds two new accessors on Backend, Name() and Tag() that can
    be used for introspection of a Backend instance.

  * cluster/Event: Hide members behind accessors (Arne Welzel, Corelight)

  * cluster/PublishEvent:: Make event non-const (Arne Welzel, Corelight)

    We want to introduce a hook that can modify the cluster event instances, so
    need to pass around a non-const version of it.

  * broker/Manager: Re-use broker serializer for conversion (Arne Welzel, Corelight)

  * EventMgr: Add Dispatch() with handler and args (Arne Welzel, Corelight)

    Allow users to call event_mgr.Dispatch(handler, args) instead of
    constructing the Event instance themselves. Deprecate the old API
    and replace users.

    There's a subtle change that net_done() may be propagated via
    auto_publish() now, but that still needs opt-in from script land
    and likely no one did that, or else they'd expected to have it
    work anyhow.

  * plugin/Manager: Fix MetaHookPre and MetaHookPost using HOOK_CALL_FUNCTION (Arne Welzel, Corelight)

7.2.0-dev.510 | 2025-04-11 15:16:53 +0200

  * Prevent event timestamps set to future (Jan Grashoefer, Corelight)

    For scheduled events, the event timestamp is the intended timestamp. If
    we force timer expiration, the timestamp might be in the future. Today,
    this happens on shutdown. This change guarantees that event timestamps
    are never set beyond network time.

7.2.0-dev.508 | 2025-04-11 12:59:53 +0200

  * GH-4301: Fix `--with-spicy`. (Robin Sommer, Corelight)

  * GH-3522: Spicy: Document lifetime semantics of Zeek analyzers created from Spicy. (Robin Sommer, Corelight)

  * Bump Spicy. (Robin Sommer, Corelight)

7.2.0-dev.503 | 2025-04-10 15:47:27 +0200

  * btest/files/x509/files: Sort analyzers in baseline (Arne Welzel, Corelight)

7.2.0-dev.501 | 2025-04-09 11:11:57 -0700

  * Revert addition of std::unreachable (Tim Wojtulewicz, Corelight)

    After further testing with the fuzzer corpus, std::unreachable isn't
    necessary here. It's fine to just let the default case break to fix
    the Coverity warning.

7.2.0-dev.499 | 2025-04-09 18:11:08 +0200

  * btest/brokerstore-attr-persistence-clone: Add BTEST_BG_RUN_SLEEP=1 (Arne Welzel, Corelight)

7.2.0-dev.497 | 2025-04-08 11:30:53 -0700

  * Add move assignment operator to ZeekString, which already had a move constructor (Tim Wojtulewicz, Corelight)

  * Don't initialize telemetry listener at all if ZEEKCTL_CHECK_CONFIG is set (Tim Wojtulewicz, Corelight)

  * Avoid extra temporary strings in concatenation (Tim Wojtulewicz, Corelight)

  * Use const auto references to avoid some copies (Tim Wojtulewicz, Corelight)

  * Clean up initialization of TunnelEncapsulation to use default member values (Tim Wojtulewicz, Corelight)

  * Remove some unnecessary std::move calls in broker::Manager (Tim Wojtulewicz, Corelight)

  * Avoid divide-by-zero in CardinalityCounter::Size (Tim Wojtulewicz, Corelight)

  * Minor fixes in POP3 analyzer based on flycheck warnings (Tim Wojtulewicz, Corelight)

    This also adds an implementation of unreachable() to use for default
    cases where it shouldn't ever actually cause the default.

  * More std::move changes based on Coverity findings (Tim Wojtulewicz, Corelight)

  * Fix a potential memory leak in Debug function (Tim Wojtulewicz, Corelight)

7.2.0-dev.486 | 2025-04-08 11:00:46 -0700

  * Bump pre-commit hooks (Benjamin Bannier, Corelight)

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.2.0-dev.482 | 2025-04-08 10:59:15 -0700

  * Make SNAP analyzer use both OUI and protocol for forwarding (Tim Wojtulewicz, Corelight)

  * Change packet analyzer identifiers to be 64-bit (Tim Wojtulewicz, Corelight)

7.2.0-dev.478 | 2025-04-04 18:36:37 +0200

  * broker/main: Adapt enum values to agree with comm.bif (Arne Welzel, Corelight)

    Logic to detect this error already existed, but due to enum identifiers
    not having a value set, it never triggered before.

  * btest/plugin: Add plugin testing enum identifiers (Arne Welzel, Corelight)

    This plugin has a generic name, but for now just tests the API around
    enum types and enum vals at InitPostScript() time.

  * Var/add_type: Do not clone EnumType when declared for the first time (Arne Welzel, Corelight)

    EnumType receives the name into its constructor. Even for the  first declaration
    the name is not empty and instead the same as the identifier's name. Due to that,
    add_type() previously took the else path and created a shallow clone of the
    initial type instead of using it. This lead to buggy behavior where enum value
    identifiers declared within an enum's first body have a different TypePtr
    associated than the one that is found via `zeek::id::find_type()`. It also
    means that enum identifiers added via redef later would have a different
    TypePtr than those in the initial pointer.

  * type/id/zeekygen: Add EnumVal to enum identifiers (Arne Welzel, Corelight)

    Provide a direct way to go from a zeek:id::ID value to EnumVal without
    needing to go through the type.

7.2.0-dev.473 | 2025-04-03 13:10:43 +0200

  * GH-4323: Traverse: Do not short-circuit traverse_all() if stmts is nullptr (Arne Welzel, Corelight)

    Since commit 0a813a53c7a5326d91fc5aa979429d04972d664b,
    zeek::detail::stmts is set to a nullptr when before it was usually
    an empty list of statements. This caused traverse_all() to be
    short-circuited unless global statements were available.

7.2.0-dev.471 | 2025-04-03 10:53:00 +0100

  * Remove unnecessary check for bind library. (Johanna Amann, Corelight)

    This has not been required since we switched to c-ares and breaks builds
    on Fedora Rawhide.

7.2.0-dev.469 | 2025-04-02 16:36:00 -0700

  * Some minor c++ modernization in EnumType methods (Tim Wojtulewicz, Corelight)

  * Avoid O(n) search in EnumType::Lookup (Tim Wojtulewicz, Corelight)

7.2.0-dev.466 | 2025-04-02 18:49:50 +0200

  * Spicy: Rework code for converting Spicy values to Zeek values. (Robin Sommer, Corelight)

    The logic was template-based so far, which wasn't great because: (1)
    conceptually, it models the Spicy types at the wrong layer (C++ rather
    than HILTI types), and (2) stopped working with some recent Spicy
    updates (which we have temporarily reverted in the meantime to keep
    Zeek working).

    The new code is based on HILTI's runtime type information and the
    corresponding introspection API, pretty much like `spicy-dump` works
    as well. This is the recommended approach for working with HILTI
    values, and generally much cleaner.

7.2.0-dev.464 | 2025-04-02 14:52:44 +0200

  * Spicy: Port over to Spicy's new tuple representation. (Robin Sommer, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.2.0-dev.461 | 2025-04-01 12:58:19 -0700

  * Add comment annotation to disable copying redef value into docs (Tim Wojtulewicz, Corelight)

7.2.0-dev.458 | 2025-03-31 18:59:11 +0200

  * CI: Upgrade zeekctl task to Debian 12 (Arne Welzel, Corelight)

  * GH-3535: CI: Add external plugins to builtin plugins task (Arne Welzel, Corelight)

    This clones a few external plugins to include them in a build. Except
    for zeek-kafka, the others are maintained by the Zeek project.

7.2.0-dev.454 | 2025-03-31 18:44:59 +0200

  * Hook into Broker logs via its new API (Dominik Charousset)

    The new Broker API allows us to provide a custom logger to Broker that
    pulls previously unattainable context information out of Broker to put
    them into broker.log for users of Zeek.

    Since Broker log events happen asynchronously, we cache them in a queue
    and use a flare to notify Zeek of activity. Furthermore, the Broker
    manager now implements the `ProcessFd` function to avoid unnecessary
    polling of the new log queue. As a side effect, data stores are polled
    less as well.

7.2.0-dev.451 | 2025-03-31 09:37:02 -0700

  * GH-3526: Add "U" to QUIC history docstrings and expand version string docs (Christian Kreibich, Corelight)

7.2.0-dev.449 | 2025-03-31 15:08:05 +0200

  * Use one-based index in warning message (Benjamin Bannier, Corelight)

    This was surfacing a zero-based counter to users which was confusing.

7.2.0-dev.447 | 2025-03-31 14:21:51 +0200

  * Event/EventMgr: protected to private (Arne Welzel, Corelight)

    These classes are final, so deriving isn't possible. No reason to have
    protected members.

  * EventHandler: Deprecate Call(args, no_remote, ts), add Call(args) (Arne Welzel, Corelight)

    The ts parameter was only added to Call() for the Broker::auto_publish()
    functionality and propagating the network timestamp. By now, the auto-publish
    functionality is deprecated, so it'd be good to cleanup that signature. There
    won't be any need for no_remote in the future either.

    Allow users to just use Call() instead.

  * EventHandler: Header cleanup (Arne Welzel, Corelight)

  * EventMgr: Do not cache current event attributes (Arne Welzel, Corelight)

    Avoid proliferation of various members on EventMgr by storing the
    pointer of the current event instead.

    This subtly changes the behavior of some builtin functions as they would
    have returned the prior event's data when executed outside of event
    draining (e.g. C++ level hook invocations), but I think that's actually
    for the better.

  * EventMgr: Drop src_val (Arne Welzel, Corelight)

    This is a left over and hasn't been used since a while.

  * Event: Header cleanup (Arne Welzel, Corelight)

7.2.0-dev.439 | 2025-03-27 16:12:44 -0700

  * Make storage events take a tag for the backend instead of a string (Tim Wojtulewicz, Corelight)

  * Add move constructor to Tag class (Tim Wojtulewicz, Corelight)

7.2.0-dev.436 | 2025-03-27 14:07:11 -0700

  * Fix handling of timeout conditions from storage backends (Tim Wojtulewicz, Corelight)

  * Reformat plugin.storage btest to be more consistent with other storage tests (Tim Wojtulewicz, Corelight)

7.2.0-dev.433 | 2025-03-27 12:40:40 -0700

  * Remove "experimental" from the QUIC history field's comment string (Christian Kreibich, Corelight)

7.2.0-dev.431 | 2025-03-26 14:23:51 +0100

  * cluster/zeromq: Improve XPUB stall behavior, add a metric (Arne Welzel, Corelight)

    Instead of fprintf, track the number of occurrences via a metric and
    change the sleep loop to a blocking send instead.

7.2.0-dev.429 | 2025-03-26 13:59:23 +0100

  * GH-4309: telemetry: Run callbacks at collect time (Arne Welzel, Corelight)

    Calling collect_metrics() from a script would not invoke metric
    callbacks, resulting in most of the process metrics to be zero
    when a Zeek process isn't scraped via Prometheus.

7.2.0-dev.427 | 2025-03-24 19:45:24 +0100

  * cluster/OnLoop: Add metric for queue stalling instead of fprintf (Arne Welzel, Corelight)

  * btest/cluster/websocket: ZeroMQ backend test (Arne Welzel, Corelight)

  * cluster/OnLoop: Switch to condition variable (Arne Welzel, Corelight)

    The busy polling wasn't clever and usually resulted in delays. For now,
    switch to mutex/condition variable and log an error if the timeouts are
    immense.

  * cluster/zeromq: Fix node_topic() and nodeid_topic() (Arne Welzel, Corelight)

    Due to prefix matching, worker-1's node_topic() also matched worker-10,
    worker-11, etc. Suffix the node topic with a `.`. The original implementation
    came from NATS, where subjects are separated by `.`.

  * cluster/websocket: Fix null deref at WebSocket server shutdown (Arne Welzel, Corelight)

  * btest/cluster/websocket: Harden multi-client tests (Arne Welzel, Corelight)

  * cluster/zeromq: Fix unsubscription visibility (Arne Welzel, Corelight)

    When two workers connect to zeek.cluster.worker, the central ZeroMQ
    proxy would not propagate unsubscription information to other nodes
    once they both left. Set ZMQ_XPUB_VERBOSER on the proxies XPUB socket
    for visibility.

7.2.0-dev.418 | 2025-03-21 11:56:40 -0700

  * Redis: Handle other errors from requests, fix KEY_EXISTS for put operations (Tim Wojtulewicz, Corelight)

  * SQLite: handle existing keys when overwrite=F correctly (Tim Wojtulewicz, Corelight)

  * Remove unnecessary type aliases from storage btests (Tim Wojtulewicz, Corelight)

  * Avoid thread-leak in scripts.base.frameworks.file-analysis.bifs.enable-disable btest (Tim Wojtulewicz, Corelight)

    This btest uses the exit() BIF to shut down, which immediately calls
    ::exit() and kills Zeek without doing any shutdown. This will sometimes
    leave the thread running the storage manager, which causes TSan to
    complain about a thread leak. Switch to use the terminate() BIF instead
    which cleanly shuts down all of Zeek.

  * Fix data-race with calling DBG_LOG from a separate thread (Tim Wojtulewicz, Corelight)

  * Fix data-race with ReturnCode objects in Sqlite::DoExpire (Tim Wojtulewicz, Corelight)

  * Fix data race with calling run_state::network_time from a separate thread (Tim Wojtulewicz, Corelight)

  * Add NEWS entry for Storage, reduce CHANGES spam (Tim Wojtulewicz, Corelight)

  * Fix Coverity findings in the SQLite backend (Tim Wojtulewicz, Corelight)

  * Remove inclusion of non-existent expected-lite path during dynamic plugin builds (Tim Wojtulewicz, Corelight)

  * Squash code from OperationResultCallback into ResultCallback (Tim Wojtulewicz, Corelight)

  * Add hiredis to generate-docs workflow to enable Redis backend (Tim Wojtulewicz, Corelight)

7.2.0-dev.405 | 2025-03-21 09:43:18 +0100

  * testing/btest: Remove btest-bg-run sleep 1 (Arne Welzel, Corelight)

    Bump to the latest btest master version and set BTEST_BG_RUN_SLEEP
    environment variable to 0. This makes btest-bg-run return
    immediately instead of delaying by 1 second.

7.2.0-dev.402 | 2025-03-19 12:47:37 -0700

  * util: Fix terminate_processing() called from non-main thread (Arne Welzel, Corelight)

    The current raise(SIGTERM) sends a signal to the calling thread. If
    terminate_processing() is called from a non-main thread and that thread
    was created at InitPostScript() time when SIGTERM is blocked, or has
    blocked SIGTERM manually, terminate_processing() has no effect.

    Switching to kill(getpid(), SIGTERM) guarantees that a thread that doesn't
    block the signal (minimally the main thread) will run the handler.

7.2.0-dev.400 | 2025-03-19 12:46:41 -0700

  * -O gen-C++ support for pattern-to-pattern comparison (Vern Paxson, Corelight)

  * -O gen-C++ support for pattern vector comparisons (Vern Paxson, Corelight)

  * -O gen-C++ support for type expressions (Vern Paxson, Corelight)

7.2.0-dev.395 | 2025-03-19 11:58:41 -0700

  * CI: Run btests on macOS under sudo (Tim Wojtulewicz, Corelight)

7.2.0-dev.393 | 2025-03-19 19:56:42 +0100

  * Bump zeekjs to v0.16.0 (Arne Welzel, Corelight)

7.2.0-dev.391 | 2025-03-19 10:10:32 -0700

  * Add is_valid_subnet BiF (Yacin Nadji, Corelight)

  * Add btests for has_valid_octets() and normalize_mac() (Christian Kreibich, Corelight)

7.2.0-dev.387 | 2025-03-19 15:28:08 +0000

  * SSH: make banner parsing more robust (Johanna Amann, Corelight)

    This change revamps SSH banner parsing.  The previous behavior was both
    a bit too strict in some regards, and too permissive in other.

    Specifically, clients are now required to send a line starting with
    "SSH-" as the first line.  This is in line with the RFC, as well with
    observed behavior. This also prevents the creation of `ssh.log` for
    non-SSH traffic on port 22.

    For the server side, we now accept text before the SSH banner. This
    previously led to a protocol violation but is allowed by the spec.

    New tests are added to cover these cases.

7.2.0-dev.382 | 2025-03-18 11:52:03 -0700

  * Add analyzer registration from VLAN to VNTAG (Tim Wojtulewicz, Corelight)

7.2.0-dev.380 | 2025-03-18 11:46:08 -0700

  * Update src/3rdparty submodule [nomail] (Tim Wojtulewicz, Corelight)

7.2.0-dev.378 | 2025-03-18 11:43:48 -0700

  * Merged new Storage framework (Tim Wojtulewicz, Corelight)

    See the NEWS for more details about this new feature.

7.2.0-dev.325 | 2025-03-18 09:07:40 +0100

  * GH-4250: Spicy: Fix passing vectors to Zeek. (Robin Sommer, Corelight)

    We missed the allocator argument for the C++-side conversion
    template, which let vector's of certain types not compile.

  * [Spicy] Add missing `to_string` overload. (Robin Sommer, Corelight)

  * Bump Spicy. (Robin Sommer, Corelight)

    This includes a fix to adapt to Spicy-side changes.

  * Bump `cmake` submodule. (Robin Sommer, Corelight)

7.2.0-dev.318 | 2025-03-17 11:55:11 -0700

  * ci/init-external-repo.sh: Use regex to match macos cirrus task (Arne Welzel, Corelight)

  * CI: Change macOS runner to Sequoia (Tim Wojtulewicz, Corelight)

7.2.0-dev.314 | 2025-03-12 13:10:58 +0100

  * github/generate-docs: Run pre-commit (Arne Welzel, Corelight)

    ...it's a bit unfortunate that we cannot use the action for this. It's
    because ./doc is a submodule and not the main repo.

  * cluster/backends/zeromq: Fix rst link in docs (Arne Welzel, Corelight)

7.2.0-dev.310 | 2025-03-11 10:50:49 +0100

  * ci/opensuse-tumpleweed: Bust cache (Arne Welzel, Corelight)

    Got a build failure because the old container images had python3-devel
    for Python3.11 or something older, but then prepare.sh would install
    Python 3.13 and Zeek's configure failing due to trying to find the
    devel headers from python313-devel which wasn't installed by prepare.sh

  * ci/macos/prepare: Install python@3 explicitly (Arne Welzel, Corelight)

    It seems Homebrew's Python 3.12 doesn't install default symlinks or
    python3 symlinks[1]. I believe this results in prepare.sh using the
    system's Python rather than Homebrew's. Install python@3 explicitly
    to put the symlinks in place.

    [1] https://stackoverflow.com/a/77655631

  * cluster/websocket: Implement WebSocket server (Arne Welzel, Corelight)

  * cluster/websocket: Add IXWebsocket submodule (Arne Welzel, Corelight)

  * ci/alpine: Install openssl package for testing (Arne Welzel, Corelight)

  * ci: Install websockets from pip for all distros (Arne Welzel, Corelight)

    The cluster/websocket tests were developed against websockets 14.2,
    but Ubuntu and Alpine ship too old versions. Switch to installing
    the latest version from pip instead, so we don't need to bother making
    tests compatible with very old Python packages shipped by distributions.

  * auxil/libunistd: Bump for ssize_t typedef (Arne Welzel, Corelight)

  * auxil/broker: Bump to latest master version (Arne Welzel, Corelight)

  * cluster/zeromq: Catch log_push.send() exception (Arne Welzel, Corelight)

  * cluster/zeromq: Catch exceptions as const zmq::error_t& (Arne Welzel, Corelight)

  * cluster/zeromq: No assert on inproc handling (Arne Welzel, Corelight)

    This might happen if we didn't succeed in completely sending a multipart
    message and stop early.

  * cluster/zeromq: Support configuring IO threads for proxy thread (Arne Welzel, Corelight)

  * cluster/zeromq: Move variable lookups from DoInit() to DoInitPostScript() (Arne Welzel, Corelight)

  * cluster/zeromq: Handle EINTR at shutdown (Arne Welzel, Corelight)

    Read ::signal_val and early exit a DoPublish() in case termination
    happened while blocked in inproc.send()

  * cluster/zeromq: Queue one message at a time (Arne Welzel, Corelight)

    Queueing multiple messages can easily overload the IO loop without
    creating any backpressure.

  * cluster/Backend: Queue a single message only (Arne Welzel, Corelight)

    The ZeroMQ backend would accumulate multiple messages and enqueue them
    all at once. However, as this could potentially result in huge batches
    of events being queued into the event loop at once, switch to a one
    message at a time model. If there's too many messages queued already,
    OnLoop::QueueForProcessing() will block the ZeroMQ thread until
    there's room available again.

  * cluster/zeromq: Adapt for OnLoopProcess changes (Arne Welzel, Corelight)

  * cluster/ThreadedBackend: Switch to OnLoopProcess (Arne Welzel, Corelight)

  * cluster/OnLoop: Introduce helper template class (Arne Welzel, Corelight)

  * serializer/broker: Expose to_broker_event() and to_zeek_event() (Arne Welzel, Corelight)

    This is useful for reuse by WebSocket clients that use
    the JSON v1 encoding.

7.2.0-dev.288 | 2025-03-10 19:16:57 +0100

  * btest/javascript: Add file_sniff() and file_state_remove() test (Arne Welzel, Corelight)

    Using file_state_remove() or file_sniff() would previously crash with the
    spicy-zip file analyzer. We don't have spicy-zip here, so it's not a
    proper reproducer, but still makes sense to test these events.

  * GH-4239: Bump zeekjs to v0.15.0 (Arne Welzel, Corelight)

        f5ff7c4 version: 0.15.0
        2a48143 docker/fedora: Bust cache and ensure sqlite-libs is updated
        05e5f57 Executor: Unblock SIGTERM in thread
        46496b9 Instance: Remove unsued variable
        c3b3c86 Instance: Offload JavaScript invocations to executor thread
        09e311f Introduce Executor helper

    Mainly, run JavaScript on a separate thread for interoperability with
    Spicy fiber stacks.

    Closes #4239

7.2.0-dev.285 | 2025-03-10 08:28:54 -0700

  * CI: Unconditionally upgrade pip on macOS (Tim Wojtulewicz, Corelight)

7.2.0-dev.283 | 2025-03-10 06:11:40 -0700

  * Fix return types in docs for double_to_count and double_to_int (Tim Wojtulewicz, Corelight)

7.2.0-dev.280 | 2025-03-07 13:13:39 -0500

  * GH-4268: Fix printing type constants like `double` (Evan Typanski, Corelight)

    Fixes #4268

7.2.0-dev.278 | 2025-03-07 11:02:12 -0700

  * Fix indentation in .clang-tidy (Tim Wojtulewicz, Corelight)

  * Remove existing hand-written clang-tidy setup (Tim Wojtulewicz, Corelight)

  * Add ability to enable iwyu and clang-tidy at configure time (Tim Wojtulewicz, Corelight)

7.2.0-dev.273 | 2025-03-06 16:41:43 -0700

  * Set ip_proto when creating new tunnel encapsulations (Tim Wojtulewicz, Corelight)

  * Add code of conduct and contributing to repo. (Johanna Amann, Corelight)

7.2.0-dev.269 | 2025-03-06 13:12:31 +0000

  * Remove violating analyzer from services field again (Johanna Amann, Corelight)

    This reverts some of the recent DPD changes; specifically violations
    trigger removal from the services field, again, by default.

    Discussion in GH-4521

7.2.0-dev.265 | 2025-03-05 19:23:53 +0100

  * ZAM: bif-tracking updates for blocking_lookup_hostname() (Arne Welzel, Corelight)

  * GH-4216 GH-4219: scan.l: Deprecate DNS resolutions of hostname literals (Arne Welzel, Corelight)

    This also skips DNS lookups when running with zeek --parse-only.

  * input/zeek-setup: Track parse_only globally (Arne Welzel, Corelight)

    For easier access in scan.l

  * zeek.bif: Introduce blocking_lookup_hostname() (Arne Welzel, Corelight)

    As a replacement for host literal DNS resolutions.

  * btest/dns_mgr: Update run-dnsmasq, use --host-record (Arne Welzel, Corelight)

    Using dnsmasq --address covers an entire domain, so dns.example.com
    AAAA queries would also return IPv6 addresses for example.com

    Instead, this was always meant to use host entries.

7.2.0-dev.258 | 2025-03-04 12:52:38 -0800

  * Update zeekctl submodule to pull in testsuite fix for metrics port (Christian Kreibich, Corelight)

7.2.0-dev.257 | 2025-03-04 09:33:54 -0700

  * Reformat embedded C++ code in bison/flex files (Tim Wojtulewicz, Corelight)

7.2.0-dev.255 | 2025-03-04 08:52:13 -0700

  * Fix Coverity findings from recent IPTunnel dumping changes (Tim Wojtulewicz, Corelight)

7.2.0-dev.253 | 2025-03-04 13:38:32 +0000

  * RDP: cookie is optional (Johanna Amann, Corelight)

    RDP connections are now parsed even if the optional cookie value
    is not present.

    Fixes GH-4237

7.2.0-dev.250 | 2025-03-04 12:07:01 +0100

  * Update zeek.bif documentation for to_count and to_int (Mark Overholser)

  * CI: Add release-build ZAM task for baseline checks during PRs (Tim Wojtulewicz, Corelight)

  * Fix language/assert btest baselines for to_count/to_int changes (Tim Wojtulewicz, Corelight)

  * Update the bifs.to_count baseline for ZAM (Tim Wojtulewicz, Corelight)

7.2.0-dev.244 | 2025-03-04 09:40:41 +0100

  * GH-2311: scan.l: Fix @load-plugin scripts loading (Arne Welzel, Corelight)

    For a plugin loaded via @load-plugin, create a YY_BUFFER_STATE holding
    the required loads for the implicitly loaded files. In loaded scripts,
    this generated file will show up with a path of the shared object file
    of the plugin with the __preload__.zeek and __load__.zeek files loaded
    by it.

    Closes #2311

  * scan.l: Extract switch_to() from load_files() (Arne Welzel, Corelight)

  * ScannedFile: Allow skipping canonicalization (Arne Welzel, Corelight)

  * Bump pre-commit hooks (Benjamin Bannier, Corelight)

  * Always break lines when formatting `spicy_add_analyzer` (Benjamin Bannier, Corelight)

  * Fix formatting of `zeek_add_plugin` (Benjamin Bannier, Corelight)

7.2.0-dev.232 | 2025-02-25 07:29:43 -0700

  * CI: Use the right variable for the number of test jobs for zeekctl_debian11_task tasks (Tim Wojtulewicz, Corelight)

  * CI: Use fewer btest jobs for ZAM tasks (Tim Wojtulewicz, Corelight)

7.2.0-dev.228 | 2025-02-24 11:37:42 -0700

  * Fix incorrect syntax for static_cast in to_count that I introduced in a previous merge (Mark Overholser)

  * Update baselines after changes to to_count and to_int (Mark Overholser)

  * fix to_count in zeek.bif to resolve conflict from bbanier's adjustment to static casting of the return from strtoull (Mark Overholser)

  * Fix tests in to_count to reflect appropriate function; add tests for 0x-formatted hex values for to_count and to_int (Mark Overholser)

  * update BIFs to_int() and to_count() to accept optional 'base' argument; allows more more exotic conversions from hex, octal, binary (Mark Overholser)

  * Fixes #4076; update BIFs to_int() and to_count() to accept optional 'base' argument for more easy conversions of strings representing (for example) hexadecimal, octal, or binary numbers (Mark Overholser)

  * geneve/functions.bif: Fix :zeek:see directive, take two (Arne Welzel, Corelight)

  * geneve/functions.bif: Fix :zeek:see directive (Arne Welzel, Corelight)

7.2.0-dev.217 | 2025-02-22 12:33:25 -0800

  * PacketAnalyzer::Geneve: Add get_options() (Arne Welzel, Corelight)

    Allow to extract Geneve options on-demand, for example during a
    new_connection() event.

  * packet_analysis: Track data spans of packet analyzers (Arne Welzel, Corelight)

    Do not just track the analyzer instance in the stack, but also the
    data span it is given. This allows to extract more information on-demand
    during event processing.

    TrackAnalyzer() is technically a public API, but no one should use it
    outside of the Analyzer's Forward methods itself.

7.2.0-dev.214 | 2025-02-21 12:24:21 +0100

  * Fix bifs.to_count and bifs.to_int btests under ZAM (Tim Wojtulewicz, Corelight)

7.2.0-dev.212 | 2025-02-20 16:40:19 -0700

  * Set original/outer packet flags to reflect inner packet results (mnhsrj)

    Propagate inner packet flags such as 'processed', 'dump_packet', 'dump_size'
    to outer packet for packets involving tunneled data.

7.2.0-dev.210 | 2025-02-20 15:35:21 -0700

  * Also trim trailing spaces in `to_count`/`to_int` inputs (Benjamin Bannier, Corelight)

    Previously we would already trim leading spaces in inputs to `to_count`
    and `to_int`, effectively by just passing the behavior of the low-level
    functions used in their implementations to the user. While this was
    useful it was also inconsistent in that we did not allow trailing
    spaces which we enable with this patch.

  * Align error handling in `to_int` with existing behavior of `to_count` (Benjamin Bannier, Corelight)

    Previously `to_int` would silently ignore invalid inputs and simply
    return `0` while `to_count` would return an error; this patch changes
    `to_int` to behave like `to_count`.

    This introduces a breaking change in that `to_int` now raises an error
    for trailing spaces (but still accepts leading spaces) where it
    previously would have silently accepted it. This is consistent with
    the behavior of `to_count`, but one could also argue that both of
    these should only accept properly trimmed input; I did not go that route
    since that would introduce breaking changes for both these functions
    instead of for just one of them.

  * Baseline handling of leading/trailing spaces in `to_count`/`to_int`. (Benjamin Bannier, Corelight)

    Currently `to_count` reports an error for trailing spaces (but not for
    leading ones) while `to_int` silently accepts them. This patch adds
    baselines capture the current behavior.

  * Add error messages to `to_count`/`to_int` baselines (Benjamin Bannier, Corelight)

    This captures error messages produced by `to_count`, but will also
    baseline future error messages from `to_int` once we introduce them.

7.2.0-dev.203 | 2025-02-18 08:51:23 -0700

  * cirrus: Bump FreeBSD 14 task to 14.2 (Arne Welzel, Corelight)

  * Fix dead links in README (Brendan Kapp)

7.2.0-dev.199 | 2025-02-14 11:28:48 -0800

  * Do not export locals (Evan Typanski, Corelight)

  * DPD changes - ZAM baseline updates (Johanna Amann, Corelight)

7.2.0-dev.194 | 2025-02-07 07:31:26 +0000

  * Allow to track service violations in conn.log. (Johanna Amann, Corelight)

    This introduces ian options, DPD::track_removed_services_in_connection.
    It adds failed services to the services column, prefixed with a
    "-".

    Alternatively, we also introduce the
    policy/protocols/conn/failed-services-logging.zeek, which provides the same
    information in a new column in conn.log.

  * Make conn.log service field ordered (Johanna Amann, Corelight)

    This changes service set in the connection record, and thus also the
    conn.log service field to being ordered. Speficically, the order of the
    entries in the service field will be the same order in which protocols
    will be confirmed. This means that it now is possible to see which
    protocols were layered over each other in which order by looking at the
    respective conn.log entry.

  * DPD: change handling of pre-confirmation violations, remove max_violations (Johanna Amann, Corelight)

    This commit revamps the handling of analyzer violations that happen
    before an analyzer confirms the protocol.

    This change reinstates the originally intended behavior of DPD. When an
    analyzer that has not been confirmed raises a protocol violation, it is
    immediately removed from the connection. This also makes a lot of sense
    - this allows the analyzer to be in a "tasting" phase at the beginning
    of the connection, and to error out quickly once it realizes that it was
    attached to a connection not containing the desired protocol.

    This change also removes the DPD::max_violations option, as it no longer
    serves any purpose after this change. (In practice, the option remains
    with an &deprecated warning, but it is no longer used for anything).

  * DPD: log analyzers that have confirmed (Johanna Amann, Corelight)

    This switches the DPD logic to always log analyzers that raised a
    protocol confirmation.

    The logic is that, once a protocol has been confirmed - and thus there
    probably is log output - it does not make sense to later remove it from
    the log. It does make sense to somehow flag it as failed - but that
    seems like a secondary step.

  * IRC analyzer - make protocol confirmation more robust. (Johanna Amann, Corelight)

    This commit changes the logic of the IRC analyzer to check for valid
    commands before confirming. Before that it nearly unconditionally confirmed
    connections.

  * CI: bump FreeBSD 14 to 14.2, which came out in Dec'24 (Christian Kreibich, Corelight)

  * CI: remove OpenSuSE Leap 15.5, EOL. (Christian Kreibich, Corelight)

7.2.0-dev.177 | 2025-02-06 09:44:15 +0100

  * GH-3595: Downgrade internal errors to reporter warnings in file/directory BiFs (Christian Kreibich, Corelight)

    This allows Zeek execution to continue gracefully in the presence of such
    errors, particularly at zeek_init() time. Includes a tweak to expand the
    bifs.directory_operations test to check continuation after errors.

  * Add NEWS entry for recent kerberos change [nomail] [skip ci] (Tim Wojtulewicz, Corelight)

7.2.0-dev.173 | 2025-02-05 16:40:41 +0100

  * cluster/zeromq: Call DoTerminate() in destructor (Arne Welzel, Corelight)

    Normal life-cycle is that Terminate() / DoTerminate() is called
    by zeek-setup code. If that doesn't happen, shutdown and join
    threads during destructor.

    try { } catch (...) suggested by Benjamin.

  * cluster/zeromq: Use lambda for thread trampoline (Arne Welzel, Corelight)

  * cluster/zeromq: Do not call util::fmt() from thread (Arne Welzel, Corelight)

    ...util::fmt() uses a static buffer, so this is problematic.

    I've dabbled a bit replacing std::thread with using threading::BasicThread
    which would offer Fmt(), but this makes things more complicated. Primarily
    as BasicThread is registered with the thread manager and the shutdown
    interactions become entangled. The thread might be terminated before the
    backend, or vice-versa. Seems nicer for the thread to be owned by the backend.

7.2.0-dev.169 | 2025-02-05 11:10:21 +0100

  * cluster/zeromq: Fix Unsubscribe() bug caused by \x00 prefix (Arne Welzel, Corelight)

  * cluster: Add SubscribeCallback support (Arne Welzel, Corelight)

    This allows callers of Subscribe() to pass in a callback that will be invoked
    once the subscription is established or failed to establish. It is the
    backend's responsibility to execute the callback on the main thread either
    synchronously, or preferably asynchronously at a later point, by
    scheduling a task on the IO main loop.

    This turns on ZMQ_XPUB_VERBOSE for ZeroMQ so that notifications about
    subscriptions are raised even if the subscriptions has previously been
    observed.

  * cluster/zeromq: Fix XSUB threading issues (Arne Welzel, Corelight)

    It is not safe to use the same socket from different threads, but the
    current code used the xsub socket directly from the main thread (to setup
    subscriptions) and from the internal thread for polling and reading.

    Leverage the PAIR socket already in use for forwarding publish operations
    to the internal thread also for subscribe and unsubscribe.

    The failure mode is/was a bit annoying. Essentially, closing of the
    context would hang indefinitely in zmq_ctx_term().

  * cluster/zeromq: Use NodeId(), drop my_node_id (Arne Welzel, Corelight)

  * cluster/Backend: Pass node_id via Init() (Arne Welzel, Corelight)

  * cluster/Backend: Make backend event processing customizable (Arne Welzel, Corelight)

    This allows configurability at the code level to decide what to do with
    a received remote events and events produced by a backend. For now, only
    enqueue events into the process's script layer, but for the WebSocket
    interface, the action would be to send out the event on a WebSocket
    connection instead.

  * cluster/broker/Serializer: Fix adaptor to adapter (Arne Welzel, Corelight)

  * cluster/Backend: Do not use const std::string_view& (Arne Welzel, Corelight)

  * cluster/serializer/broker: Fix handler lookup (Arne Welzel, Corelight)

    Handler overwrites operator bool, so need to explicitly test for nullptr
    rather than not having any handlers defined.

  * broker/Manager: Move name in PublishEvent() (Arne Welzel, Corelight)

  * btest/zeromq/test-bootstrap: Fix port parsing (Arne Welzel, Corelight)

    to_port() will produce an error on empty strings which extract_count()
    does not.

  * EventHandler: Support operator!= (Arne Welzel, Corelight)

7.2.0-dev.156 | 2025-02-05 09:05:00 +0000

  * IPv6 support for detect-external-names and testcase (Johanna Amann, Corelight)

  * Add  `skip_resp_host_port_pairs` option to policy/protocols/dns/detect-external-names.zeek.
    This option allows to skip the detection of external names for certain addresses.
    By default this is set so that mDNS broadcasts no longer are logged as extenal. (jbaggs)

7.2.0-dev.152 | 2025-02-04 14:50:36 -0800

  * Bump cluster testsuite to pull in resilience to agent connection timing [skip ci] (Christian Kreibich, Corelight)

7.2.0-dev.150 | 2025-02-04 16:50:44 +0100

  * GH-4209: util/init_random_seed: write_file implies deterministic (Johanna Amann, Corelight)

    This makes Zeek run in deterministic mode with --save-seeds usage
    and reworks all the extra indirections used in init_random_seed()
    to make it easier to follow the control flow.

7.2.0-dev.148 | 2025-02-04 09:52:29 +0100

  * external/subdir-btest.cfg: Set OPENSSL_ENABLE_SHA1_SIGNATURES=1 (Arne Welzel, Corelight)

    We already do something similar for OPENSSL_ENABLE_MD5_VERIFY=1

  * btest/x509_verify: Drop OpenSSL 1.0 hack (Arne Welzel, Corelight)

    We do not have a distro in CI anymore that ships OpenSSL 1.0,
    drop the hack.

  * GH-4035: testing/btest: Use OPENSSL_ENABLE_SHA1_SIGNATURES (Arne Welzel, Corelight)

    This reverts the call to update-crypto-policies in the Fedora 41 image
    and instead sets OPENSSL_ENABLE_SHA1_SIGNATURES in the individual tests.
    This allows RHEL 10 or Fedora 41 users to run the tests in question
    without needing to fiddle with system settings.

    Fixes #4035

7.2.0-dev.144 | 2025-02-04 09:18:25 +0100

  * Add ZAM baseline for new scripts.base.protocols.quic.analyzer-confirmations btest (Tim Wojtulewicz, Corelight)

7.2.0-dev.142 | 2025-02-03 18:41:40 -0700

  * Make enc_part value from kerberos response available to scripts (Philipp Tekeser-Glasz)

7.2.0-dev.140 | 2025-02-03 18:34:00 -0700

  * Add note to Traces/README about possible malware in pe/pe.trace (Tim Wojtulewicz, Corelight)

  * Fix formatting of Traces/README entry for modbus-eit.trace (Tim Wojtulewicz, Corelight)

7.2.0-dev.137 | 2025-02-03 16:53:04 -0800

  * Remove unused SupervisedNode::InitCluster declaration (Christian Kreibich, Corelight)

7.2.0-dev.135 | 2025-02-03 17:50:31 +0100

  * QUIC/decrypt_crypto: Rename all_data to data (Arne Welzel, Corelight)

    ...for consistency.

  * GH-4201: QUIC: Confirm before forwarding data to SSL (Arne Welzel, Corelight)

    Fixes #4201

  * GH-4198: QUIC: Parse all QUIC packets in a UDP datagram (Arne Welzel, Corelight)

    A UDP datagram may contain multiple QUIC packets, but the parser so far
    handled only the very first packet, ignoring any subsequent packets.

    Fixes #4198

  * QUIC: Only slurp till packet end, not till &eod (Arne Welzel, Corelight)

    This doesn't change behavior, but avoids slurping in more data than
    needed. A UDP packet an contain multiple QUIC packets and we'd read
    all following ones instead just the one we're interested in.

7.2.0-dev.129 | 2025-01-31 15:58:37 -0800

  * Management framework:

    - Bump cluster testsuite to pull in updated Prometheus tests (Christian Kreibich, Corelight)
    - move up addition of agent IPs into deployable cluster configs (Christian Kreibich, Corelight)
    - Support multiple instances per host addr in auto metrics generation (Michael Dopheide)
    - When auto-generating metrics ports for worker nodes, get them more uniform across instances. (Michael Dopheide)

7.2.0-dev.124 | 2025-01-30 10:51:14 -0700

  * Pack some classes for better memory usages (Tim Wojtulewicz, Corelight)

    - Analyzer: Reduce from 208 bytes to 192 bytes, remove one cache line
    - EventGroup: Reduce from 104 bytes to 96 bytes
    - Packet: Reduce from 200 bytes to 184 bytes, remove one cache line
    - threading::Value: Reduce from 48 bytes to 40 bytes
    - ConnTuple: push hole to the end of struct
    - TCP_Reassembler: Reduce from 240 bytes to 232 bytes

7.2.0-dev.122 | 2025-01-24 15:47:15 -0700

  * Make types into constants (Evan Typanski, Corelight)

    This allows types to be used in expressions, but they can't be
    reassigned. Note that this was meant to be a special "type expression" -
    but that is unnecessary complexity.

    Type expressions would allow access to the type without going through
    its constant value, but the constant value is never changed, so it's
    simply a few more checks if necessary when functionality gets expanded.
    This way, ZAM and other code will not need updates, so the potential for
    increased work in the future is probably not worth caring about.

7.2.0-dev.116 | 2025-01-24 11:42:14 -0700

  * Fix errors from rst linting on the generated docs (Tim Wojtulewicz, Corelight)

7.2.0-dev.113 | 2025-01-23 11:49:23 -0700

  * Fix options parsing segfault (Evan Typanski, Corelight)

    A command like this would segfault:

    zeek -b test.zeek --debug

    The issue was that `getopt_long` was using a null element to determine
    what the end of the options array is. If it saw a non-null element after
    `--debug` it would say it's the argument for optarg, even if it's beyond
    `zeek_args.size()`. Instead, just make sure the array is
    null-terminated.

7.2.0-dev.111 | 2025-01-23 11:21:21 -0700

  * Minor whitespace cleanup in init-bare.zeek (Tim Wojtulewicz, Corelight)

  * Add missing export blocks to init-bare.zeek (Tim Wojtulewicz, Corelight)

  * Merge some GLOBAL module sections in init-bare (Tim Wojtulewicz, Corelight)

  * Merge Tunnel module sections in init-bare (Tim Wojtulewicz, Corelight)

7.2.0-dev.106 | 2025-01-23 16:46:33 +0100

  * script_opt: Use emit_builtin_error() for Lookup-Conn (Arne Welzel, Corelight)

    Still create a separate baseline file because ZAM doesn't provide
    detailed location information.

    Patch for ZBI.op provided by @vpax

7.2.0-dev.104 | 2025-01-21 16:48:56 -0700

  * session/Manager: Emit explicit errors for FindConnection() with proto=65535 (Arne Welzel, Corelight)

    We silently broke users constructing conn_id records manually and
    subsequently using them with lookup_connection() or connection_exists().

    This is an attempt to at least report a runtime error about the situation
    so it doesn't go completely unnoticed.

  * IPAddr/ConnKey: Protect from uninitialized conn_id (Arne Welzel, Corelight)

    Check if the non-default fields exist using HasField()
    and use GetField() for proto such that it'll initialize
    the default value which GetFieldAs<> doesn't do.
    default

  * IPAddr/ConnKey: Promote transport to uint16_t (Arne Welzel, Corelight)

    Instead of a separate bool field which is also stored in the session
    table, promote the transport field to uint16_t and encode an invalid
    ConnKey as transport 2**16-2

  * session/Manager: Header cleanup (Arne Welzel, Corelight)

7.2.0-dev.99 | 2025-01-20 10:27:32 +0100

  * fixes for -O gen-standalone-C++ generation of lambdas (Vern Paxson, Corelight)

7.2.0-dev.95 | 2025-01-14 21:39:01 +0100

  * logging: Fix reporter message (Arne Welzel, Corelight)

  * logging: Avoid repeated writer name lookups for plugin hooks (Arne Welzel, Corelight)

    If a plugin provides a write hook, the invocation for HookLogWrite() would
    redo looking up the writer's name from the enum value and instantiating
    a new std::string instance for every write. Avoid doing this.

  * logging: Fix HookLogInit() and HookLogWrite() info usage (Arne Welzel, Corelight)

    There's two instances of WriterBackend::WriterInfo for a given
    writer. One in Manager::WriterInfo that's accessible via
    stream.writers and a copy within WriterFrontend.

    Commit 78999d147d7a98a064d25854eea38468c1af7c5e switched to use the
    address of the frontend's info instance for HookLogWrite() invocations,
    breaking users using the address for identification purposes.

7.2.0-dev.91 | 2025-01-14 18:20:04 +0100

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

  * Prevent unneeded copies in QUIC C++ helper code (Benjamin Bannier, Corelight)

7.2.0-dev.88 | 2025-01-14 14:39:14 +0000

  * Raise warnings when for DNS events that are not raised due to dns_skip_all_addl (Johanna Amann, Corelight)

    By default, dns_skip_all_addl is set to false. This causes several
    events to not be raised. This change emits warnings when a user defines
    event handlers for events that will not be raised.

    Furthermore, it adds notes about this behavior to the documentation. We
    also introduce a new BIF, `is_event_handled`, which checks if an event
    is handled.

    Fixes GH-4061

7.2.0-dev.84 | 2025-01-14 11:12:52 +0100

  * support for record extensions when using -O gen-standalone-C++ (Vern Paxson, Corelight)

7.2.0-dev.82 | 2025-01-14 08:42:27 +0100

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

  * Prevent copies in various places (Benjamin Bannier, Corelight)

7.2.0-dev.79 | 2025-01-13 08:30:54 -0700

  * Fix incomplete includes in Spicy SSL analyer C++ code (Benjamin Bannier, Corelight)

    This appears to have been broken by
    feec451bcee7c459bc9a93e39ae18dc41515ac17.

7.2.0-dev.77 | 2025-01-13 08:21:51 -0700

  * Add SECURITY.md, pointing at the website (Tim Wojtulewicz, Corelight)

7.2.0-dev.72 | 2025-01-11 17:36:31 +0100

  * Mark `swap` specialization `noexcept` (Benjamin Bannier, Corelight)

  * Clean up some includes (Benjamin Bannier, Corelight)

  * Prevent exception in `noexcept` function. (Benjamin Bannier, Corelight)

  * Prevent exception escape. (Benjamin Bannier, Corelight)

  * Prevent unnecessary copies in Spicy bindings (Benjamin Bannier, Corelight)

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.2.0-dev.64 | 2025-01-10 11:15:24 -0800

  * GH-4102: Harden flaky test based on creating a file (Evan Typanski, Corelight)

7.2.0-dev.62 | 2025-01-09 22:17:41 -0700

  * Update btests for new local-only subnets (Tim Wojtulewicz, Corelight)

  * Add recommended non-routable subnets (JW-Corelight, Corelight)

    224.0.0.0/24 (and 6to4 conversion 2002:e000::/40) from RFC5771	"Multicast Local Network Control Block" defined as non-routable.

    239.0.0.0/8 (and 6to4 conversion 2002:ef00::/24) from RFC2365 "Administratively Scoped IP Multicast"

    fec0::/10 from RFC3879 "Deprecated Site Local Addresses"
    (cherry picked from commit 821ab2dbed0bc24c14b35ed22be6ba754646ca24)

  * Fix another typo in the Coverity workflow script (Tim Wojtulewicz, Corelight)

7.2.0-dev.57 | 2025-01-09 13:47:29 -0700

  * Add missing include for <vector> (Tim Wojtulewicz, Corelight)

  * Extended ZAM validation to include macros (Vern Paxson, Corelight)

7.2.0-dev.54 | 2025-01-09 12:09:07 -0700

  * factoring of some ZAM header files for better modularity (Vern Paxson, Corelight)

7.2.0-dev.52 | 2025-01-09 12:02:45 -0700

  * fixes for initializing globals when using -O gen-standalone-C++ (Vern Paxson, Corelight)

7.2.0-dev.50 | 2025-01-09 16:26:00 +0100

  * Update COPYING date to now and fix some [skip CI] (Evan Typanski, Corelight)

7.2.0-dev.48 | 2025-01-08 21:44:21 -0800

  * Try to be more careful with `--help` printing (Evan Typanski, Corelight)
  * Update doc submodule [nomail] [skip ci] (zeek-bot)
  * Add CECPQ2 curve number to SSL consts (Johanna Amann, Corelight)

7.2.0-dev.43 | 2025-01-08 08:38:25 -0700

  * CI: Fix escaping in coverity workflow (Tim Wojtulewicz, Corelight)

7.2.0-dev.40 | 2025-01-07 11:41:31 -0700

  * Add 7.1 contributors to NEWS file [skip ci] (Christian Kreibich, Corelight)

7.2.0-dev.38 | 2025-01-07 10:05:15 -0700

  * More updates to the SSL consts from recent protocol additions (Johanna Amann, Corelight)

7.2.0-dev.35 | 2025-01-06 15:51:03 -0700

  * Update ssl consts with more post-quantum curves (Johanna Amann, Corelight)

7.2.0-dev.33 | 2025-01-06 10:37:33 -0700

  * CI: Fix coverity workflow to support large uploads (Tim Wojtulewicz, Corelight)

    The previous setup only allowed uploads of up to 500MB, which we
    eclipsed a long time ago. They recently started enforcing it, so
    this switches over to use a call-and-response API for uploading
    larger files.

  * CI: Remove use of wget from coverity workflow (Tim Wojtulewicz, Corelight)

  * CI: Upgrade coverity workflow to ubuntu24, add jq (Tim Wojtulewicz, Corelight)

7.2.0-dev.28 | 2025-01-05 14:19:15 -0700

  * Fix incorrect uses of `zeek:see` (Benjamin Bannier)

    This fixes instances where `zeek:see` was used incorrectly so it was not
    rendered correctly. All these instances have been found by looking for
    `zeek:see` in the generated HTML where it should not be visible anymore.

    I also removed a doc reference to `paraglob_add` which never existed.

7.2.0-dev.25 | 2024-12-20 15:31:19 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.2.0-dev.23 | 2024-12-20 15:14:33 -0700

  * Require spicy for spicy.analyzer-id btest (Tim Wojtulewicz, Corelight)

  * Document `get_tag` to ensure that `name` exists (Evan Typanski, Corelight)

    This caused confusion and I don't think it's very intuitive. If called
    with a name that does not exist, this returns without a value, not even
    an error value. Changing that seems like it could be more deprecation
    work.

7.2.0-dev.18 | 2024-12-18 15:44:40 -0700

  * Add spicy runtime-support current_analyzer_id(), use it to set id in events (Tim Wojtulewicz, Corelight)

7.2.0-dev.16 | 2024-12-18 09:28:33 +0100

  * pre-commit: Bump spicy-format to 0.23 (Arne Welzel, Corelight)

  * fix for ZAM optimization of assigning a record field to result of "in" operation (Vern Paxson, Corelight)

7.2.0-dev.13 | 2024-12-17 12:15:42 -0700

  * Return a warning and fail if creating a store at global scope (Tim Wojtulewicz, Corelight)

7.2.0-dev.11 | 2024-12-16 12:37:25 -0700

  * ZAM/relexpr-op NE for patterns (Vern Paxson, Corelight)

  * Expr: Fix folding of pattern values to support == and != (Arne Welzel, Corelight)

    The fatal error is actually triggered at runtime, so it's a bit
    dangerous for users, but not sure there's many use-cases to
    compare vectors of patterns.

7.2.0-dev.8 | 2024-12-16 10:19:18 -0700

  * QUIC/decrypt_crypto: Actually check if decryption was successful (Arne Welzel, Corelight)

    ...and bail if it wasn't.

    PCAP was produced using OSS-Fuzz input from issue 383379789.

  * QUIC/decrypt_crypto: Limit payload_length to 10k (Arne Welzel, Corelight)

    Given we dynamically allocate memory for decryption, employ a limit
    that is unlikely to be hit, but allows for large payloads produced
    by the fuzzer or jumbo frames.

  * QUIC/decrypt_crypto: Fix decrypting into too small stack buffer (Arne Welzel, Corelight)

    A QUIC initial packet larger than 1500 bytes could lead to crashes
    due to the usage of a fixed size stack buffer for decryption.

    Allocate the necessary memory dynamically on the heap instead.

  * Fix naming of zeromq package in Coverity workflow (Tim Wojtulewicz, Corelight)

  * Fix naming of cppzmq-dev package in Coverity workflow (Tim Wojtulewicz, Corelight)

7.2.0-dev.2 | 2024-12-13 16:46:18 -0700

  * CI: Add missing packages to coverity workflow (Tim Wojtulewicz, Corelight)

  * Start of 7.2.0 development (Tim Wojtulewicz, Corelight)

7.1.0-dev.829 | 2024-12-13 13:15:41 -0700

  * Updating submodule(s) [nomail] (Tim Wojtulewicz, Corelight)

7.1.0-dev.827 | 2024-12-13 12:17:25 -0700

  * btest/supervisor: Bump one timeout to 30 seconds (Arne Welzel, Corelight)

  * btest/cluster: Bump timeouts to 30 seconds (Arne Welzel, Corelight)

    ZAM startup may take a long time, particularly in CI environments, so
    bump it up from 10 to 30 seconds.

  * btest/validate-ZAM: Update baseline, run always (Arne Welzel, Corelight)

7.1.0-dev.823 | 2024-12-13 12:14:46 -0700

  * simplified ZAM instructions for executing "assert" statements (Vern Paxson, Corelight)

7.1.0-dev.821 | 2024-12-13 12:14:17 -0700

  * cirrus/container_image_manifest: match RC tags, too (Arne Welzel, Corelight)

    The rest should just work, assuming VERSION files contain an
    appropriate value. Add a check for that, too.

  * cirrus: Move additional tag "computation" into separate script (Arne Welzel, Corelight)

    This allows for easier testing locally and maybe re-usability.

7.1.0-dev.818 | 2024-12-13 08:04:17 -0700

  * fix for memory management associated with ZAM table iteration (Vern Paxson, Corelight)

7.1.0-dev.816 | 2024-12-13 12:59:08 +0100

  * zeekygen: Disable Cluster::Experimental module (Arne Welzel, Corelight)

    The nodes-experimental/manager.zeek file ends up calling Broker::publish()
    unconditionally, resulting in a warning. Skip running that code when
    generating documentation.

7.1.0-dev.814 | 2024-12-13 10:57:19 +0100

  * BTest updates in support of compiling-scripts-to-C++ (Vern Paxson, Corelight)

  * -O gen-standalone-C++ fixes for recent more aggressive AST profiling (Vern Paxson, Corelight)

7.1.0-dev.811 | 2024-12-12 20:11:39 -0800

  * removed a bunch of no-longer used BTest alternatives and their associated baselines (Vern Paxson, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.1.0-dev.808 | 2024-12-12 13:17:51 -0700

  * netcontrol: Move to Cluster::publish() (Arne Welzel, Corelight)

  * openflow: Move to Cluster::publish() (Arne Welzel, Corelight)

  * netcontrol/catch-and-release: Move to Cluster::publish() (Arne Welzel, Corelight)

  * config: Move to Cluster::publish() (Arne Welzel, Corelight)

  * ssl/validate-certs: Move to Cluster::publish() (Arne Welzel, Corelight)

  * irc: Move to Cluster::publish() (Arne Welzel, Corelight)

  * ftp: Move to Cluster::publish() (Arne Welzel, Corelight)

  * dhcp: Move to cluster publish (Arne Welzel, Corelight)

  * notice: Move to Cluster::publish() (Arne Welzel, Corelight)

  * intel: Move to Cluster::publish() (Arne Welzel, Corelight)

  * sumstats: Move to Cluster::publish() (Arne Welzel, Corelight)

7.1.0-dev.796 | 2024-12-12 13:16:57 -0700

  * cluster/Backend: Handle unspecified table/set (Arne Welzel, Corelight)

    Same as what we do in Broker. Use the expected type if publishing
    a table() or set() parameter.

    This fixes issues when switching sumstats to Cluster::publish()

  * cluster: Fix Cluster::publish() of Broker::Data (Arne Welzel, Corelight)

    The broker serializer leverages the existing data_to_val() function.
    During unserialization, if the destination type is any, the logic
    simply wraps the broker::data value into a Broker::Data record.
    Therefore, events with any parameters are currently exposed to
    the Broker::Data type.

    There is a bigger issue in that re-publishing such Broker::Data
    instances would encode them as a normal record. Explicitly prevent
    this by serializing the contained data value directly instead, similar
    to what Broker already did when publishing a record.

  * cluster: Be noisy when attempting to connect to an unknown node (Arne Welzel, Corelight)

    Mostly due to spending too much time wondering why nodes didn't connect
    when there was a mismatch between "manager" and "manager-1" in the
    cluster layout. Remove manager from test-all-policy-cluster test to
    avoid connection attempts in this test.

7.1.0-dev.792 | 2024-12-12 11:35:08 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.1.0-dev.790 | 2024-12-12 11:33:01 -0700

  * Add note about various dependency updates [nomail] [skip ci] (Tim Wojtulewicz, Corelight)

  * NEWS additions for v7.1 [nomail] [skip ci] (Tim Wojtulewicz, Corelight)

7.1.0-dev.787 | 2024-12-12 14:45:39 +0100

  * Pre-compute the node topics for all pool entries. (Justin Azoff, Corelight)

    A zeek script profile showed a small percentage of time spent in
    Cluster::node_topic, but this never changes and can be cached.

  * Fix ZAM's implementation of Analyzer::name() BiF (Christian Kreibich, Corelight)

    ZAM's implementation deviates from Zeek's in consideration of remappings, which
    means that running ZAM produced conn.log service names prefixed with "spicy_"
    whereas regular Zeek doesn't.

7.1.0-dev.782 | 2024-12-11 15:33:06 -0700

  * Update zeekctl submodule to remove BroControl dir (Tim Wojtulewicz, Corelight)

  * Run Coverity workflow on ubuntu 22.04 (Tim Wojtulewicz, Corelight)

7.1.0-dev.779 | 2024-12-11 12:59:17 -0700

  * Add blurb about Spicy SSL to NEWS (Johanna Amann, Corelight)

7.1.0-dev.777 | 2024-12-11 12:38:48 -0700

  * Add Spicy analyzers to Coverity builds (Tim Wojtulewicz, Corelight)

7.1.0-dev.775 | 2024-12-11 11:45:31 -0700

  * Swap pre-commit yapf for ruff/ruff-format, fix findings (Tim Wojtulewicz, Corelight)

  * Upgrade package-manager submodule to get python upgrade (Tim Wojtulewicz, Corelight)

  * Upgrade broker submodule to get python upgrade (Tim Wojtulewicz, Corelight)

  * Upgrade zeekctl submodule to get python upgrade (Tim Wojtulewicz, Corelight)

  * Upgrade zeek-client submodule to get python upgrade (Tim Wojtulewicz, Corelight)

  * Upgrade btest submodule to get python upgrade (Tim Wojtulewicz, Corelight)

  * Require Python 3.9 in CMakeLists.txt (Tim Wojtulewicz, Corelight)

  * CI: Install python 3.9 on ubuntu 20 (Tim Wojtulewicz, Corelight)

7.1.0-dev.766 | 2024-12-11 11:07:53 -0700

  * btest: Avoid loading ZeroMQ if not compiled in (Arne Welzel, Corelight)

    ...at the same time, add some `TEST-REQUIRES: have-zeromq` which
    unfortunately means that developers will usually want libzmq
    installed on their system.

  * btest/coverage: Avoid warnings in test-all-policy-cluster (Arne Welzel, Corelight)

  * Broker::publish: Warn on using Broker::publish() when inactive (Arne Welzel, Corelight)

    This is mostly for transitioning base scripts to Cluster::publish() and
    avoid silent surprises why certain things don't work when using ZeroMQ.

  * Update zeek-testing and zeek-testing-cluster commit hashes (Tim Wojtulewicz, Corelight)

7.1.0-dev.760 | 2024-12-11 09:28:04 +0100

  * Update ZAM BiF-tracking (Arne Welzel, Corelight)

  * configure: Add --disable-cluster-backend-zeromq (Arne Welzel, Corelight)

  * CMakeLists: Cluster backends output (Arne Welzel, Corelight)

  * zeromq: Conditionally enable by default (Arne Welzel, Corelight)

    Instead of having ZeroMQ as a new dependency, enable the ZeroMQ backend only
    if ZeroMQ is available on the system as suggested by Tim.

  * btest/generic: Add publish_hrw(), publish_rr() and logging tests (Arne Welzel, Corelight)

    They currently use zeromq, but technically they should be valid for
    any other backend, too, even broker.

  * generate-docs: Run on Ubuntu 24.04, add cppzmq (Arne Welzel, Corelight)

  * docker: Add cppzmq/libzmq dependencies (Arne Welzel, Corelight)

  * tsan_suppressions: Add called_from_lib: libzmq (Arne Welzel, Corelight)

  * ci: Add cppzmq and libzmq to most platforms (Arne Welzel, Corelight)

  * cluster/backend/zeromq: Add ZeroMQ based cluster backend (Arne Welzel, Corelight)

    This is a cluster backend implementation using a central XPUB/XSUB proxy
    that by default runs on the manager node. Logging is implemented leveraging
    PUSH/PULL sockets between logger and other nodes, rather than going
    through XPUB/XSUB.

    The test-all-policy-cluster baseline changed: Previously, Broker::peer()
    would be called from setup-connections.zeek, causing the IO loop to be
    alive. With the ZeroMQ backend, the IO loop is only alive when
    Cluster::init() is called, but that doesn't happen anymore.

  * cluster/backend/zeromq: Add cppzmq submodule (Arne Welzel, Corelight)

    Not all supported platforms provide a recent enough cppzmq version,
    add a fallback as submodule. cppzmq is a header-only library, so there's
    no build step involved.

  * cluster: Add Cluster::node_id(), allow redef of node_topic(), nodeid_topic() (Arne Welzel, Corelight)

    This provides a way for non-broker cluster backends to override a
    node's identifier and its own topics that it listens on by default.

  * cluster: Move publish_hrw() and publish_rr() to cluster.bif (Arne Welzel, Corelight)

    From this point on, Cluster::publish_hrw() and Cluster::publish_rr()
    go through cluster/Backend.cc code.

7.1.0-dev.745 | 2024-12-10 16:15:57 -0700

  * Add btest for unknown_protocols.log (Jan Grashoefer, Corelight)

  * Add protocol_id count to unknown protocol record (Jan Grashoefer, Corelight)

    The count representation is not logged and added for access to the value
    in log policy hooks without converting the logged hex representation.

7.1.0-dev.742 | 2024-12-10 14:41:10 -0700

  * NEWS tweaks [skip ci] (Christian Kreibich, Corelight)

    - Switch list items back to "-" from "*" -- we hadn't used "*" since
      2.5.4 but started in 7.1, probably by accident? :-)

    - Fix a typo.

7.1.0-dev.740 | 2024-12-10 20:31:36 +0100

  * Update BiF-tracking, add get_current_packet_ts() (Arne Welzel, Corelight)

    Also, run the ZAM-bif-tracking test in non-ZAM environments so
    failures are caught immediately. There's nothing overly ZAM specific about
    running this test.

    I'm not sure I like the fact that any new contributor adding a BiF
    will need to dig into this... it might be a bit intimidating.

7.1.0-dev.738 | 2024-12-10 18:26:31 +0100

  * Introduce get_packet_lag() (Jan Grashoefer, Corelight)

  * Add btest for get_current_packet_ts() (Jan Grashoefer, Corelight)

  * Introduce get_current_packet_ts to fix packet lag (Jan Grashoefer, Corelight)

    Using network_time to calculate packet lag will produce wrong results
    when there is no packet available but network time does not (yet) fall
    back to wall clock.

7.1.0-dev.734 | 2024-12-10 09:56:46 +0100

  * DNS/dns_binds_rr: Fix complte to complete typo, switch to count (Arne Welzel, Corelight)

    From my reading in the docs the complete_flag should only ever be a
    single byte, so add a weird for when it is longer, but use count
    as the new type.

7.1.0-dev.732 | 2024-12-09 23:28:30 -0800

  * Support for Broker I/O backpressure overflow policies (Christian Kreibich, Corelight, and Dominik Charousset)

    - Add sleep() BiF
    - Add backpressure disconnect notification to cluster.log and via telemetry
    - Remove unneeded @loads from base/misc/version.zeek
    - Add Cluster::nodeid_to_node() helper function
    - Support re-peering with Broker peers that fall behind
    - Add Zeek-level configurability of Broker slow-peer disconnects
    - Bump Broker to pull in disconnect feature and infinite-loop fix
    - No need to namespace Cluster:: functions in their own namespace

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.1.0-dev.720 | 2024-12-09 12:22:44 -0700

  * Add missing copyright line to headers and cc files (Arne Welzel, Corelight)

  * pre-commit: Add license-header check inspired by Spicy (Arne Welzel, Corelight)

  * Add missing "COPYING" in file comments (Arne Welzel, Corelight)

    This was just done via sed. There's a number of files that don't
    have a license entry at all.

7.1.0-dev.716 | 2024-12-09 12:15:46 -0700

  * BTest baseline updates for compile-to-C++ (Vern Paxson, Corelight)

  * mark ZAM regression BTests as not suitable for compile-to-C++ (Vern Paxson, Corelight)

  * fix for -O gen-C++ maintenance helper to skip BTest intermediary files (Vern Paxson, Corelight)

  * introduced simplified initialization for non-standalone -O gen-C++ code (Vern Paxson, Corelight)
    tied -O gen-standalone-C++ to use of --optimize-files

  * streamline generated -O C++ code by relying on per-function profiles rather than aggregate profile (Vern Paxson, Corelight)

  * when reporting available/unavailble C++ script bodies, flag those that are skipped (Vern Paxson, Corelight)

  * modified AST profiling to mark (and fully skip) non-optimizable functions (Vern Paxson, Corelight)

  * modified merge_types() to skip work if given identical types, which (Vern Paxson, Corelight)
    also preserves type names (useful for -O gen-C++)

7.1.0-dev.707 | 2024-12-09 12:08:21 -0700

  * Move python signatures to a separate file (Tim Wojtulewicz, Corelight)

  * Add signatures for Python bytecode for 3.8-3.14 (Tim Wojtulewicz, Corelight)

  * Bump pre-commit hooks (Benjamin Bannier, Corelight)

  * Bump typos pre-commit hooks (Benjamin Bannier, Corelight)

    This now picks up additional typical misspellings, but also triggers on
    more identifiers we use. I opted for fixing the obvious misspellings and
    updated the allowlist for anything else.

  * Bump clang-format pre-commit hooks (Benjamin Bannier, Corelight)

    This brings in slightly better formatting around uniform initialization,
    and comments after blocks not surrounded by `{ .. }`.

7.1.0-dev.700 | 2024-12-09 14:03:29 +0100

  * ScriptOpt: Fail compilation if known exprs/stmts is outdated (Arne Welzel, Corelight)

  * skip optimization of functions with AST nodes unknown to script optimization (Vern Paxson, Corelight)

  * Disable CTU-SME test under TSAN (Arne Welzel, Corelight)

7.1.0-dev.695 | 2024-12-06 17:33:19 +0100

  * btest/http: Demo StreamEvent analyzer with HTTP::upgrade_analyzers (Arne Welzel, Corelight)

  * protocol: Add StreamEvent analyzer (Arne Welzel, Corelight)

    This analyzer can be used to transport raw stream data for a given
    connection to the script layer. For example, adding this analyzer into
    the HTTP::upgrade_analyzer or using it to configure a child WebSocket
    analyzer allows to get access to the raw stream data in script land
    when no more appropriate protocol analyzer is available.

7.1.0-dev.692 | 2024-12-06 10:22:07 +0100

  * fix for ZAM "assert" statements potentially evaluating invalid expressions (Vern Paxson, Corelight)

7.1.0-dev.689 | 2024-12-05 13:48:46 -0700

  * init-bare: Deprecate tcp_reassembler_ports (Arne Welzel, Corelight)

    ...and remove from NetVar, seems left-over.

7.1.0-dev.687 | 2024-12-05 21:43:49 +0100

  * ZAM documentation updates for asserts and event handler run-time errors (Vern Paxson, Corelight)

  * BTest updates for ZAM support of (optionally) keeping "assert" statements (Vern Paxson, Corelight)

  * command-line options for controlling script optimization: keeping asserts, (Vern Paxson, Corelight)
    avoiding event handler coalescence

  * ZAM support for option to not coalesce event handlers (Vern Paxson, Corelight)

  * ZAM support for keeping "assert" statements (Vern Paxson, Corelight)

  * internal support for script optimization options for keeping asserts, not (Vern Paxson, Corelight)
    consolidating event handlers

  * ZAM operations to support asserts (Vern Paxson, Corelight)

  * simplified "assert" by not trying to catch messages that themselves have errors (Vern Paxson, Corelight)

  * ZAM optimization now removes hook calls to hooks without any bodies (Vern Paxson, Corelight)

7.1.0-dev.676 | 2024-12-05 11:08:55 -0700

  * update of BTest that tracks number of (and validates) ZAM operations (Vern Paxson, Corelight)

  * ZAM support for pattern equality/inequality operations (Vern Paxson, Corelight)

  * expanded ZAM operations for bit-shifting to allow for int/count shift values (Vern Paxson, Corelight)

  * added type coercion for bit-shifting expressions (Vern Paxson, Corelight)

7.1.0-dev.671 | 2024-12-05 14:51:01 +0100

  * zeek-testing: Add Experiment-VM-Microsoft-Windows7AD-1 PCAP and baselines (Arne Welzel, Corelight)

    The pcap comes from the following dataset [1]:

        CTU-SME-11: a labeled dataset with real benign and malicious network
        traffic mimicking a small medium-size enterprise environment

    [1] https://zenodo.org/records/7958259

7.1.0-dev.668 | 2024-12-04 13:47:10 +0100

  * init-bare/zeek-setup: Groundwork for instantiating cluster backends (Arne Welzel, Corelight)

  * cluster/serializer: Add binary-serialization-format (Arne Welzel, Corelight)

    This is a serializer for log records that is using SerialTypes
    for serializing and un-serializing rather. Essentially, this is
    similar to what broker does except for the envelope.

  * logging/WriterFrontend: Add logic for non-broker cluster backends (Arne Welzel, Corelight)

    If cluster::backend isn't broker_mgr, use the WriterFrontend's buffering
    logic and send a whole batch of log writes during FlushWriteBuffer().
    This is a different path than broker's own logging logic.

    Preferably we adapt broker to a model where it isn't
    buffering either.

  * logging/WriterBackend: Include logging/Types.h (Arne Welzel, Corelight)

  * logging/Manager: Implement new WriteBatchFromRemote() (Arne Welzel, Corelight)

  * logging/WriterFrontend: Add LogWriteHeader as member (Arne Welzel, Corelight)

    The header captures the enum values as well as the fields

  * logging: Add filter_name to WriterInfo (Arne Welzel, Corelight)

    ...with this change, it'll be possible to identify WriterFrontend's
    based on (stream, filter_name, path) pairs in addition to (stream,
    writer, path) pairs.

7.1.0-dev.660 | 2024-12-04 11:13:58 +0100

  * GH-4077: btest/spicy.type-converter: Drop ASAN_OPTIONS from test (Arne Welzel, Corelight)

7.1.0-dev.658 | 2024-12-04 11:07:34 +0100

  * Remove obsolete c_str_safe utility (Dominik Charousset, Corelight)

    The old `c_str_safe` utility function allowed Zeek to operator on
    `broker::data` and `broker::variant`. The former grants access to actual
    `std::string` objects while the latter only provides access to fields
    via `std::string_view`. Since the Zeek formatting functions need null
    terminated strings, we need to copy the characters into a
    null-terminated container first.

    After removing support for `broker::data` and `broker::variant` from the
    same code paths, we can drop `c_str_safe` and always do the copying
    (since we are always dealing with `broker::variant` now).

  * Remove obsolete Broker compatibility layer (Dominik Charousset, Corelight)

    Since the transition to broker::variant has been long finalized, there
    is no more need to be able to go back to a pre-variant version of
    Broker. Hence, we can drop various utilities that allow Zeek to run with
    older Broker releases.

7.1.0-dev.654 | 2024-12-03 10:10:15 -0700

  * Add interval_as_double argument to control how intervals are converted to JSON (Tim Wojtulewicz, Corelight)

  * Add btest for round-trip JSON conversion (Tim Wojtulewicz, Corelight)

  * Allow comparing two PatternVals (Tim Wojtulewicz, Corelight)

  * Handle conversion between data from Val::ToJSON and ValFromJSON better (Tim Wojtulewicz, Corelight)

7.1.0-dev.649 | 2024-12-02 13:43:26 +0100

  * added new Cluster:: BiFs to script optimization tracking (Vern Paxson, Corelight)

  * added locations to ZAM run-time errors about vector size mismatches (Vern Paxson, Corelight)

7.1.0-dev.645 | 2024-12-02 10:59:04 +0100

  * fixed -O dump-final-ZAM to work in conjunction with -O no-ZAM-opt (Vern Paxson, Corelight)

7.1.0-dev.643 | 2024-12-02 09:51:10 +0100

  * Remove support for building against Spicy versions before 1.8 (Benjamin Bannier, Corelight)

    zeek-6.0 shipped with spicy-1.8, but we still have dedicated handling
    for earlier versions of Spicy in the code. This patch cleans them up
    since these versions are unsupported.

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.1.0-dev.639 | 2024-11-27 12:31:40 -0700

  * Add TEST-REQUIRES: which jq to two new tests that are using jq (Johanna Amann, Corelight)

  * Explain why modbus test does not work with the Spicy SSL analyzer (Johanna Amann, Corelight)

    This took a _long_ time to figure out.

7.1.0-dev.635 | 2024-11-27 08:29:19 +0000

  * Support setting the synchronous flag and the journal_mode for the SQLite log writer.

    These options allow for a significant speed-up of SQLite logging, at the expense
    of some data security. To change the default settings, redef the LogSQLite::synchronous
    and LogSQLite::journal_mode consts. (Mymaqn)

7.1.0-dev.629 | 2024-11-26 17:45:08 +0100

  * ci/test.sh: Run doctest with TZ=UTC (Arne Welzel, Corelight)

    Broker's JSON serialization is TZ dependent (which seems a bug). For now
    do the same as we do in btest.cfg and run doctests with TZ set to UTC.

    Reported in zeek/broker#434.

  * cluster/setup-connections: Switch to Cluster::subscribe(), short-circuit broker (Arne Welzel, Corelight)

    For the time being, this is easiest, otherwise we'd need to
    conditionally load a broker-specific policy script based on
    Cluster::backend being set.

  * cluster/serializer: Add Broker based event serializers (Arne Welzel, Corelight)

    This adds the first event serializers that use
    broker functionality. Binary and JSON formats.

  * cluster: Add Cluster scoped bifs (Arne Welzel, Corelight)

    ... and a broker based test using Cluster::publish() and
    Cluster::subscribe().

  * Reporter: Add ScriptLocationScope helper (Arne Welzel, Corelight)

  * init-bare/zeek-setup: Add Cluster::backend const &redef (Arne Welzel, Corelight)

  * broker: Implement cluster::Backend interface (Arne Welzel, Corelight)

  * Broker: Fix some error messages (Arne Welzel, Corelight)

  * broker: Remove MakeEvent(ArgsSpan) (Arne Welzel, Corelight)

    This was added previously in the 7.1 cycle. Now that MakeEvent() was
    removed from cluster::Backend, there's no need for Broker to provide
    this version.

  * Update 3dparty submodule (Johanna Amann, Corelight)

7.1.0-dev.618 | 2024-11-26 17:17:00 +0100

  * GH-4052: More robust memory management for ZAM execution - fixes #4052 (Vern Paxson, Corelight)

  * Update SQLite to 3.47.1 (Johanna Amann, Corelight)

7.1.0-dev.614 | 2024-11-26 15:25:09 +0100

  * ZeekArgs: Deprecate val_list_to_args() (Arne Welzel, Corelight)

    Fly-by deprecation for something that isn't used in-tree anymore.

7.1.0-dev.611 | 2024-11-22 18:37:37 +0100

  * btest/plugins: Add a plugin testing Init and Done hooks (Arne Welzel, Corelight)

7.1.0-dev.609 | 2024-11-22 15:29:29 +0100

  * GH-4052: Disable core.expr-execption btest under ZAM to fix CI builds (Tim Wojtulewicz, Corelight)

7.1.0-dev.607 | 2024-11-22 12:32:21 +0100

  * btest: Test Broker::make_event() together with Cluster::publish_hrw() (Arne Welzel, Corelight)

  * btest: Add cluster dir, minimal test for enum value (Arne Welzel, Corelight)

  * broker: Add shim plugin adding a backend component (Arne Welzel, Corelight)

    For broker, this isn't really functioning, but at least makes the
    CLUSTER_BACKEND_BROKER enum available.

  * zeek-setup: Instantiate backend::manager (Arne Welzel, Corelight)

    Required to allow registration of cluster components.

  * cluster: Add to src/CMakeLists.txt (Arne Welzel, Corelight)

  * cluster: Add Components and ComponentManager for new components (Arne Welzel, Corelight)

  * cluster/Backend: Interface for cluster backends (Arne Welzel, Corelight)

  * cluster/Serializer: Interface for event and log serializers (Arne Welzel, Corelight)

  * logging: Introduce logging/Types.h (Arne Welzel, Corelight)

    Header and implementation for types shared between the cluster and
    logging framework. The logging framework will be adapted later to
    use these. For now, the new cluster components will simply reference
    them.

  * SerialTypes/Field: Allow default construction and add move constructor (Arne Welzel, Corelight)

    This is in preparation of using SerialTypes to serialize and
    unserialize complete log batches which include Field instances
    and not just Value's.

  * DebugLogger: Add cluster debugging stream (Arne Welzel, Corelight)

  * plugin: Add component enums for pluggable cluster backends (Arne Welzel, Corelight)

  * broker: Pass frame to MakeEvent() (Arne Welzel, Corelight)

    This was lost in a prior change.

7.1.0-dev.592 | 2024-11-21 16:38:55 +0100

  * sumstat/non-cluster: Move last epoch processing to zeek_done() (Arne Welzel, Corelight)

    @Sheco reported that standalone epoch processing may exclude scheduled
    events when the final sumstat epoch runs before. For example, this easily
    happens when attempting to do sumstat observations within connection_state_remove().

    Delay final epoch processing to zeek_done() instead.

    This doesn't deal with the clustered version - this would need something
    more elaborate and potentially a mechanism to delay the shutdown of
    other cluster nodes until/after sumstat processing completed.

7.1.0-dev.590 | 2024-11-21 14:40:53 +0100

  * plugin: Add InitPreExecution() (Arne Welzel, Corelight)

    Currently, plugins do not have a way to further inspect or even mutate
    script functions after ZAM optimization ran. One use-case here is
    zeek-perf-support [1]. This plugin wraps Stmt instances of functions,
    events and hooks hooks with a small assembly stub to support JIT map
    files [2] and for integration with perf tools.

    This change introduces a new InitPreExecution() hook that runs after
    ZAM optimization completed, just before the zeek_init() event is enqueued.

    Additionally, remove the existing CPP_activation_hook. It doesn't seem
    to be used. If it becomes necessary in the future, the new
    InitPreExecution() hook can be leveraged instead.

    [1] https://github.com/zeek/zeek-perf-support
    [2] https://github.com/torvalds/linux/blob/master/tools/perf/Documentation/jit-interface.txt

7.1.0-dev.588 | 2024-11-21 10:22:21 +0100

  * Bump zeekjs to v0.14.0 (Arne Welzel, Corelight)

        79b0c21 version: 0.14.0
        b75b384 docker: Use Fedora 41 packages
        d65cbc8 Minor header cleanup
        4fd7e8b scripts: Remove __preload__.zeek and types.zeek
        93a8113 CreateEnvironment: Unset kOwnsProcessState and kOwnsInspector
        3b1f5d3 Instance::Init(): Replace parameters with Options struct

  * Fix documentation for `have_spicy` [skip CI] (Benjamin Bannier, Corelight)

    The continued line was incorrectly marked up (as a plain comment instead
    of a Zeekygen comment) which caused only half of the docstring to be
    rendered by Zeekygen.

7.1.0-dev.583 | 2024-11-19 19:16:51 +0100

  * Bump zeekjs to 0.13.2 (Arne Welzel, Corelight)

        41ec748 cmake: Use foreach range
        2b90a56 tests: Update new-event to run with 7.1+, remove ip_proto elsewhere
        a596f6f Makefile: Update outdated commands
        b954661 Enable `cmake/FindNodejs.cmake` to find more libnode versions

7.1.0-dev.581 | 2024-11-19 10:52:56 -0700

  * CI: Use test.sh script for running ZAM tests, but disable parts of it (Tim Wojtulewicz, Corelight)

    This ensures that the normal test setup is run, which enables greedy
    mode on Cirrus allowing us to over-provision the testing. This should
    help speed up the ZAM builds a bit.

7.1.0-dev.579 | 2024-11-18 10:13:00 -0800

  * Order rule traversal in RuleMatcher::Match() operations by Rule index (Christian Kreibich, Corelight)

7.1.0-dev.577 | 2024-11-18 09:39:05 -0800

  * Define ordering on Rule instances and use on sets in RuleMatcher (Christian Kreibich, Corelight)

7.1.0-dev.575 | 2024-11-18 17:28:18 +0100

  * communityid: Use GetField() over GetFieldAs() (Arne Welzel, Corelight)

    GetFieldAs() does not initialize an optional or default field. Apparently,
    for ZAM that makes a difference, possibly the [] record construction is
    optimized, not initializing proto until actually accessed. Not quite
    sure why that's not happening for classic script interpretation
    though.

  * btest/Baseline.zam: Updates for proto addition (Arne Welzel, Corelight)

7.1.0-dev.572 | 2024-11-16 09:34:27 -0700

  * Make debug stream names use "-", and handle "_" transparently (Christian Kreibich, Corelight)

    This looks consistent, and doesn't break any existing uses with underscores.

  * Make "-B all" apply to plugin streams as well. (Christian Kreibich, Corelight)

  * Sort streams in "-B help" output, and match case-insensitively throughout (Christian Kreibich, Corelight)

    Matching of plugins' debug streams was still case-sensitive. Also contains some
    minor output tweaks.

    It'd be nice to only list plugin debug streams actually _used_ by plugins. I
    didn't see a quick way to do that so that's for another time.

7.1.0-dev.568 | 2024-11-15 19:08:02 -0800

  * Don't forward out of the unknown IP transport analyzer (Tim Wojtulewicz, Corelight)

  * The cisco-fabric-path pcap used in tests doesn't need the -C argument (Tim Wojtulewicz, Corelight)

  * Add btests for ip_proto policy files (Tim Wojtulewicz, Corelight)

7.1.0-dev.563 | 2024-11-15 17:39:49 +0100

  * zeek-setup: Remove some unused headers (Arne Welzel, Corelight)

    The zeek_binpac.h one isn't used directly, but keeping it over
    <binpac.h> include. Also do some std prefixing. binpac.h has
    'using namespace std', so these slip through :-(

  * clang-format: Sort doctest header at the bottom (Arne Welzel, Corelight)

  * RuleMatcher: Move plugin/Manager.h include from .h to .cc (Arne Welzel, Corelight)

  * iosource/Manager: Remove superflous includes (Arne Welzel, Corelight)

  * telemetry/Manager: Remove broker header include, add fnmatch.h (Arne Welzel, Corelight)

  * logging/Manager: Fix using filename from input.h in debug log (Arne Welzel, Corelight)

    ...and remove network_time, it's always included.

  * Update external commit hashes (Arne Welzel, Corelight)

  * communityid: Do not include ports for non TCP, UDP, ICMP (Arne Welzel, Corelight)

    Checked against the result of pycommunityid. The SCTP case
    isn't quite right, because Zeek's core will not have extracted
    any ports for SCTP.

7.1.0-dev.552 | 2024-11-14 14:15:24 +0100

  * sumstats: Remove copy() for Broker::publish() calls (Arne Welzel, Corelight)

    Serialization happens immediately at Broker::publish() time, there
    should be no caching issues.

  * broker/Publish: Use event time instead of network time (Arne Welzel, Corelight)

    Discussed with @J-Gras, calling Broker::publish() within a scheduled
    should use the "intended timestamp" implicitly.

    This is subtle, but supposedly more expected when running
    a pcap replay cluster.

  * GH-3637: broker/Eventhandler: Deprecate Broker::auto_publish() for v8.1 (Arne Welzel, Corelight)

    Relates to #3637

  * btest: Remove Broker::auto_publish() usages (Arne Welzel, Corelight)

    The ones that seemed to test Broker::auto_publish() were annotated
    for removal.

  * frameworks/control: Remove Broker::auto_publish() (Arne Welzel, Corelight)

  * catch-and-release: Remove Broker::auto_publish() (Arne Welzel, Corelight)

  * ssl/validate-certs: Remove Broker::auto_publish() (Arne Welzel, Corelight)

  * sumstats: Remove Broker::auto_publish() (Arne Welzel, Corelight)

  * cluster_started: No Broker::auto_publish() use (Arne Welzel, Corelight)

  * openflow: Remove Broker::auto_publish() (Arne Welzel, Corelight)

  * dhcp: Remove Broker::auto_publish() (Arne Welzel, Corelight)

    This isn't prettier, but neither worse IMO. A test would be good.

  * frameworks/notice: Remove Broker::auto_publish() (Arne Welzel, Corelight)

  * netcontrol: Replace Broker::auto_publish() (Arne Welzel, Corelight)

    I'd think we could drop the cluster.zeek and non-cluster.zeek and
    just unconditionally do the publish(), but keeping it for now.

  * intel: Switch to Cluster::publish() (Arne Welzel, Corelight)

    This isn't quite making things a lot nicer, but more explicit.

  * broker: Support publish() of unspecified set() / table() (Arne Welzel, Corelight)

    Calling Broker::make_event(..., table()) or Broker::publish(..., table())
    caused runtime type errors as same_type() would result in false.

  * types: Fix table() resulting in table_type->IsSet() == true (Arne Welzel, Corelight)

    typename(table()) apparently always resulted in a set[] type
    being rendered. Make the yield type of an unspecified table
    ANY so that type->IsSet() ends up false.

    While at it, also render unspecified types as table(), set() and
    vector() rather than vector of void, set[] or table[] of any which
    IMO should help to figure out what's going.

7.1.0-dev.535 | 2024-11-13 17:28:09 -0800

  * CI: Use FEDORA40 crypto policy in Fedora 41 (Johanna Amann, Corelight)

  * Bump zeekjs to 0.13.0 (Arne Welzel, Corelight)

  * CI: bump FreeBSD 13 to 13.4, released in September (Christian Kreibich, Corelight)

  * CI: drop Fedora 39, add 41 (Christian Kreibich, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.1.0-dev.529 | 2024-11-13 14:36:04 -0700

  * Add NEWS entry for ip_proto feature (Tim Wojtulewicz, Corelight)

  * Move IP protocol names table out of policy script to init-bare (Tim Wojtulewicz, Corelight)

  * Minor review nits (Tim Wojtulewicz, Corelight)

  * Fixes for community ID hashing with new proto values (Tim Wojtulewicz, Corelight)

  * Use new_connection instead of connection_state_remove (Tim Wojtulewicz, Corelight)

  * Add policy script to remove ip_proto field, rename protocol naming script (Tim Wojtulewicz, Corelight)

  * Rename protocol_id field to ip_proto and similar renaming for name field (Tim Wojtulewicz, Corelight)

  * Increase size of proto fields to uint16_t, add common default value (Tim Wojtulewicz, Corelight)

  * Disable part of core/dict-iteration-expire5 btest to avoid iteration bug (Tim Wojtulewicz)

    The second set of seeds in this test trip the bug reported in #3538

  * Add conn.log entries for connections with unhandled IP protocols (Tim Wojtulewicz, Corelight)

  * CI: Add Ubuntu 24.10 (Johanna Amann, Corelight)

7.1.0-dev.516 | 2024-11-12 12:26:41 -0700

  * diff-remove-abspath: Add separate handling of Windows paths (Tim Wojtulewicz)

  * diff-remove-abspath: Remove capture of windows drive letters from POSIX regex (Tim Wojtulewicz)

7.1.0-dev.513 | 2024-11-12 16:16:11 +0100

  * Bump Spicy to current `main`. (Robin Sommer, Corelight)

7.1.0-dev.511 | 2024-11-12 16:00:00 +0100

  * PktSrc: Remove first_timestamp condition check (Arne Welzel, Corelight)

    The comment is stale and first_timestamp is only relevant/available
    in pseudo_realtime.

  * PktSrc: Fix includes (Arne Welzel, Corelight)

  * PktSrc/RunState: Scale on first_wallclock and move pseudo realtime logic to RunState (Arne Welzel, Corelight)

    check_pseudo_time() used zeek_start_time which skews things sufficiently
    around being in the past when ZAM compilation takes multiple seconds. Switch
    to using first_wallclock instead.

    Further, move setting of first_timestamp and first_wallclock from PktSrc
    into RunState's dispatch_packet(), so it's more centralized now.

    The only pseudo_realtime piece left in PktSrc() is in GetNextTimeout() to
    determine how long the PktSrc is idle until the next packet is ready.

  * RunState.h: Deprecate misleadingly named current_packet_timestamp() (Arne Welzel, Corelight)

    This returns current_pseudo, naming it current_packet_timestamp()
    is actively misleading.

  * debug: Add processing suspended/continued to debug.log (Arne Welzel, Corelight)

7.1.0-dev.505 | 2024-11-12 10:26:15 +0100

  * ZAM fixes for assignments involving "any" record fields (Vern Paxson, Corelight)

  * fixes for (mostly ZAM) vector operation issues found by ASAN (Vern Paxson, Corelight)

7.1.0-dev.501 | 2024-11-11 21:05:41 +0100

  * GH-4006: Fix nullptr deref in Spicy accept/decline input (Evan Typanski, Corelight)

    Seems like this is a continuation of #4006

  * Spicy: Improve error messages reporting malformed unit names in EVT files. (Robin Sommer, Corelight)

  * GH-3988: Spicy:: Remove unhelpful assertion. (Robin Sommer, Corelight)

    In cases of a malformed event definition, this could fire instead of a
    more helpful error message coming later.

    Closes #3988.

  * GH-4007: Spicy: Do not raise an analyzer error when a connection is missing a regular tear-down. (Robin Sommer, Corelight)

    So far, when Zeek didn't see a connection's regular tear-down (e.g.,
    because its state timed-out before we got to the end), we'd still
    signal a regular end-of-data to Spicy parsers. As a result, they would
    then typically raise a parse error because they were probably still
    expecting data and would now declare it missing. That's not very
    useful because semantically it's not really a protocol issue if the
    data just doesn't make it over to us; it's a transport-layer issue
    that Zeek already handles elsewhere. So we now switch to signaling
    end-of-data to Spicy analyzers only if the connection indeed shuts
    down regularly. This is also matches how BinPAC handles it.

    This also comes with a test exercising various combinations of
    end-of-data behavior so that we ensure consistent/desired behavior.

    Closes #4007.

7.1.0-dev.494 | 2024-11-11 10:25:43 +0100

  * ci: Run ZAM CI if src/script_opt is modified (Arne Welzel, Corelight)

    ...and rework && to || conditions.

7.1.0-dev.492 | 2024-11-11 09:52:41 +0100

  * DNS_Mgr: Remove processing of dns aliases in general (Tim Wojtulewicz, Corelight)

  * ci: Add dnsmasq to a few platforms for testing (Arne Welzel, Corelight)

  * DNS_Mgr: Fix aliases memory issues (Arne Welzel, Corelight)

  * btest: Add integration test for DNS_Mgr (Arne Welzel, Corelight)

    This makes use of an ephemeral dnsmasq instance

  * DNS_Mgr: Remove usage of ares_getsock from Lookup (Tim Wojtulewicz, Corelight)

  * DNS_Mgr: Remove usage of ares_getsock from GetNextTimeout (Tim Wojtulewicz, Corelight)

  * DNS_Mgr: Switch to ares_set_servers_csv (Tim Wojtulewicz, Corelight)

  * DNS_Mgr: Use ares_dns_record methods for queries (Tim Wojtulewicz, Corelight)

  * Update vcpkg submodule to pick up c-ares v1.34.2 (Tim Wojtulewicz, Corelight)

  * Update c-ares submodule to v1.34.2 (Tim Wojtulewicz, Corelight)

7.1.0-dev.481 | 2024-11-11 09:34:10 +0100

  * policy/community-id: Populate conn$community_id in new_connection() (Arne Welzel, Corelight)

    This wasn't possible before #3028 was fixed, but now it's safe to set
    the value in new_connection() and allow other users access to the
    field much earlier. We do not have to deal with connection_flipped()
    because the community-id hash is symmetric.

7.1.0-dev.478 | 2024-11-08 18:36:07 +0100

  * Fixed ZAM memory leak when coercing values to "any" (Vern Paxson, Corelight)

  * ci: Remove -b from test_script lines for zam tasks (Arne Welzel, Corelight)

7.1.0-dev.475 | 2024-11-08 15:35:00 +0100

  * fixes for ZAM's propagation of control flow information for some degenerate constructs (Vern Paxson, Corelight)

7.1.0-dev.473 | 2024-11-08 15:31:39 +0100

  * fixed ZAM memory leak when looping over vectors of records (Vern Paxson, Corelight)

7.1.0-dev.471 | 2024-11-08 15:22:48 +0100

  * fixed access to uninitialized memory in ZAM's "cat" built-in (Vern Paxson, Corelight)

  * GH-3906: ci: Add asan and ubsan sanitizer tasks for ZAM (Arne Welzel, Corelight)

7.1.0-dev.467 | 2024-11-06 11:50:12 +0100

  * Make Spicy hook execution order deterministic in test (Benjamin Bannier, Corelight)

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.1.0-dev.464 | 2024-11-05 17:38:41 +0100

  * Fix potential nullptr deref in Spicy plugin runtime (Benjamin Bannier, Corelight)

    If we added a file but the other side of the connection had already run
    into a protocol violation and shut down we could previously have
    dereferenced a null cookie. This patch fixes the code so it now throws
    in such scenarios.

  * Assume no Spicy cookie in most places (Benjamin Bannier, Corelight)

    We would previously assert that it was available which could have lead
    to aborts since when the analyzer for either side of a connection shuts
    down the connection cookie could get cleared and become nil. This patch
    reworks the code slightly so we now never assume it is available. We do
    this by either throwing or by making the whole operation requesting the
    cookie a noop.

7.1.0-dev.461 | 2024-11-04 19:35:21 +0100

  * btest: Add detect-sqli test script (Arne Welzel, Corelight)

    ...I added the baselines during the merge, just not the test itself.

7.1.0-dev.459 | 2024-11-04 18:47:02 +0100

  * switched CPPCompile::Canonicalize() to take std::string instead of const char* (Vern Paxson, Corelight)

7.1.0-dev.457 | 2024-11-04 16:33:14 +0100

  * minor ZAM BTest updates for recently added fnv1a64 BiF (Vern Paxson, Corelight)

7.1.0-dev.455 | 2024-11-04 16:32:37 +0100

  * RuleMatcher: Use a single list for tracking pattern_matches (Arne Welzel, Corelight)

  * ZeekString: Implement move constructor (Arne Welzel, Corelight)

  * Bump and reenable spicy-format pre-commit hook (Benjamin Bannier, Corelight)

  * Add test for TCP over 802.3/SNAP (Johanna Amann, Corelight)

    This admittedly is a quite esoteric combination of protocols. But - as
    we do correctly support them, it seems nice to have a slightly more
    complete testcase that covers this.

7.1.0-dev.447 | 2024-10-30 14:52:40 +0100

  * CI: Upgrade FreeBSD 14 to 14.1 (Evan Typanski, Corelight)

  * CI: Add Ubuntu Clang task (Evan Typanski, Corelight)

    This feels more like a band-aid solution - it still requires very manual
    intervention to get the next builds, but at least this way we don't rely
    on whatever Clang/libc++ happens to ship with FreeBSD for the only
    libc++ testing. It seems like sanitizer builds don't use libc++, but I'd
    rather a dedicated Linux/Clang/libc++ task at least.

  * Fix up minor warnings in touched files (Evan Typanski, Corelight)

  * GH-3994: Fix Clang 19 deprecation failure (Evan Typanski, Corelight)

    Fixes #3994

    Clang 19 with libc++ started failing to compile because the default
    implementation of `std::char_traits` was removed, making uses of
    `std::char_traits<unsigned char>` invalid. This was more of used for
    convenience before, but it should be roughly the same behavior with
    `char`.

    See relevant LLVM commits:

    https://github.com/llvm/llvm-project/commit/aeecef08c385b1e4955155dd649a2d3724463849

    https://github.com/llvm/llvm-project/commit/08a0faf4cd32bce6c51027ea9b5ec351747995b4

7.1.0-dev.442 | 2024-10-30 14:43:18 +0100

  * pre-commit-config: Disable spicy-format (Arne Welzel, Corelight)

    This fails to install currently: bbannier/spicy-format#157

7.1.0-dev.441 | 2024-10-30 14:36:57 +0100

  * GH-3984: Fix issues with Modbus message logging (Emmanuele Zambon)

    This commit fixes three issues with Zeek's Modbus message logging:

    1 - Some exception responses (e.g., READ_COILS_EXCEPTION) are logged
        twice: once without and once with the exception message.
    2 - Some exception responses (e.g., PROGRAM_484_EXCEPTION) are not
        logged.
    3 - Some known but reserved function codes (e.g., PROGRAM_UNITY) are
        logged as unk-xxx (e.g., unk-90), while it would be possible to
        log their known name.

    To address these inconsistencies, the modbus parser has been updated
    to parse all exception responses (i.e., all responses where the MSB
    of the function code is set) using the already defined Exception
    message.
    Also, the Modbus main.zeek script has been updated to consistently
    demand logging exception responses to the specialized
    modbus_exception event, rather than logging some exception responses
    in the modbus_message event and others in the modbus_exception event.
    Finally, the main.zeek script has been updated to make sure that
    for every known function code, the corresponding exception code was
    also present, and the enumeration of known function codes in
    consts.zeek has been expanded.

    Closes #3984

7.1.0-dev.439 | 2024-10-30 14:33:48 +0100

  * signatures: Add data_end_offset to signature_match() and custom events (Arne Welzel, Corelight)

    This change tracks the current offset (number of bytes fed into matchers)
    on the top-level RuleEndpointState such that we can compute the relative ending
    for matched texts individually.

    Additionally, it adds the data_end_offset as a new optional parameter to
    signature_match().

  * Add pattern_end_offset to signature_state (ronny8360988)

7.1.0-dev.436 | 2024-10-30 11:47:53 +0000

  * modbus: Skip non-modbus traffic testing with Spicy SSL (Arne Welzel, Corelight)

    With Spicy SSL, there's no SSL conn.log produced.

  * testing: Add have-spicy-ssl helper and update tests (Arne Welzel, Corelight)

  * Improvements in FNV1A hash functions (Martin van Hensbergen)

    - Add FNV1a64 hash function
    - make hash function type aware
    - add unit tests

7.1.0-dev.430 | 2024-10-29 14:08:25 +0100

  * account for spaces encoding to plus signs in sqli regex detection (Cooper Grill)

7.1.0-dev.428 | 2024-10-29 13:50:05 +0100

  * fixed "-O gen-C++" naming of "when" captures to avoid ambiguities due to inlining (Vern Paxson, Corelight)

    	Previously there was logic for doing this, but it was ineffectual
    	due to the order in which canonicalization was done. This problem
    	manifested non-deterministically depending on order-of-generation
    	of "when" lambdas, which is why previous testing didn't catch it.

  * Simplified & made more robust maintenance helper script for "-O gen-C++" testing (Vern Paxson, Corelight)

  * "-a cpp" baseline updates to reflect recent BTest changes (Vern Paxson, Corelight)

7.1.0-dev.423 | 2024-10-24 07:08:45 -0700

  * Telemetry framework: move BIFs to the primary-bif stage (Christian Kreibich, Corelight)

  * Minor comment tweaks for init-frameworks-and-bifs.zeek (Christian Kreibich, Corelight)

7.1.0-dev.420 | 2024-10-23 05:49:31 -0700

  * Update broker submodule (Christian Kreibich, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.1.0-dev.418 | 2024-10-22 19:04:22 +0200

  * btest/telemetry: Fix "Note compilable" typo (Arne Welzel, Corelight)

  * misc/stats: Add zeek_net_timestamp_seconds (Arne Welzel, Corelight)

    Adding a metric for the network time value itself should make it
    possible to observe it stopping or growing slowly as compared to
    realtime when Zeek isn't able to keep up.

    Also, modify the telemetry/log.zeek test to include misc/stats and
    log at a higher frequency with a more interesting pcap.

  * telemetry/Manager: Remove variant include (Arne Welzel, Corelight)

  * GH-3947: telemetry: Invoke Telemetry::sync() only at scrape/collection time (Arne Welzel, Corelight)

    This stops invoking Telemetry::sync() via a scheduled event and instead
    only invokes it on-demand. This makes metric collection network time
    independent and lazier, too.

    With Prometheus scrape requests being processed on Zeek's main thread
    now, we can safely invoke the script layer Telemetry::sync() hook.

7.1.0-dev.413 | 2024-10-22 11:24:50 +0200

  * GH-3978: Bump zeekjs to 0.12.1 (Arne Welzel, Corelight)

        7ec0953 ci: Bump actions/upload-artifact
        8e5914d ci/docker: Bump distros, update some OBS repos
        129b737 Fix crash during shutdown

7.1.0-dev.410 | 2024-10-21 15:51:05 +0200

  * GH-3962: Prevent non-Modbus on port 502 to be reported as Modbus (Emmanuele Zambon)

    This commit prevents most non-Modbus TCP traffic on port 502 to be
    reported as Modbus in conn.log as well as in modbus.log.
    To do so, we have introduced two &enforce checks in the Modbus
    protocol definition that checks that some specific fields of the
    (supposedly) Modbus header are compatible with values specified in
    the specs.

    To ensure non-regression, with this commit we also introduce a
    new btest.

    Closes #3962

7.1.0-dev.408 | 2024-10-18 17:51:04 -0700

  * factored CPP source's main header into collection of per-source-file headers (Vern Paxson, Corelight)

  * renamed script optimization Attrs.h header to prepare for factoring large Compile.h (Vern Paxson, Corelight)

  * factored ZAM source's main header into collection of per-source-file headers (Vern Paxson, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.1.0-dev.403 | 2024-10-18 09:55:20 -0700

  * Fix installation of Python packages in generate docs CI job again (Benjamin Bannier, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.1.0-dev.400 | 2024-10-15 17:11:57 +0200

  * Fix invalid Sphinx directive in docstring (Benjamin Bannier, Corelight)

  * Bump GH actions for generate-docs job (Benjamin Bannier, Corelight)

  * Fix installation of Python packages in generate docs CI job (Benjamin Bannier, Corelight)

  * Bump GH actions for pre-commit job (Benjamin Bannier, Corelight)

  * Pin distribution for pre-commit CI job (Benjamin Bannier, Corelight)

7.1.0-dev.393 | 2024-10-15 09:56:19 +0200

  * Test `.evt` file `&priority` (Evan Typanski, Corelight)

    This was not documented nor tested, so this tests the behavior.
    Documentation should be added later.

7.1.0-dev.390 | 2024-10-09 15:36:41 -0700

  * removed specialized ZAM instructions for GTPv1 and Teredo cleanup BiFs (Vern Paxson, Corelight)

7.1.0-dev.388 | 2024-10-09 15:36:09 -0700

  * -a zam baseline updates reflecting recent changes to main baselines (Vern Paxson, Corelight)

7.1.0-dev.386 | 2024-10-09 14:26:35 -0700

  * GH-3957: input/Raw: Rework GetLine() (Arne Welzel, Corelight)

  * GH-215: POP3: Rework unbounded pending command fix (Arne Welzel, Corelight)

7.1.0-dev.383 | 2024-10-04 12:45:05 -0700

  * Bump zeek-testing-cluster to pull in a baseline update (Christian Kreibich, Corelight)

7.1.0-dev.381 | 2024-10-04 19:31:36 +0200

  * GH-3949: Fix flaky `missing-file-initially` test (Evan Typanski, Corelight)

    That test got flaky probably from #3949 on centosstream9 CI. You can
    replicate that behavior by increasing the sleep time when waiting for
    the file such that the test will attempt to read the missing file again.
    Since the one second wait for file is glacially slow for this, speeding
    it up should mean that the file gets created sooner and so the test
    won't try to open the file again. But, it's always still technically
    possible, since the test will wait for 10 seconds and the heartbeat
    seems to be 1 second. At least if that happens, it's probably a bug or
    massive slowdown of some kind.

7.1.0-dev.379 | 2024-10-04 13:34:31 +0200

  * Add missing newline in `spicyz` usage message (Benjamin Bannier, Corelight)

7.1.0-dev.377 | 2024-10-02 20:17:28 +0200

  * Fix input error test nondeterminism (Evan Typanski, Corelight)

    It seems like other similar tests get by because they have more "stuff"
    before they call `terminate()` most likely. But, to be safe, just
    removing the "received termination signal" line seems like the best
    approach.

7.1.0-dev.375 | 2024-10-01 11:40:16 +0200

  * Report suppressed warnings count (Evan Typanski, Corelight)

    This also triggers if there is one warning, which seems a little weird,
    but it seems mostly reasonable.

  * GH-3692: Avoid duplicating warnings when reading table (Evan Typanski, Corelight)

    Invalid lines in a file was the one case that would not suppress future
    warnings. Just make it suppress warnings too, but clear that suppression
    if there is a field in between that doesn't error.

    Fixes #3692

7.1.0-dev.371 | 2024-09-27 15:17:04 -0700

  * A round of ZAM/gen-C++-related updates and fixes (Vern Paxson, Corelight)

    - factoring of logic used by ZAM's low-level optimizer when adjusting control flow info
    - BTest baseline update for more complete function/lambda names
    - tweak to -O gen-C++ maintenance script to avoid treating plugins as BTests
    - fixed lambda hash collision bug due to function descriptions lacking full parameter information
    - fixes (to avoid collisions) for AST profiling's function hash computations
    - removed unused ZAM cast-to-any operation
    - fixes for ZAM tracking the return type associated with function calls
    - ZAM control-flow tracking now explicitly includes the ends of loops
    - fix for ZAM identification of common subexpressions
    - "-O dump-final-ZAM" option similar to "dump-ZAM" only prints final version of functions
    - fix for setting object locations to avoid use-after-free situation
    - extended "-O allow-cond" to apply to both gen-C++ and gen-standalone-C++
    - -O gen-C++ fix for run-time warnings for "when" lambdas
    - fix to -O gen-C++ for recent AST profiling changes for identifying function parameters
    - fix to -O gen-C++ for dealing with "hidden" parameters
    - tweak to prevent an incorrect warning for scripts compiled to C++
    - fixed overly narrow Spicy test for manipulating packet analyzers
    - fixed memory leak for recursive ZAM functions that exit via an exception
    - remove unnecessary header include

7.1.0-dev.351 | 2024-09-27 16:47:39 +0200

  * Honor no plaintext password logging for PASS cmd (Martin van Hensbergen)

7.1.0-dev.349 | 2024-09-27 15:37:13 +0200

  * NEWS: Update (Arne Welzel, Corelight)

  * scripts/base/cluster: Move active node management into node_down() (Arne Welzel, Corelight)

    With the idea of an alternative cluster backend, we should
    not maintain Cluster state within low-level Broker events.

  * logging/Manager: Extract another CreateWriter() helper (Arne Welzel, Corelight)

    For other cluster backends, CreateWriter() will use a logger's filter
    configuration rather than receiving all configuration through CreateLog.
    Extract a helper out from WriteToFilters() for reuse.

  * logging/Manager: Extract path_func invocation into helper (Arne Welzel, Corelight)

  * logging: Dedicated log flush timer (Arne Welzel, Corelight)

    Log flushing is currently triggered based on the threading heartbeat timer
    of WriterBackends and the hard-coded WRITE_BUFFER_SIZE 1000.

    This change introduces a separate timer that is managed by the logger
    manager instead of piggy-backing on the heartbeat timer, as well as a
    const &redef for the buffer size.

    This allows to modify the log flush frequency and batch size independently
    of the threading heartbeat interval. Later, this will allow to re-use the
    buffering and flushing logic of writer frontends for non-Broker cluster
    backends, too.

    One change here is that even frontends that do not have a backend will
    be flushed regularly. This is wanted for non-Broker backends and should be
    very cheap. Possibly, Broker can piggy back on this timer down the road, too,
    rather than using its own script-level timer (see Broker::log_flush()).

  * all: Change to use Func::GetName() (Arne Welzel, Corelight)

  * script_opt: Use Func::GetName() (Arne Welzel, Corelight)

  * Func: Add std::string name accessors, deprecate const char* versions (Arne Welzel, Corelight)

  * plugin/ComponentManager: Support lookup by EnumValPtr (Arne Welzel, Corelight)

7.1.0-dev.339 | 2024-09-27 14:59:45 +0200

  * zeek-setup: Support enabling debug streams through env variable (Arne Welzel, Corelight)

    For debugging btests, it can be convenient to enable debug streams
    by setting an environment variable rather than editing zeek invocations
    and adding -B selectively.

    Sample use case:

        $ export ZEEK_DEBUG_LOG_STREAMS=all
        $ btest -d core/failing-test.zeek
        $ less .tmp/core/failing-test/debug.log

    This change makes Zeek's -B option and ZEEK_DEBUG_LOG_STREAMS are additive.

  * Install `procps` in OpenSuse Leap images (Benjamin Bannier, Corelight)

    The tests `core.sigterm-regular` and `core.sigterm-stdin` rely on `ps`
    to be present which is not the case anymore on OpenSuse Leap; install it
    explicitly there.

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.1.0-dev.332 | 2024-09-23 10:59:51 -0700

  * pop3: Remove unused headers (Arne Welzel, Corelight)

  * pop3: Prevent unbounded state growth (Arne Welzel, Corelight)

    The cmds list may grow unbounded due to the POP3 analyzer being in
    multiLine mode after seeing `AUTH` in a Redis connection, but never
    a `.` terminator. This can easily be provoked by the Redis ping
    command.

    This adds two heuristics: 1) Forcefully process the oldest commands in
    the cmds list and cap it at max_pending_commands. 2) Start raising
    analyzer violations if the client has been using more than
    max_unknown_client_commands commands (default 10).

    Closes #3936

  * btest/pop3: Add somewhat more elaborate testing (Arne Welzel, Corelight)

    PCAP taken from here: https://tranalyzer.com/tutorial/pop and reference
    added to Traces/README.

7.1.0-dev.328 | 2024-09-18 19:10:43 +0200

  * Add enum value negative check (Evan Typanski, Corelight)

    There was one already at parse time, this adds a check later so that
    cases like overflows or internal enums with negative values get caught.

  * Fix port/enum values `SizeOf` not being a count (Evan Typanski, Corelight)

    Really, they both should be count. But, they were getting provided as an
    integer. Port is easy since it is backed by an unsigned value. Enums
    *should* be unsigned, but aren't. This doesn't address that, it just
    takes the other name for this operator (absolute value) and makes the
    enum value positive if it's negative.

    This fixes a case where using the size of operator on enum/port values
    in certain contexts (like the default parameter of a struct) would cause
    an internal error.

7.1.0-dev.324 | 2024-09-17 18:51:34 +0200

  * btest: Update baselines for removal-hooks addition (Arne Welzel, Corelight)

    The removal_hooks field exists in bare mode (seems fine) and moved within the
    connection record to earlier, so a bunch of baselines changed

  * gtpv1: Replace connection_state_remove() with RemovalHook (Arne Welzel, Corelight)

  * teredo: Replace connection_state_remove() with RemovalHook (Arne Welzel, Corelight)

    Remove overhead of unconditionally calling remove_teredo_connection()
    for *every* connection by installing a connection removal hook for only
    when state was allocated.

  * teredo: Move conn member from analyzer to encapsulation (Arne Welzel, Corelight)

    There's only a single instance of the Teredo analyzer. Mutating the conn
    member for every new packet and leaving it set after processing the
    packet is confusing. Move conn into TeredoEncapsulation instead, or pass
    it explicitly.

7.1.0-dev.319 | 2024-09-17 18:50:40 +0200

  * Update broker submodule (Arne Welzel, Corelight)

    ...to pin prometheus to 1.2.4

  * telemetry: Move callbacks to Zeek (Arne Welzel, Corelight)

    Now that we run callbacks on the main loop, we can move callback support
    for Counter and Gauge instances directly into Zeek and don't need to patch
    prometheus-cpp anymore.

  * auxil/prometheus-cpp: Pin to 1.2.4 (Arne Welzel, Corelight)

7.1.0-dev.315 | 2024-09-12 09:18:35 +0200

  * Update Dockerfile to avoid LegacyKeyValueFormat warning (MP-Corelight)

  * Fix potential endless loop in util::strreplace (Tim Wojtulewicz, Corelight)

7.1.0-dev.311 | 2024-09-12 08:52:02 +0200

  * Remove core.negative-time btest (Tim Wojtulewicz, Corelight)

    This test is failing with libpcap libpcap 1.10; for more information
    see https://github.com/zeek/zeek/issues/3921

7.1.0-dev.309 | 2024-09-12 08:51:08 +0200

  * Bump spicy-format to 0.16.2 (Johanna Amann, Corelight)

  * Spicy SSL: reformat with new version of spicy format (Johanna Amann, Corelight)

7.1.0-dev.305 | 2024-09-11 16:55:55 +0200

  * Spicy SSL analyzer:

    This commit adds an alternative Spicy-based SSL analyzer. It supports
    nearly the entire functionality of the current binpac analyzer, with
    the exception of DTLS and decryption.

    This currently is mostly for internal tests, or for Spicy testing purposes.
    There is no functional advantage to use the Spicy based analyzer - it does
    not have any additional features.

    It is currently gated behind a configure-time flag that needs to be provided
    to enable it (--enable-spicy-ssl).

7.1.0-dev.259 | 2024-09-09 13:24:45 +0200

  * script_opt/ZAM/IterInfo.h: Add missing Dict.h dependency (Arne Welzel, Corelight)

    Triggered when trying to remove some other includes elsewhere.

  * script_opt/ZAM: ZBody.h / Support.h: Cleanup includes, use forward declarations (Arne Welzel, Corelight)

    Not sure the IsAny() convenience functions were really worth the
    include zeek/Expr.h.

  * script_opt/ZAM/Profile: Remove Zeek header includes (Arne Welzel, Corelight)

    This can stand by itself.

  * script_opt: Extend Support.h to break include dependencies (Arne Welzel, Corelight)

    Rebuilding ZBody.cc is annoyingly slow with UBSAN or ASAN enabled. A rebuild
    is currently triggered when touching Manager.h files like logging/Manager.h,
    broker/Manager.h or file_analysis/Manager.h and various other headers that are
    included from there or directly in ZBody.h.

    Add tiny wrapper functions to Support.h that encapsulate the actual Zeek
    functionality and move the includes to Support.cc instead. This will
    cause frequent Support.cc rebuilds, but that is decently fast.

    This comes at the expense of one indirect function call for some ops, but
    its overhead should be negligible in comparison to a lookup for a
    connection or component or a log_mgr->Write() call.

  * script_opt: Do not include ZBody.h in ZAM/Validate.cc (Arne Welzel, Corelight)

    Touching broker/Manager.h or logging/Manager.h or anything that's
    included in ZBody.h results in a rebuild of a bunch of files in ZAM.
    Particularly, ZAM/Validate.cc takes much too long to recompile for
    me (45+ seconds) and apparently that's mostly by accident.

    Clean up the ZAM/Validate.cc includes to prevent this.

7.1.0-dev.252 | 2024-09-06 19:17:29 +0200

  * btest/ldap: Add regression test for #3919 (Arne Welzel, Corelight)

    This works as expected in master, it's just that we forgot to backport
    PR #3845 to 7.0.1. Add the PCAP from Martin anyhow.

    Closes #3919.

7.1.0-dev.250 | 2024-09-06 17:47:36 +0200

  * postgresql: Simplify SSL buffering and forwarding (Arne Welzel, Corelight)

    The ssl_sink can only be connected form the backend side, so don't
    overcomplicate it.

  * postgresql: Initial parser implementation (Arne Welzel, Corelight)

    This adds a protocol parser for the PostgreSQL protocol and a new
    postgresql.log similar to the existing mysql.log.

    This should be considered preliminary and hopefully during 7.1 and 7.2
    with feedback from the community, we can improve on the events and logs.
    Even if most PostgreSQL communication is encrypted in the real-world, this
    will minimally allow monitoring of the SSLRequest and hand off further
    analysis to the SSL analyzer.

    This originates from github.com/awelzel/spicy-postgresql, with lots of
    polishing happening in the past two days.

7.1.0-dev.247 | 2024-09-05 19:19:31 +0200

  * testing/external: Update private baselines (Arne Welzel, Corelight)

  * analyzer/syslog: Reformat with spicy-format (Arne Welzel, Corelight)

  * analyzer/finger: Reformat with spicy-format (Arne Welzel, Corelight)

  * scripts/spicy: Reformat with spicy-format (Arne Welzel, Corelight)

  * pre-commit: Add spicy-format (Arne Welzel, Corelight)

    This excludes the larger protocol analyzers. These should be formatted
    during the 7.2 cycle, shortly before 8.0.

7.1.0-dev.241 | 2024-09-04 14:53:19 -0700

  * Check for netbios to avoid reporting extra bad DNS opcodes (Tim Wojtulewicz, Corelight)

  * Add weird for unhandled opcodes in DNS analyzer (Tim Wojtulewicz, Corelight)

7.1.0-dev.238 | 2024-09-03 09:03:24 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.1.0-dev.236 | 2024-09-03 10:18:32 +0200

  * Remove pre-commit exclusions for clang-format (Benjamin Bannier, Corelight)

    We previously would ignore any files under `auxil/`. Since pre-commit
    only formats files tracked in this repo, and `auxil/` today contains
    only submodules this exclusion did not exclude anything; if however we
    ever end up adding C++ files under `auxil/` we would like them to be
    formatted consistently.

  * Bump clang-format (Benjamin Bannier, Corelight)

    This patch contains a bump of the configured clang-format version from
    17.0.3 to 18.1.8 and automatically generated C++ source updates. The
    main difference we are seeing from this is fixes for previously
    incomplete reformats.

7.1.0-dev.233 | 2024-09-03 10:02:59 +0200

  * Bump zeek-aux for zeek/zeek-aux#57 (Arne Welzel, Corelight)

7.1.0-dev.232 | 2024-08-30 18:56:24 +0200

  * http: fix password capture when enabled (Pierre Lalet)

    The current implementation would only log, if the password contains a
    colon, the part before the first colon (e.g., the password
    `password:password` would be logged as `password`).

    A test has been added to confirm the expected behaviour.

7.1.0-dev.230 | 2024-08-30 15:38:52 +0200

  * RunState: Drop broker_mgr->Active() usage (Arne Welzel, Corelight)

    ...and deprecate it. The communication_enabled flag doesn't really
    make a difference in how the IO loop works.

  * logging/WriterFrontend: No need for explicit CleanupWriteBuffer() (Arne Welzel, Corelight)

    Any pending records will be cleaned in the destructor of WriterFrontend
    and WriteBuffer, no need to do this explicitly.

  * logging: Switch index-assignment of raw pointers to emplace_back() (Arne Welzel, Corelight)

  * broker/logging: Change threading::Value** usage std::vector instead (Arne Welzel, Corelight)

    This allows to leverage automatic memory management, less allocations
    and using move semantics for expressing ownership.

    This breaks the existing logging and broker API, but keeps the plugin
    DoWrite() and HookLogWrite() methods functioning.

    It further changes ValToLogVal to return a threading::Value rather than
    a threading::Value*. The vector_val and set_val fields unfortunately
    use the same pointer-to-array-of-pointers approach. this can'tbe changed
    as it'd break backwards compatibility for plugin provided input readers
    and log writers.

  * threading/Value: Support move and copy constructors (Arne Welzel, Corelight)

7.1.0-dev.222 | 2024-08-27 13:29:12 +0100

  * Fix parsing of version field in SSLv2 client hello (Johanna Amann, Corelight)

    It turns out that, for probably a long time, we have reported an
    incorrect version when parsing an SSLv2 client hello. We always reported
    this as SSLv2, no matter which version the client hello actually
    contained.

    This bug probably went unnoticed for a long time, as SSLv2 is
    essentially unused nowadays, and as this field does not show up in the
    default logs.

    This was found due to a baseline difference when writing the Spicy SSL
    analyzer.

7.1.0-dev.219 | 2024-08-23 14:18:35 +0200

  * Analyzer: Do not add child analyzers when finished (Arne Welzel, Corelight)

    Depending on an analyzer's implementation, its Done() method may
    attempt to access analyzer or connection state when executing.
    When this happens in the destructor of the parent analyzer during
    the process of destructing a connection, this state may have been
    deleted, resulting in use-after-free crashes or worse memory
    corruption.

    The following cases have been observed in the wild for when this happens.

      * PIA matching during Done() for undelivered TCP data enables a Spicy
        based analyzer which in turn attempts to raise an analyzer violation
        during Done()->EndOfData().

      * Spicy analyzers attaching new analyzers during their Done() processing
        which in turn attempt to use TCP() (to call FindChild()) during Done()
        while the analyzer tree / connection is being destructed.

    The second scenario was previously found to happen in the HTTP analyzer
    and fixed with 6ef9423f3cff13e6c73f97eb6a3a27d6f64cc320.

    Plug these scenarios by short-circuiting AddChildAnalyzer() if the analyzer
    or connection have finished or are being finished.

7.1.0-dev.217 | 2024-08-23 09:40:53 +0200

  * TCP_Reassembler: Fix IsOrig() position in Match() call (Arne Welzel, Corelight)

    Found during a debug session with @rsmmr. Undelivered TCP data
    would only be matched for the responder and eol set to IsOrig().

  * Spicy: Register well-known ports through an event handler. (Robin Sommer, Corelight)

    This avoids the earlier problem of not tracking ports correctly in
    scriptland, while still supporting `port` in EVT files and `%port` in
    Spicy files.

    As it turns out we are already following the same approach for file
    analyzers' MIME types, so I'm applying the same pattern: it's one
    event per port, without further customization points. That leaves the
    patch pretty small after all while fixing the original issue.

  * Revert "Remove deprecated port/ports fields for spicy analyzers" (Robin Sommer, Corelight)

    This reverts commit 15d404dd191a723960e4efd956eec22739d3f1c2.

7.1.0-dev.211 | 2024-08-20 11:38:48 +0100

  * Make ssl_history work for SSLv2 handshakes/connections (Johanna Amann, Corelight)

    It turns out that the ssl_history field never was populated with C/S for
    SSLv2 connections, or connections using the SSLv2 handshake. In our
    testcases, the latter is especially common - with connections up to TLS1
    using the old SSLv2 client hello for backwards compatibility.

    This change resolves this issue. As the history is not by default
    enabled in a lot of locations, baseline impact is minor.

7.1.0-dev.209 | 2024-08-20 10:10:46 +0200

  * broker: Deprecate MakeEvent(ValPList*) (Arne Welzel, Corelight)

    The variadic broker messaging BIFs currently convert @ARGS@ into a
    ValPList before passing it on to MakeEvent(). This appears historic
    plumbing. Implement the same functionality using Span<const ValPtr>
    and do the extra copying in the now deprecated MakeEvent().

    Further, make passing a frame optional as not all callers may
    have one available.

  * Span: Remove deduction guideline for Iter, Iter, include cleanup (Arne Welzel, Corelight)

    We don't have a constructor for that, so that's confusing, also
    <array> isn't used.

  * ScriptOpt: Ensure global statements have non-null scope (Arne Welzel, Corelight)

    The ProfileFunc() logic assumed that GetScope() returned a non-nullptr.
    This holds except for the synthetic global statements function.

    Fix the latter and add an assert, also add a name to the type so it's
    easier to recognize in a debugger what's going on, otherwise the name
    is "".

    This was found by UBSAN due to it seeing the ->OrderedVars() call on a
    nullptr. Elsewhere, num_params == 0 shielded from that access and so
    didn't lead to crashes.

  * Update gen-zam submodule [nomail] [skip ci] (Tim Wojtulewicz, Corelight)

7.1.0-dev.202 | 2024-08-16 09:06:41 -0700

  * Remove unused wrapper packet analyzer (Jan Grashoefer, Corelight)

    This is a leftover from the migration to the packet analysis framework.
    The analyzer wrapped the original packet analysis code for comparison.

7.1.0-dev.200 | 2024-08-16 16:50:47 +0200

  * Add DNS TKEY event (Evan Typanski, Corelight)

7.1.0-dev.198 | 2024-08-16 12:10:00 +0200

  * simpler and more robust identification of function parameters for AST profiling (Vern Paxson, Corelight)

  * fixes to limit AST traversal in the face of recursive types (Vern Paxson, Corelight)

  * address some script optimization compiler warnings under Linux (Vern Paxson, Corelight)

  * fix for -O C++ construction of variable names that use multiple module namespaces (Vern Paxson, Corelight)

  * fix for script optimization of "opaque" values that are run-time constants (Vern Paxson, Corelight)

  * fix for script optimization of nested switch statements (Vern Paxson, Corelight)

  * script optimization fix for complex "in" expressions in conditionals (Vern Paxson, Corelight)

  * updates to typos allow-list reflecting ZAM regularization changes (Vern Paxson, Corelight)

  * BTest updates for ZAM regularization changes (Vern Paxson, Corelight)

  * convert new ZAM operations to use typed operands (Vern Paxson, Corelight)

  * complete migration of ZAM to use only public ZVal methods (Vern Paxson, Corelight)

  * "-O validate-ZAM" option to validate generated ZAM instructions (Vern Paxson, Corelight)

  * internal option to suppress control-flow optimization (Vern Paxson, Corelight)

  * exposing some functionality for greater flexibility in structuring run-time execution (Vern Paxson, Corelight)

  * rework ZAM compilation of type switches to leverage value switches (Vern Paxson, Corelight)

  * add tracking of control flow information (Vern Paxson, Corelight)

  * factoring of ZAM operation specifications into separate files (Vern Paxson, Corelight)

  * updates to ZAM operations / gen-zam regularization, other than the operations themselves (Vern Paxson, Corelight)

  * type-checking fix for vector-of-string operations (Vern Paxson, Corelight)

  * ZVal constructor for booleans (Vern Paxson, Corelight)

  * fix for nit in base/protocols/krb/main.zeek (Vern Paxson, Corelight)

  * mark functions skipped by ZAM compilation as such (Vern Paxson, Corelight)

  * fix for avoiding inadvertent interpreter errors in CallExpr::IsPure() (Vern Paxson, Corelight)

  * support for traversing ZAM code similar to AST traversal (Vern Paxson, Corelight)

  * run-time warnings for scripts compiled to C++ (Vern Paxson, Corelight)

  * allow C++ script compiler access to type internals (Vern Paxson, Corelight)

  * fixes for script optimization of coerce-to-any expressions (Vern Paxson, Corelight)

  * fix to correctly track whether a capture needs deep-copying (Vern Paxson, Corelight)

  * fix for -O report-C++ (Vern Paxson, Corelight)

  * support for more in-depth AST profiling (Vern Paxson, Corelight)

  * allow profiling without updating of hash values (Vern Paxson, Corelight)

  * ListVal method to clear the list to allow reusing w/o new construction (Vern Paxson, Corelight)

  * accessor for smart-pointer version of FileVal's value (Vern Paxson, Corelight)

7.1.0-dev.164 | 2024-08-15 10:30:37 +0200

  * Func: Add SetCapturesVec() (Arne Welzel, Corelight)

    Add an API to directly set captures_vec for use by C++ compilation. The
    current code keys off or asserts on ZAM stmts, making it difficult to
    leverage captures_vec in other contexts.

  * marked some recently added BTests as not suitable for -O gen-C++ testing (Vern Paxson, Corelight)

  * robustness improvements for -O gen-C++ generation of lambdas / "when"s (Vern Paxson, Corelight)

  * speedups for compilation of initializers in -O gen-C++ generated code (Vern Paxson, Corelight)

  * fixes for -O gen-C++ generation of floating point constants (Vern Paxson, Corelight)

  * -O gen-C++ fix for dealing with use of more than one module qualifier (Vern Paxson, Corelight)

  * header tweaks to provide gen-C++ script optimization with more flexibility (Vern Paxson, Corelight)

  * fix for script optimization of constants of type "opaque" (Vern Paxson, Corelight)

  * fix for script optimization of "in" operations (Vern Paxson, Corelight)

  * some minor tidying of -O gen-C++ sources (Vern Paxson, Corelight)

7.1.0-dev.152 | 2024-08-14 20:08:14 +0200

  * mysql: Implement and test COM_CHANGE_USER (Arne Welzel, Corelight)

    This reworks the parser such that COM_CHANGE_USER switches the
    connection back into the CONNECTION_PHASE so that we can remove the
    EXPECT_AUTH_SWITCH special case in the COMMAND_PHASE. Adds two pcaps
    produced with Python that actually do COM_CHANGE_USER as it seems
    not possible from the MySQL CLI.

  * mysql: Remove auth plugin state (Arne Welzel, Corelight)

    Now that we use CONNECTION_PHASE and interpret AuthSwitchRequest
    correctly, we can remove reliance on the plugin discrepancy to
    determine expectations.

  * GH-3880: mysql: Handle server connection phase separately from command phase (Arne Welzel, Corelight)

    This avoids interpreting an AuthSwitchRequest (0xfe) during the command
    phase as EOF_Packet.

    Thanks @AmazingPP.

    Closes #3880

7.1.0-dev.147 | 2024-08-13 12:37:17 +0200

  * Deprecate old unknown_protocol event signature (Jan Grashoefer, Corelight)

  * Use raw pointer for packet analyzer history (Jan Grashoefer, Corelight)

  * Update external baselines for analyzer history (Jan Grashoefer, Corelight)

  * Update btest baselines for analyzer history (Jan Grashoefer, Corelight)

  * Add packet analyzer history (Jan Grashoefer, Corelight)

7.1.0-dev.141 | 2024-08-12 11:07:32 +0200

  * spicyz: Add back message about removed support for port / ports in evt (Arne Welzel, Corelight)

    spicy-dhcp, spicy-http and spicy-dns all have this still in their .evt files,
    so it seems popular. Be more helpful than "unexpected token" to users.

7.1.0-dev.139 | 2024-08-09 20:57:23 +0200

  * rule-parse: Remove id_to_str() lookup to squelch coverity warning (Arne Welzel, Corelight)

    Coverity didn't like that id_to_str() allocates memory and we didn't
    free it. Remote its usage wholesale.

  * GH-3774: btest: Skip core.script-args under TSAN (Arne Welzel, Corelight)

    TSAN may re-execute the executable when the memory layout doesn't
    fullfill requirements, causing argument confusion when that happens.

    Closes #3774.

  * Update zeekctl submodule [nomail] (Tim Wojtulewicz, Corelight)

7.1.0-dev.133 | 2024-08-08 10:44:31 +0200

  * Update zeekctl submodule (Tim Wojtulewicz)

  * Add note to NEWS about the removal of OpaqueVal::DoSerialize and OpaqueVal::DoUnserialize (Tim Wojtulewicz, Corelight)

7.1.0-dev.129 | 2024-08-07 12:20:22 -0700

  * Remove deprecated port/ports fields for spicy analyzers (Tim Wojtulewicz, Corelight)

  * Remove deprecated Cluster::Node::interface field (Tim Wojtulewicz, Corelight)

  * Remove deprecated signature definition format (Tim Wojtulewicz, Corelight)

  * Return an error if GLOBAL:: prefix is used (Tim Wojtulewicz, Corelight)

  * Remove deprecated BloomFilter serialization methods (Tim Wojtulewicz, Corelight)

  * Remove deprecated OpaqueVal serialization methods (Tim Wojtulewicz, Corelight)

  * Remove deprecated DECLARE_OPAQUE_VALUE macro (Tim Wojtulewicz, Corelight)

  * Make TypePtr::Capture member variables private (Tim Wojtulewicz, Corelight)

    The public versions were marked as deprecated for 7.0, and accessors
    should be used to manage them now.

  * Remove deprecated Trigger constructor (Tim Wojtulewicz, Corelight)

  * Remove deprecated Controller::auto_assign_ports and Controller::auto_assign_start_port (Tim Wojtulewicz, Corelight)

  * Remove deprecated load-balacing policy script (Tim Wojtulewicz, Corelight)

  * Remove deprecated prometheus telemetry policy script (Tim Wojtulewicz, Corelight)

  * Remove deprecated policy/tuning/default package (Tim Wojtulewicz, Corelight)

  * Remove deprecated time machine settings (Tim Wojtulewicz, Corelight)

  * Remove deprecated json NullDoubleWriter class (Tim Wojtulewicz, Corelight)

  * Remove deprecated modbus event definitions (Tim Wojtulewicz, Corelight)

  * Remove Connection::AppendAddl (Tim Wojtulewicz, Corelight)

  * Remove STMT_ANY statement type (Tim Wojtulewicz, Corelight)

  * Remove EventRegistry::Used and EventRegistry::SetUsed (Tim Wojtulewicz, Corelight)

7.1.0-dev.109 | 2024-08-07 14:10:54 +0200

  * ldap: Promote uint8 to uint64 before shifting (Arne Welzel, Corelight)

    Relates to zeek/spicy#1829

7.1.0-dev.107 | 2024-08-07 11:43:15 +0200

  * ci/ubuntu-24.04: Use ccache 4.10.2 (Arne Welzel, Corelight)

    The ccache version shipped with Ubuntu 24.04 does not yet recognize
    --fprofile-update=atomic, install one that does.

    Now that the asan_sanitizer build also includes building Spicy and
    running the spicyz test suite, ccache is quite important.

    Reference ccache/ccache#1408 and zeek/zeek#3777.

7.1.0-dev.105 | 2024-08-07 10:54:10 +0200

  * telemetry/Manager: Check RegisterFd() return value (Arne Welzel, Corelight)

    Please coverity.

  * telemetry/Manager: Track sent_in and sent_out totals without callback (Arne Welzel, Corelight)

    For terminated threads, the totals would go down once the threads are
    removed, which isn't great. Move tracking of sent in and sent out
    messages from callback to explicit `Inc()` calls.

    Also fixes total_messages_in_metric being initialized twice rather
    than total_messages_out_metric.

  * threading/Manager: Switch inf bucket from infinity() to max() (Arne Welzel, Corelight)

    For uint64_t, std::numeric_limits<T>::has_infinity is false and infinity()
    actually returns 0. Use uint64_t's max() instead. We could cast to double
    and use the double infinity, but this seems reasonable, too.

    This was found while trying to provoke some pending messages and being
    confused why all but the "inf" bucket increased.

  * threading/Manager: "lt" to "le" and do not break (Arne Welzel, Corelight)

    The buckets are specified as lower-equal (changed from lower-than now),
    which means we shouldn't break: The larger "le" bucket contains all previous
    buckets, too. The "inf" bucket represents the current number of threads.

    For example, with a total of 10 threads, 5 threads with 0 messages pending,
    another 4 threads with 50 messages, and on with 2000 messages, the metrics
    would end end up as follows:

        pending_buckets{le=1}      = 5
        pending_buckets{le=10}     = 5
        pending_buckets{le=100}    = 9
        pending_buckets{le=1000}   = 9
        pending_buckets{le=10000}  = 10
        pending_buckets{le=inf}    = 10

    This might be strange initially, but aligns with the Prometheus
    histogram approach (though we're using gauges here).

7.1.0-dev.99 | 2024-08-06 20:08:37 +0200

  * Bump auxil/spicy to latest development snapshot (Arne Welzel, Corelight)

  * spicy/runtime-support: Switch ParameterMismatch::_fmt to static (Arne Welzel, Corelight)

    UBSAN's vptr sanitize isn't happy with the call to _fmt()
    in its member initializer list.

        $ zeek -r Traces/ssh/single-conn.trace .tmp/spicy.event-args-mismatch/test.hlto .tmp/spicy.event-args-mismatch/event-args-mismatch.zeek
        <...>/src/include/zeek/spicy/runtime-support.h:80:29: runtime error: member call on address 0x511000369540 which does not point to an object of type 'zeek::spicy::rt::ParameterMismatch'
        0x511000369540: note: object has invalid vptr
         00 00 00 00  be be be be be be be be  be be be be be be be be  be be be be be be be be  be be be be
                      ^~~~~~~~~~~~~~~~~~~~~~~
                      invalid vptr
            #0 0x7f9c9977b019 in zeek::spicy::rt::ParameterMismatch::ParameterMismatch(std::basic_string_view<char, std::char_traits<char>>, zeek::IntrusivePtr<zeek::Type> const&, std::basic_string_view<char, std::char_traits<char>>) <...>/src/include/zeek/spicy/runtime-support.h:80:29
            #1 0x7f9c9977a6a2 in zeek::spicy::rt::to_val(hilti::rt::Bytes const&, zeek::IntrusivePtr<zeek::Type> const&) <...>/src/include/zeek/spicy/runtime-support.h:562:15

  * coverage/lcov_html: Ignore testing/btest/.tmp (Arne Welzel, Corelight)

    gcda/gcno files in the btest/.tmp directory are from .htlo files
    referencing ephemeral cc files. No need to include these.

  * cirrus: Do not disable Spicy for sanitizer builds (Arne Welzel, Corelight)

  * ldap: Avoid unset m$opcode (Arne Welzel, Corelight)

    Initial fuzzing caused a bind response to arrive before a bind request,
    resulting in an unset field expression error:

        expression error in base/protocols/ldap/main.zeek, line 270: field value missing (LDAP::m$opcode)

    Prevent this by ensuring m$opcode is set and raising instead.

  * GH-3860: fuzzers: Add LDAP fuzzing (Arne Welzel, Corelight)

    LDAP supports both, UDP and TCP as separate analyzers. The corpus
    is identical, however. Started to hit the TLS analyzer fairly
    quickly, too.

    Closes #3860

7.1.0-dev.92 | 2024-08-06 09:01:40 -0700

  * Don't install empty ZAM directories (Tim Wojtulewicz, Corelight)

  * btest/spicy: Make replaces-conflicts trigger replaces code path (Arne Welzel, Corelight)

    The current test attempts to instantiate two spicy::SSH_1 protocol
    analyzers in the .evt file. The intention likely was to use two
    distinct protocol analyzer both trying to replace the builtin SSH
    analyzer.

    Coincidentally, fixing this happens to workaround TSAN errors tickled
    by the FatalError() call while loading the .hlto with two identically
    named analyzers.

        $ cat .tmp/spicy.replaces-conflicts/output
        error: redefinition of protocol analyzer spicy::SSH_1
        ThreadSanitizer: main thread finished with ignores enabled
          One of the following ignores was not ended (in order of probability)
          Ignore was enabled at:
            #0 __llvm_gcov_init __linker___d192e45c25d5ee23-484d3e0fc2caf5b4.cc (ssh.hlto+0x34036) (BuildId: 091934ca4da885e7)
            #1 __llvm_gcov_init __linker___d192e45c25d5ee23-484d3e0fc2caf5b4.cc (ssh.hlto+0x34036) (BuildId: 091934ca4da885e7)
            ...

    I was tempted to replace FatalError() with Error() and rely on
    zeek-setup.cc's early exiting on any reporter errors, but this
    seems easier for now.

    Relates to #3865.

7.1.0-dev.87 | 2024-08-05 14:39:56 -0700

  * Remove some unnecessary #includes (Tim Wojtulewicz, Corelight)

  * Avoid capturing 'this' for callback in telemetry::Manager (Tim Wojtulewicz, Corelight)

  * Make telemetry metrics out of MsgThread statistics (Tim Wojtulewicz, Corelight)

  * Split cpu time metric into user/system components like prof.log (Tim Wojtulewicz, Corelight)

    The total can be calculated from the two parts via Prometheus/Grafana
    if desired, so it's more informative to pass them as separate parts.

  * Move broker statistics to be telemetry metrics (Tim Wojtulewicz, Corelight)

  * Add timer counts as telemetry metrics (Tim Wojtulewicz, Corelight)

  * Move thread manager stats to telemetry metric (Tim Wojtulewicz, Corelight)

  * Add extra metrics to session_mgr (Tim Wojtulewicz, Corelight)

    - Sessions killed by activity
    - Current number of sessions across all types

  * Move dns_mgr stats to telemetry instruments (Tim Wojtulewicz, Corelight)

  * Move trigger stats to telemetry instruments (Tim Wojtulewicz, Corelight)

  * Move pulling of global state inside 'expensive' check for stats (Tim Wojtulewicz, Corelight)

7.1.0-dev.74 | 2024-08-02 15:49:40 -0700

  * Process metric callbacks from the main-loop thread (Tim Wojtulewicz, Corelight)

    This avoids the callbacks from being processed on the worker thread
    spawned by Civetweb. It fixes data race issues with lookups involving
    global variables, amongst other threading issues.

  * CI: Use 16GB of memory for FreeBSD builds (Tim Wojtulewicz, Corelight)

7.1.0-dev.68 | 2024-07-26 10:09:48 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

    This in particular pulls in a fix for zeek/spicy#1808.

7.1.0-dev.66 | 2024-07-26 15:14:36 +0200

  * GH-3853: ldap: Recognize SASL+SPNEGO+NTLMSSP (Arne Welzel, Corelight)

    The ctu-sme-11-win7ad-1-ldap-tcp-50041.pcap file was harvested
    from the CTU-SME-11 (Experiment-VM-Microsoft-Windows7AD-1) dataset
    at https://zenodo.org/records/7958259 (DOI 10.5281/zenodo.7958258).

    Closes #3853

7.1.0-dev.63 | 2024-07-25 09:19:20 -0700

  * Use accessor to reach into X509_ALGOR (Theo Buehler)

    Despite already having an accessor, X509_ALGOR wasn't made opaque
    during OpenSSL 1.1.0 development. It would be nice if this could be
    fixed at some point, so avoid reaching into that struct by using the
    accessor

7.1.0-dev.61 | 2024-07-25 12:02:51 +0200

  * mysql: Simplify length computation (Arne Welzel, Corelight)

    Thanks Tim!

  * mysql: Improve date and time parsing (Fupeng Zhao)

  * btest/mysql: Clean query-attr.pcapng (Arne Welzel, Corelight)

    It contained some unrelated IntelliJ traffic.

  * mysql: Support non-string query attributes (Arne Welzel, Corelight)

    The query attributes aren't exposed to script layer right now, but this
    should at least parse over them once encountered and some fixups.

  * btest/mysql: Add pcap with non-string query attributes (Arne Welzel, Corelight)

    Pcap was generated as follows. Doesn't seem wireshark even parses
    this properly right now.

        with common.get_connection() as c:
            with c.cursor() as cur:
                date1 = datetime.date(1987, 10, 18)
                datetime1 = datetime.datetime(1990, 9, 26, 12, 13, 14)
                cur.add_attribute("number1", 42)
                cur.add_attribute("string1", "a string")
                cur.add_attribute("date1", date1)
                cur.add_attribute("datetime1", datetime1)
                cur.execute("SELECT version()")
                result = cur.fetchall()
                print("result", result)

  * mysql: Introduce mysql_ssl_request event (Arne Welzel, Corelight)

    This should've been added with fa48c885 for completion. Do it now.
    The MySQL spec calls it SSLRequest packet, so keep SSL in the name for
    consistency.

  * mysql: Fix EOFIfLegacyThenResultSet (Arne Welzel, Corelight)

    Only expect a result next if an EOF was consumed.

  * mysql: Add data parameter to mysql_auth_plugin (Arne Welzel, Corelight)

    This may contain salt from the server or a hashed password from the client.

  * mysql: Add mysql_auth_plugin, mysql_auth_more_data and mysql_auth_switch_request events (Arne Welzel, Corelight)

    Remove caching_sha2_password parsing/state from the analyzer and implement
    the generic events. If we actually want to peak into the authentication
    mechanism, we could write a separate analyzer for it. For now, treat it
    as opaque values that are exposed to script land.

    The added tests show the --get-server-public-key in use where
    mysql_auth_more_data contains an RSA public key.

  * mysql: AuthSwitchRequest: &enforce a 0xfe / 254 status (Arne Welzel, Corelight)

  * mysql: Make auth_plugin_ a std::string (Arne Welzel, Corelight)

  * mysql: Fix auth_plugin_data_part2 length computation (Arne Welzel, Corelight)

  * Refactored connection phase state handling (Fupeng Zhao)

    Added `ConnectionExpected` enum for expected packet types during the connection phase.

  * Add support for "auth switch" and "query attrs" (Fupeng Zhao)

    Also fix the issue where Resultset could not correctly distinguish between EOF_Packet and OK_Packet.

  * Add support for parsing the "caching_sha2_password" auth plugin (Fupeng Zhao)

7.1.0-dev.45 | 2024-07-24 15:28:59 -0700

  * Update binpac submodule to better format output code [nomail] (Tim Wojtulewicz, Corelight)

7.1.0-dev.43 | 2024-07-24 13:25:52 -0700

  * Update 7.0 NEWS with blurb about multi-PDU parsing causing increased load [nomail] [skip ci] (Tim Wojtulewicz, Corelight)

  * Fix handling of zero-length SMB2 error responses (Tim Wojtulewicz, Corelight)

7.1.0-dev.40 | 2024-07-24 11:18:03 +0200

  * minor optimization of boolean comparisons (Vern Paxson, Corelight)

  * GH-3839: fix & regression test for GH-3839 (spurious warnings for "when" constructs) (Vern Paxson, Corelight)

7.1.0-dev.37 | 2024-07-23 19:18:37 -0700

  * Bump zeek-testing-cluster to reflect deprecation of prometheus.zeek (Christian Kreibich, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.1.0-dev.34 | 2024-07-23 08:54:23 -0700

  * Update Mozilla CA list and CT list (Johanna Amann, Corelight)

7.1.0-dev.32 | 2024-07-23 08:51:11 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.1.0-dev.30 | 2024-07-23 12:38:54 +0200

  * ldap: Add heuristic for wrap tokens (Arne Welzel, Corelight)

    Instead of dissecting the GSSAPI handshake, add another heuristic
    into MaybeEncrypted to check for the WRAP token identifier.

    After this change, the pcap on the following ticket is processed
    nicely: https://gitlab.com/wireshark/migration-test/-/issues/9398

  * ldap: Ignore ec/rrc for sealed wrap tokens (Arne Welzel, Corelight)

    It shouldn't matter for the encrypted payload that we'll
    just consume and ignore.

  * ldap: Add LDAP sample with SASL-SRP mechanism (Arne Welzel, Corelight)

    This is what @dopheide-esnet actually saw. Produced with a custom
    cyrus-sasl and openldap build :-(

  * ldap: Reintroduce encryption after SASL heuristic (Arne Welzel, Corelight)

    @dopheide-esnet provided sample captures where SASL SRP is used as
    a SASL mechanism and the follow-up LDAP messages are encrypted. It's
    not clear how to determine whether encryption will or will not happen,
    so re-add a heuristic to determine this based on the first byte of
    the first message *after* the successful bindResponse handshake. If
    that byte is 0x30, assume cleartext.

    I haven't been able to produce such pcaps, unfortunately, but the
    cleartext path is tested via the existing sasl-ntlm.pcap.

  * ldap: Fix assuming GSS-SPNEGO for all bindResponses (Arne Welzel, Corelight)

    In retrospect that's an obvious bug.

  * ldap: Implement extended request/response and StartTLS support (Arne Welzel, Corelight)

    PCAP was produced with a local OpenLDAP server configured to support StartTLS.

    This puts the Zeek calls into a separate ldap_zeek.spicy file/module
    to separate it from LDAP.

7.1.0-dev.23 | 2024-07-23 10:02:52 +0200

  * telemetry: Deprecate prometheus.zeek policy script (Arne Welzel, Corelight)

    With Cluster::Node$metrics_port being optional, there's not really
    a need for the extra script. New rule, if a metrics_port is set, the
    node will attempt to listen on it.

    Users can still redef Telemetry::metrics_port *after*
    base/frameworks/telemetry was loaded to change the port defined
    in cluster-layout.zeek.

  * Update broker submodule [nomail] (Tim Wojtulewicz, Corelight)

7.1.0-dev.20 | 2024-07-19 19:51:12 +0200

  * GH-3836: input/Manager: Improve type checks of record fields with type any (Arne Welzel, Corelight)

    Calling AsRecordType() or AsFunc() on a Val of type any isn't safe.

    Closes #3836

7.1.0-dev.18 | 2024-07-17 15:37:12 -0700

  * Bump zeek-testing-cluster to pull in tee SIGPIPE fix (Christian Kreibich, Corelight)

7.1.0-dev.16 | 2024-07-17 16:45:13 +0200

  * ldap: Remove MessageWrapper with magic 0x30 searching (Arne Welzel, Corelight)

    This unit implements a heuristic to search for the 0x30 sequence
    byte if Message couldn't readily be parsed. Remove it with the
    idea of explicit and predictable support for SASL mechanisms.

  * ldap: Harden parsing a bit (Arne Welzel, Corelight)

    ASN1Message(True) may go off parsing arbitrary input data as
    "something ASN.1" This could be GBs of octet strings or just very
    long sequences. Avoid this by open-coding some top-level types expected.

    This also tries to avoid some of the &parse-from usages that result
    in unnecessary copies of data.

    Adds a locally generated PCAP with addRequest/addResponse that we
    don't currently handle.

  * ldap: Handle integrity-only KRB wrap tokens (Arne Welzel, Corelight)

    Mostly staring at the PCAPs and opened a few RFCs. For now, only if the
    MS_KRB5 OID is used and accepted in a bind response, start stripping
    KRB5 wrap tokens for both, client and server traffic.

    Would probably be nice to forward the GSS-API data to the analyzer...

    Closes zeek/spicy-ldap#29.

7.1.0-dev.12 | 2024-07-16 10:16:02 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

    This patch bump Spicy to the latest development snapshot. This
    introduces a backwards-incompatible change in that it removes support
    for a never officially supported syntax to specify unit fields (so I
    would argue: not strictly a breaking change).

7.1.0-dev.10 | 2024-07-12 16:02:22 -0700

  * CI: Set FETCH_CONTENT_FULLY_DISCONNECTED flag for configure (Tim Wojtulewicz, Corelight)

  * Fix a broken merge (Tim Wojtulewicz, Corelight)

    I merged an old version of the branch on accident and then merged the right
    one over top of it, but git ended up including both versions. This fixes
    that mistake.

7.1.0-dev.6 | 2024-07-12 09:51:39 -0700

  * Do not emit hook files for builtin modules (Benjamin Bannier, Corelight)

    We would previously emit a C++ file with hooks for at least the builtin
    `spicy` module even though that module like any other builtin module
    never contains implementations of hooks for types in user code.

    This patch prevents modules with skipped implementations (such as our
    builtin modules) from being added to the compilation which prevents
    generating their hook files.

7.1.0-dev.2 | 2024-07-12 09:46:34 -0700

  * Fix warning about grealpath when running 'make dist' on Linux (Tim Wojtulewicz, Corelight)

7.0.0-dev.467 | 2024-07-11 12:14:52 -0700

  * Update the scripts.base.frameworks.telemetry.internal-metrics test (Christian Kreibich, Corelight)

  * Revert "Temporarily disable the scripts/base/frameworks/telemetry/internal-metrics btest" (Christian Kreibich, Corelight)

  * Bump Broker to pull in new Prometheus support and pass in Zeek's registry (Dominik Charousset and Christian Kreibich, Corelight)

7.0.0-dev.461 | 2024-07-10 18:45:36 +0200

  * Extend btest for logging of disabled analyzers (Jan Grashoefer, Corelight)

  * Add logging of disabled analyzers to analyzer.log (Jan Grashoefer, Corelight)

7.0.0-dev.458 | 2024-07-10 11:05:19 +0200

  * testing/btest: Default to HILTI_JIT_PARALLELISM=1 (Arne Welzel, Corelight)

    This is a rework of b59bed9d06f2257a6b4f6c6408b8363a277eebac moving
    HILTI_JIT_PARALLELISM=1 into btest.cfg to make it default applicable to
    btest -j users (and CI).

    The background for this change is that spicyz may spawn up to nproc compiler
    instances by default. Combined with btest -j, this may be nproc x nproc
    instances worst case. Particularly with gcc, this easily overloads CI or
    local systems, putting them into hard-to-recover-from thrashing/OOM states.

    Exporting HILTI_JIT_PARALLELISM in the shell allows overriding.

  * Revert "CI: Use ccache and a single CPU when building spicy analyzers for btests" (Arne Welzel, Corelight)

    This reverts commit b59bed9d06f2257a6b4f6c6408b8363a277eebac.

7.0.0-dev.454 | 2024-07-09 15:12:19 -0700

  * CI: Use ccache and a single CPU when building spicy analyzers for btests (Tim Wojtulewicz, Corelight)

7.0.0-dev.452 | 2024-07-09 14:53:41 -0700

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.0.0-dev.450 | 2024-07-09 10:15:13 -0700

  * minor script optimization updates to reflect recent changes, Coverity findings (Vern Paxson, Corelight)

7.0.0-dev.447 | 2024-07-09 17:10:16 +0200

  * Fix for --display-cmake in configure (cknill)
    Moved build directory creation further down in the script so that --display-cmake
    has a chance to happen before build tree setup.

7.0.0-dev.445 | 2024-07-09 00:07:25 -0700

  * Management framework: bump cluster testsuite to pull in telemetry tests (Christian Kreibich, Corelight)

  * Management framework: bump zeek-client (Christian Kreibich, Corelight)

  * Management framework: augment deployed configs with instance IP addresses (Christian Kreibich, Corelight)

  * Management framework: add auto-enumeration of metrics ports (Christian Kreibich, Corelight)

  * Management framework: propagate metrics port from agent (Christian Kreibich, Corelight)

  * Management framework: add metrics port in management & Supervisor node records (Christian Kreibich, Corelight)

  * Harden the telemetry manager against unset Telemetry::metrics_address (Christian Kreibich, Corelight)

  * Comment-only tweaks for telemetry-related settings. (Christian Kreibich, Corelight)

  * Update submodules [nomail] (Tim Wojtulewicz, Corelight)

7.0.0-dev.434 | 2024-07-04 17:34:23 +0200

  * CMakeLists: Ensure Threads::Threads target exists (Arne Welzel, Corelight)

    Fix failure on OSX with CMake 3.30 complaining about missing
    Threads::Threads target.

  * ci/macos: Only use sonoma image (Arne Welzel, Corelight)

7.0.0-dev.431 | 2024-07-04 17:22:42 +0200

  * Bump auxil/zeek-aux (Benjamin Bannier, Corelight)

7.0.0-dev.429 | 2024-07-04 15:15:56 +0200

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.0.0-dev.427 | 2024-07-04 13:35:25 +0200

  * GH-3789: HTTP: Implement FlipRoles() (Arne Welzel, Corelight)

    When Zeek flips roles of a HTTP connection subsequent to the HTTP analyzer
    being attached, that analyzer would not update its own ContentLine analyzer
    state, resulting in the wrong ContentLine analyzer being switched into
    plain delivery mode.

    In debug builds, this would result in assertion failures, in production
    builds, the HTTP analyzer would receive HTTP bodies as individual header
    lines, or conversely, individual header lines would be delivered as a
    large chunk from the ContentLine analyzer.

    PCAPs were generated locally using tcprewrite to select well-known-http ports
    for both endpoints, then editcap to drop the first SYN packet.

    Kudos to @JordanBarnartt for keeping at it.

    Closes #3789

  * ContentLineAnalyzer: Add getter for skip_partial (Arne Welzel, Corelight)

7.0.0-dev.423 | 2024-07-02 15:35:36 -0700

  * Remove the Supervisor's internal ClusterEndpoint struct. (Christian Kreibich, Corelight)

  * Provide a script-layer equivalent to Supervisor::__init_cluster(). (Christian Kreibich, Corelight)

7.0.0-dev.420 | 2024-07-02 14:46:29 -0700

  * Update NEWS file to cover JSON enhancements (Christian Kreibich, Corelight)

  * Support JSON roundtripping via to_json()/from_json() for patterns (Christian Kreibich, Corelight)

  * Support table deserialization in from_json() (Christian Kreibich, Corelight)

  * Support map-based definition of ports in from_json() (Christian Kreibich, Corelight)

  * Document the field_escape_pattern in the to_json() BiF (Christian Kreibich, Corelight)

7.0.0-dev.414 | 2024-07-02 19:42:10 +0200

  * Bump cmake submodule [nomail] (Arne Welzel, Corelight)

7.0.0-dev.413 | 2024-07-02 14:41:27 +0200

  * threading/Manager: Warn if threads are added after termination (Arne Welzel, Corelight)

    The core.file-analyzer-violation test showed that it's possible to
    create new threads (log writers) when Zeek is in the process of
    terminating. This can result in the IO manager's deconstructor
    deleting IO sources for threads that are still running.

    This is sort of a scripting issue, so for now log a reporter warning
    when it happens to have a bit of a bread-crumb what might be
    going on. In the future it might make sense to plug APIs with
    zeek_is_terminating().

  * iosource/Manager: Reap dry sources while computing timeout (Arne Welzel, Corelight)

    Avoids looping over the sources vector twice and should result
    in the same behavior.

  * GH-3682: threading/MsgThread: Decouple IO source and thread lifetimes (Arne Welzel, Corelight)

    MsgThread acting as an IO source can result in the situation where the
    threading manager's heartbeat timer deletes a finished MsgThread instance,
    but at the same time this thread is in the list of ready IO sources the
    main loop is currently processing.

    Fix this by decoupling the lifetime of the IO source part and properly
    registering as lifetime managed IO sources with the IO manager.

    Fixes #3682

  * iosource/Manager: Do not manage lifetime of pkt_src (Arne Welzel, Corelight)

    Now that dry sources are properly reaped and freed, an offline packet
    source would be deleted once dry, resulting in GetPktSrc() returning
    a wild pointer. Don't manage the packet source lifetime and instead
    free it during Manager destruction.

  * iosource/Manager: Honor manage_lifetime and dont_count for short-lived IO sources (Arne Welzel, Corelight)

    If an IO source is registered and becomes dry at runtime, the IO
    manager would not honor its manage_lifetime or dont_count attribute
    during collection, resulting in memory leaks.

    This probably hasn't mattered so far as there's no IO sources registered
    in-tree at runtime using manage_lifetime=true.

7.0.0-dev.407 | 2024-06-26 13:16:10 +0200

  * coverage/lcov_html: Allow missing coveralls token (Arne Welzel, Corelight)

    This is a fixup for 0cd023b83919fca7bfac55e75a41f724e820fd26 which
    currently causes ASAN coverage builds to fail for non-master branches
    when due to a missing COVERALLS_REPO_TOKEN.

    Instead of bailing out for non-master branches, pass `--dry-run` to the
    coveralls-lcov invocation to test more of the script.

7.0.0-dev.405 | 2024-06-25 13:35:41 +0200

  * Bump auxil/spicy to latest development snapshot (Benjamin Bannier, Corelight)

7.0.0-dev.403 | 2024-06-25 11:29:58 +0200

  * NEWS: Add entry about FileExtractDir (Arne Welzel, Corelight)

  * Update zeekctl submodule (Arne Welzel, Corelight)

  * zeek-testing-private: Update baseline, after merge (Arne Welzel, Corelight)

7.0.0-dev.399 | 2024-06-24 11:19:14 +0200

  * script optimization for record operations sourced (in part) from other records (Vern Paxson, Corelight)

7.0.0-dev.397 | 2024-06-20 18:16:51 -0700

  * zeek-testing-private: Update baseline (Arne Welzel, Corelight)

  * ssh: Revert half-duplex robustness (Arne Welzel, Corelight)

    This reverts part of commit a0888b7e36308d241f4c62b42715a94d499aab23 due
    to inhibiting analyzer violations when parsing non SSH traffic when
    the &restofdata path is entered.

    See additional discussion here:
    https://github.com/zeek/zeek/pull/3781
    https://github.com/zeek/zeek/pull/3720/files#r1636314375

7.0.0-dev.394 | 2024-06-20 17:28:11 -0700

  * Add "zeek/" prefixes to includes in spicy/runtime-support.h (Michael Dopheide)

7.0.0-dev.392 | 2024-06-20 15:51:42 +0200

  * Spicy: Provide runtime API to access Zeek-side globals. (Robin Sommer, Corelight)

    This allows to read Zeek global variables from inside Spicy code. The
    main challenge here is supporting all of Zeek's data type in a
    type-safe manner.

    The most straight-forward API is a set of functions
    `get_<type>(<id>)`, where `<type>` is the Zeek-side type
    name (e.g., `count`, `string`, `bool`) and `<id>` is the fully scoped
    name of the Zeek-side global (e.g., `MyModule::Boolean`). These
    functions then return the corresponding Zeek value, converted in an
    appropriate Spicy type. Example:

        Zeek:
            module Foo;

            const x: count = 42;
            const y: string = "xxx";

        Spicy:
            import zeek;

            assert zeek::get_count("Foo::x") == 42;
            assert zeek::get_string("Foo::y") == b"xxx"; # returns bytes(!)

    For container types, the `get_*` function returns an opaque types that
    can be used to access the containers' values. An additional set of
    functions `as_<type>` allows converting opaque values of atomic
    types to Spicy equivalents. Example:

        Zeek:
            module Foo;

            const s: set[count] = { 1, 2 };
            const t: table[count] of string = { [1] = "One", [2] = "Two" }

        Spicy:

            # Check set membership.
            local set_ = zeek::get_set("Foo::s");
            assert zeek::set_contains(set_, 1) == True

            # Look up table element.
            local table_ = zeek::get_table("Foo::t");
            local value = zeek::table_lookup(t, 1);
            assert zeek::as_string(value) == b"One"

    There are also functions for accessing elements of Zeek-side vectors
    and records.

    If any of these `zeek::*` conversion functions fails (e.g., due to a
    global of that name not existing), it will throw an exception.

    The documentation has more information on all of this.

    Design considerations:

        - We support only reading Zeek variables, not writing. This is
          both to simplify the API, and also conceptually to avoid
          offering backdoors into Zeek state that could end up with a very
          tight coupling of Spicy and Zeek code.

        - We accept that a single access might be relatively slow due to
          name lookup and data conversion. This is primarily meant for
          configuration-style data, not for transferring lots of dynamic
          state over.

        - In that spirit, we don't support deep-copying complex data types
          from Zeek over to Spicy. This is (1) to avoid performance
          problems when accidentally copying large containers over,
          potentially even at every access; and (2) to avoid the two sides
          getting out of sync if one ends up modifying a container without
          the other being able to see it.

  * Spicy: Reformat `zeek.spicy` with `spicy-format`. (Robin Sommer, Corelight)

  * Spicy: Extend exception hierarchy. (Robin Sommer, Corelight)

    We move the current `TypeMismatch` into a  new `ParameterMismatch`
    exception that's derived from a more general `TypeMismatch` now that
    can also be used for other, non-parameter mismatches.

7.0.0-dev.387 | 2024-06-18 10:52:25 +0200

  * CMakeLists: Disable -Werror for 3rdparty/sqlite3.c (Arne Welzel, Corelight)

    We package vanilla sqlite from upstream and on Fedora 40 with sqlite 3.46
    there's the following compiler warning:

        In function 'sqlite3Strlen30',
            inlined from 'sqlite3ColumnSetColl' at
            ../../src/3rdparty/sqlite3.c:122105:10:
            ../../src/3rdparty/sqlite3.c:35003:28: error: 'strlen' reading 1 or more bytes from a region of size 0 [-Werror=stringop-overread]
        35003 |   return 0x3fffffff & (int)strlen(z);
              |                            ^~~~~~~~~
        In function 'sqlite3ColumnSetColl':

    Disabling -Werror on sqlite3.c seems sensible given we have little
    control over that code.

  * Bump zeek-3rdparty to pull in sqlite move to 3.46 (Christian Kreibich, Corelight)

    This avoids a compiler warning/error on Fedora 40.

  * CI: drop Fedora 38, add 40 (Christian Kreibich, Corelight)

7.0.0-dev.383 | 2024-06-14 13:50:05 +0200

  * GH-3783: Spicy: Disallow repeating replacements of the same analyzer. (Robin Sommer, Corelight)

    We now reject EVT files that attempt to replace the same built-in
    analyzer multiple times as doing so would be ill-defined and not very
    intuitive in what exactly it means.

  * Bump Spicy. (Robin Sommer, Corelight)

7.0.0-dev.380 | 2024-06-11 15:11:43 +0200

  * Drop EOL centos8-stream in CI (Benjamin Bannier, Corelight)

7.0.0-dev.378 | 2024-06-11 12:01:03 +0200

  * Suppress a known data race during civetweb shutdown (Tim Wojtulewicz)

7.0.0-dev.376 | 2024-06-11 11:00:46 +0200

  * Bump cmake for -fprofile-update=atomic usage (Arne Welzel, Corelight)

  * cirrus: Unset CCACHE_BASEDIR for asan/coverage build (Arne Welzel, Corelight)

    When CCACHE_BASEDIR is set, ccache will rewrite absolute paths to
    relative paths in order to allow compilation in different source
    directories. We do not need this feature on Cirrus (the checkout
    is always in /zeek) and using absolute paths avoids
    confusion/normalization needs for the gcov -p results.

    We could consider removing the global CCACHE_BASEDIR, but it'd
    bust the ccache of every other task, too.

7.0.0-dev.372 | 2024-06-07 09:28:52 -0700

  * Add Telemetry::metrics_address option (Tim Wojtulewicz, Corelight)

7.0.0-dev.368 | 2024-06-06 18:08:29 -0700

  * Change prometheus test to check for require jq (Tim Wojtulewicz, Corelight)

7.0.0-dev.366 | 2024-06-06 18:06:42 -0700

  * Check for 'zeekctl check' before trying to start up prometheus (Tim Wojtulewicz, Corelight)

7.0.0-dev.362 | 2024-06-04 14:16:54 -0700

  * Switch to zeek fork of prometheus-cpp (Tim Wojtulewicz, Corelight)

  * Remove unnecessary shared_from_this on instrument classes (Tim Wojtulewicz, Corelight)

  * Restore label_names field in MetricOpts record (Tim Wojtulewicz)

  * Change how we count FDs on Linux to fix zeekctl stop issues (Tim Wojtulewicz)

  * Update zeekctl tests for telemetry rework (Tim Wojtulewicz, Corelight)

  * Use forward declarations of prometheus-cpp types in telemetry::Manager (Tim Wojtulewicz, Corelight)

  * Add prometheus-cpp files to install set for plugins to use (Tim Wojtulewicz, Corelight)

  * Fix a memory leak with the CivetWeb callbacks in telemetry (Tim Wojtulewicz, Corelight)

  * Fix a bunch of copy-instead-of-move findings from Coverity (Tim Wojtulewicz, Corelight)

  * Move telmetry label names out of opts records, into main metric records (Tim Wojtulewicz, Corelight)

  * Ensure the order of label values matches the label names (Tim Wojtulewicz, Corelight)

  * Remove prefix column from telemetry.log (Tim Wojtulewicz, Corelight)

  * Fix race condition by pre-building the cluster json data for services.json (Tim Wojtulewicz)

  * Set running_under_test for scripts.base.frameworks.logging.telemetry test (Tim Wojtulewicz, Corelight)

7.0.0-dev.347 | 2024-06-04 11:36:13 -0700

  * Update reporter.bif to describe special case of errors in init (Smoot)

    Originally proposed in zeek/zeek-docs#257, but reverted via
    9f9ebde62380a3012a1471d9ff1c1c91c7aa69da.

7.0.0-dev.345 | 2024-06-04 10:36:46 -0700

  * script optimization baseline tweaks due to recent minor changes (Vern Paxson, Corelight)

  * updated list of BiFs for script optimization (Vern Paxson, Corelight)

  * addressed some Coverity nits (Vern Paxson, Corelight)

  * improved error cascade for invalid attributes (Vern Paxson, Corelight)

7.0.0-dev.338 | 2024-05-31 14:18:15 -0700

  * Add type aliases for instrument and family shared_ptrs (Tim Wojtulewicz, Corelight)

  * Update NEWS for double and is_sum changes (Tim Wojtulewicz, Corelight)

  * Remove is_sum arguments from counters and gauges (Tim Wojtulewicz, Corelight)

  * Change all instruments to only handle doubles (Tim Wojtulewicz, Corelight)

  * Add comment to telemetry::Manager::InitPostScript (Tim Wojtulewicz, Corelight)

  * Remove all of the ZEEK_METRICS_ environment variables (Tim Wojtulewicz, Corelight)

  * Fix header comments in scripts/policy/frameworks/telemetry/prometheus.zeek (Tim Wojtulewicz, Corelight)

  * Change all prometheus #includes to use angle brackets (Tim Wojtulewicz, Corelight)

  * Update zeekctl submodule for metrics_port node.cfg option (Tim Wojtulewicz, Corelight)

  * Remove the is_sum argument from BIF histogram creation methods (Tim Wojtulewicz, Corelight)

  * Update NEWS for Telemetry rework (Tim Wojtulewicz, Corelight)

  * Remove Telemetry::metrics_export_prefixes option (Tim Wojtulewicz, Corelight)

  * Validate that label names are constant in non-zeek metrics (Tim Wojtulewicz, Corelight)

  * Avoid calling Collect() in counter/gauge Value() methods if not needed (Tim Wojtulewicz, Corelight)

  * Fix some determinism issues with btests (Tim Wojtulewicz, Corelight)

  * Temporarily disable the scripts/base/frameworks/telemetry/internal-metrics btest (Tim Wojtulewicz, Corelight)

  * Fix the scripts.policy.frameworks.telemetry.prometheus btest to use the service discovery endpoint (Tim Wojtulewicz, Corelight)

  * Btest updates due to recent changes (Tim Wojtulewicz, Corelight)

  * Update telemetry log policy due to the fact that unit will not be filled in anymore (Tim Wojtulewicz, Corelight)

  * Rework everything to access the prometheus-cpp objects more directly (Tim Wojtulewicz, Corelight)

  * Move telemetry opaques out of OpaqueVal.h (Tim Wojtulewicz, Corelight)

  * Add GetRegistry() method for retrieving access to prometheus-cpp registry (Tim Wojtulewicz, Corelight)

  * Remove Broker metrics configuration values and methods (Tim Wojtulewicz, Corelight)

  * Add support for callbacks for gauges/counters, restore process stat metrics (Tim Wojtulewicz, Corelight)

  * Add a services.json endpoint for Prometheus service discovery (Tim Wojtulewicz, Corelight)

  * Don't include endpoint label/value when collecting metrics internally (Tim Wojtulewicz, Corelight)

  * Remove everything related to aggregation (Tim Wojtulewicz, Corelight)

  * Make all options const-redefs, remove all of the change handler code (Tim Wojtulewicz, Corelight)

  * Move base types from telemetry framework to init-bare (Tim Wojtulewicz, Corelight)

  * Update test baselines due to underscore changes (Tim Wojtulewicz, Corelight)

  * Convert telemetry code to use prometheus-cpp (Tim Wojtulewicz, Corelight)

  * Add necessary script-land changes (Tim Wojtulewicz, Corelight)

  * Add prometheus-cpp submodule, FindPrometheusCpp cmake module (Tim Wojtulewicz, Corelight)

7.0.0-dev.302 | 2024-05-31 09:37:21 -0700

  * More precise error reporting for the disable_analyzer() BiF (Christian Kreibich, Corelight)

  * Add btests for the lookup_connection_analyzer_id() BiF. (Christian Kreibich, Corelight)

  * Add BiF for looking up a connection's numeric protocol analyzer IDs (Christian Kreibich, Corelight)

7.0.0-dev.298 | 2024-05-29 13:49:00 -0700

  * removing now-vestigial "add" and "delete" statements (Vern Paxson, Corelight)

  * script optimization support for "add" and "delete" being expressions (Vern Paxson, Corelight)

  * "add" and "delete" are now expressions rather than statements (Vern Paxson, Corelight)

  * bug fix for dealing with illegal types of initializers (Vern Paxson, Corelight)

  * added a space when rendering some expressions so they're more readable (Vern Paxson, Corelight)

7.0.0-dev.292 | 2024-05-29 14:11:57 +0100

  * Copy timestamp from file object (mvhensbergen)

		In some cases, e.g. running zeek on short pcaps as opposed to continuous
		packet streams, network_time() may not equal the time that was used when
		generating the file object.  This results in the pe.log entry having a
		different timestamp than its corresponding files.log entry which is strange
		as they refer to the exact same file.

  * CI: Add coveralls-lcov gem to ubuntu 24, remove from ubuntu 20 (Tim Wojtulewicz, Corelight)

7.0.0-dev.287 | 2024-05-28 13:05:45 -0700

  * CI: Revert part of 2bde82ffa2f5fe9161e3322fee82eb45699b9164 to fix coverage builds (Tim Wojtulewicz, Corelight)

7.0.0-dev.284 | 2024-05-24 15:04:27 -0700

  * Fix Zeekygen warning for QUIC::unrecognized_version event (Christian Kreibich, Corelight)

7.0.0-dev.282 | 2024-05-24 10:49:31 -0700

  * Update TLS consts, mainly new named curves. (Johanna Amann, Corelight)

    Add test for X25519Kyber768Draft00 (post-quantum key agreement)

7.0.0-dev.280 | 2024-05-21 16:22:57 -0700

  * CI: Remove --enable-werror for asan builds (Tim Wojtulewicz, Corelight)

    There's a bug in GCC (https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105562) that
    causes std::regex to emit some warnings when built with -fsanitize=address. Any
    warnings that actually mean anything would be caught by the other sanitizer
    builds or by the regular ubuntu24 build.

  * CI: Run coverage builds for PRs, but only upload on master (Tim Wojtulewicz, Corelight)

  * Coverage: Ignore a few errors during generation (Tim Wojtulewicz, Corelight)

  * Coverage: don't bother ignoring non-existent bro.dir files (Tim Wojtulewicz, Corelight)

  * CI: Re-enable coverage (Tim Wojtulewicz, Corelight)

  * CI: Switch asan build back to gcc (Tim Wojtulewicz, Corelight)

    The tools used for coverage (gcov, lcov) work better with GCC. We could switch
    over to similar tools for llvm, but they way they store files during coverage
    builds don't work as well for us (mostly the places they store the files).

  * CI: Avoid divide by zero error when generating coverage files (Tim Wojtulewicz, Corelight)

7.0.0-dev.270 | 2024-05-20 15:54:09 -0700

  * Fix for suppressing SMB logging of previously-logged files (Vern Paxson, Corelight)

7.0.0-dev.268 | 2024-05-17 08:56:31 -0700

  * Bump Spicy to latest dev snapshot (Benjamin Bannier, Corelight)

  * CI: Disable coverage temporarily, broken with clang-18 (Tim Wojtulewicz, Corelight)

7.0.0-dev.265 | 2024-05-16 11:09:23 -0700

  * Fix for ZAM inlining of nested function calls with the same parameter names (Vern Paxson, Corelight)

  * Fixed ZAM logic error in canonicalizing specialized min/max instructions (Vern Paxson, Corelight)

  * Fixed order-of-evaluation bug in ZAM Subnet-To-Addr instruction (Vern Paxson, Corelight)

  * "-a zam" BTest baseline update reflecting recent Spicy baseline change (Vern Paxson, Corelight)

7.0.0-dev.260 | 2024-05-16 09:34:55 -0700

  * CI: Disable spicy_head task for release branches (Tim Wojtulewicz, Corelight)

7.0.0-dev.258 | 2024-05-15 20:00:41 -0700

  * CI: Use llvm-cov-18 on Cirrus for building coverage data (Tim Wojtulewicz, Corelight)

  * CI: Add missing lcov package to ubuntu 24 Dockerfile (Tim Wojtulewicz)

7.0.0-dev.254 | 2024-05-13 17:40:37 -0700

  * CI: Use clang-18 on Ubuntu 24 for sanitizers builds, enable TSan builds (Tim Wojtulewicz)

  * CI: Add clang-18 to Ubuntu 24.04 VM (Tim Wojtulewicz)

7.0.0-dev.251 | 2024-05-13 16:38:33 +0200

  * Spicy: Apply missing fix for recent Spicy bump. (Robin Sommer, Corelight)

7.0.0-dev.249 | 2024-05-13 11:51:17 +0200

  * Bump Spicy, with small tweaks for API changes. (Robin Sommer, Corelight)

7.0.0-dev.247 | 2024-05-10 10:19:43 -0700

  * CI: Update asan and ubsan tasks to use Ubuntu 22.04 VM (Tim Wojtulewicz, Corelight)

  * CI: Replace Ubuntu 23.10 with Ubuntu 24.04 (Tim Wojtulewicz, Corelight)

7.0.0-dev.244 | 2024-05-10 11:08:47 +0200

  * GH-3725: Spicy: Fix service reporting for replaced analyzers. (Robin Sommer, Corelight)

    We accidentally applied analyzer mappings when looking up an
    analyzer's name from scriptland.

  * GH-3561: Spicy: Support UDP in Spicy's `protocol_*` runtime functions. (Robin Sommer, Corelight)

    This extends the ability to feed new payload back into Zeek's analyzer
    pipeline from TCP to now also UDP.

    Note: We don't extend this further to ICMP because the ICMP analyzer
    cannot be dynamically instantiated (Zeek aborts when trying so). As
    ICMP isn't very interesting from use case perspective anyways, that
    seems fine.

  * Add method to analyzer to retrieve direct child by name. (Robin Sommer, Corelight)

  * Add explicit children life-cycle management method to analyzers. (Robin Sommer, Corelight)

  * Extend PIA's `FirstPacket` API. (Robin Sommer, Corelight)

    `FirstPacket()` so far supported only TCP. To extend this to UDP, we
    move the method into the PIA base class; give it a protocol parameter
    for the case that there's no actual packet is available; and add the
    ability to create fake UDP packets as well, not just TCP.

    This whole thing is pretty ugly to begin with, and this doesn't make
    it nicer, but we need this extension that so we can feed UDP data into
    the signature engine that's tunneled over other protocols. Without the
    fake packets, DPD signatures in particular wouldn't have anything to
    match on.

  * Spicy: Prepare for supporting forwarding to protocols other than TCP. (Robin Sommer, Corelight)

    So far the Spicy runtime supported forwarding data into other
    analyzers only for TCP analyzers. This puts branching logic in place
    that let the relevant runtime functions dispatch differently based on
    the target transport-layer protocol. We don't implement anything else
    than TCP yet; that will come next.

    Along with the internal changes, this also updates the user-visible
    runtime function to pass protocol information in. For now, this
    likewise remains limited to TCP. The function signatures are chosen so
    that they stay backwards-compatible to previous Spicy version. In
    particular, they default to TCP where not otherwise specified.

  * Fix include of private file in public header (Benjamin Bannier, Corelight)

  * Update package-manager submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update zeekctl submodule [nomail] (Tim Wojtulewicz, Corelight)

7.0.0-dev.231 | 2024-05-08 13:09:25 -0700

  * enable ZAM operation specifications to reside in multiple files (not yet used) (Vern Paxson, Corelight)

7.0.0-dev.229 | 2024-05-08 09:55:01 -0700

  * Move packet_analysis::Dispatcher to detail namespace (Tim Wojtulewicz, Corelight)

.0.0-dev.226 | 2024-05-07 12:02:28 -0700

  * make SSH analyzer robust to half-duplex connections (Vern Paxson, Corelight)

7.0.0-dev.224 | 2024-05-07 10:26:40 -0700

  * Clarify membership in the Site::private_address_space prefix list. [skip ci] (Christian Kreibich, Corelight)

    IANA's IPv6 special-purpose address registry now has members that technically
    meet the definition of not being globally reachable, but don't imply operating
    locally. An example: https://datatracker.ietf.org/doc/draft-ietf-6man-sids/06/

    This change just explains that distinction.

7.0.0-dev.222 | 2024-05-07 10:25:55 -0700

  * Avoid segfault when generating Zeekygen docs on Zeek-internal identifiers. (Christian Kreibich, Corelight)

    Identifiers that Zeek generates explicitly in-core for example during component management
    ("Analyzer::ANALYZER_FOO", "Input::READER_FOO", etc), aren't associated with any
    scripts and would lead to nullpointer derefs when trying to identify
    modification time.

    This fix returns a zero timestamp in such cases, ensuring it never triggers docs
    refreshes. We do the same e.g. in PackageInfo instances.

  * Add btest for Zeekygen docs extraction on identifiers defined by the Zeek core. (Christian Kreibich, Corelight)

    Mainly, this should not crash. :-) The baseline output file also should remain
    empty, since Zeekygen's staleness test should conclude that it's sufficiently
    fresh.

7.0.0-dev.218 | 2024-05-07 09:45:25 +0200

  * Fix packet analyzer replacement. (Robin Sommer, Corelight)

    Also reworking the existing test, which was pretty odd/broken.

  * GH-3573: Spicy: Wenn replacing an analyzer add a component mapping. (Robin Sommer, Corelight)

    This uses the new API to replace components internally.

    With these changes in place, replacing protocol analyzers now don't
    need to register their ports anymore if they match what the original
    analyzer was using (because the old one's registrations will map
    over).

    Packet analyzer replacement doesn't quite work yet but will be fixed
    in next commit.

  * Add component API to transparently remap one component to another one. (Robin Sommer, Corelight)

    When a specific component is requested through its tag or name, one
    can now have the component manager transparently return a different
    one that has been registered to replace the original one. We limit
    this to disabled components to avoid unnecessary confusion. That also
    means that remappings are currently only supported for analyzers
    (because other types of components cannot be disabled for now, per the
    previous change).

  * Move enabled/disabled functionality from analyzers into `Component` base class API. (Robin Sommer, Corelight)

    The different analyzers types all had their own methods for
    enabling/disabling their availability. This change abstracts that into
    a new API inside their base class (`plugin::Component`) so that they
    can be toggled in a unified way.

    In principle, other types of components could/should use this as well
    now, so that, e.g., an input reader's availability could be toggled at
    runtime. The code doesn't make that broader change for now because it
    would requires a series of changes wherever these other component
    types are being used. However, that means that one now could try
    toggling some other component through the new API without that having
    any effect. To catch that, there's a runtime check in place that turns
    any such attempt into an internal error.

  * GH-3440: Spicy: Query Zeek scriptland for file handles. (Robin Sommer, Corelight)

    Like traditional file analyzers, we now query Zeek's
    `get_file_handle()` event for handles when a connection begins
    analyzing an embedded file. That means that Spicy-side protocol
    analyzers that are forwarding data into file analysis now need to call
    Zeek's `Files::register_protocol()` and provide a callback for
    computing file handles. If that's missing, Zeek will now issue a
    warning. This aligns with the requirements Zeek's traditional protocol
    analyzers. (If the EVT file defines a protocol analyzer to `replace`
    an existing one, that one's `register_protocol()` will be consulted.)

    Because Zeek's `get_file_handle()` event requires a current
    connection, if a Spicy file analyzer isn't directly part of a
    connection context (e.g., with nested files), we continue to use
    hardcoded, built-in file handle. Scriptland won't be consulted in
    that case, just like before.

  * Spicy: Cleanup some runtime code. (Robin Sommer, Corelight)

  * GH-3606: Spicy: Map Spicy's `Protocol` enum to Zeek's `transport_proto`. (Robin Sommer, Corelight)

    We now hardcode this specific enum mapping to make Zeek-side usage
    more convenient.

7.0.0-dev.207 | 2024-05-06 16:59:31 -0700

  * Update broker submodule [nomail] (Tim Wojtulewicz, Corelight)

7.0.0-dev.205 | 2024-05-06 11:16:15 -0700

  * Move the options from policy/tuning/defaults to actual Zeek defaults, deprecate that package (Tim Wojtulewicz, Corelight)

7.0.0-dev.200 | 2024-05-02 19:00:53 -0700

  * refine Val "footprint" to equate long strings with multiple objects (Vern Paxson, Corelight)

7.0.0-dev.198 | 2024-05-02 10:21:43 -0700

  * Constify classes in RuleMatcher, fixes c++20 build failure (Tim Wojtulewicz, Corelight)

7.0.0-dev.196 | 2024-04-29 09:09:28 -0700

  * Fix cid propagation into files.log (Johanna Amann, Corelight)

    Changes to the connection id were not propagated to files.log in all
    cases.

    Fixes GH-3700

7.0.0-dev.194 | 2024-04-29 09:08:20 -0700

  * factored BTest constants into globals to prevent premature ZAM optimization when testing (Vern Paxson, Corelight)

  * addressed minor issues flagged by Coverity (Vern Paxson, Corelight)

7.0.0-dev.191 | 2024-04-29 09:06:24 -0700

  * Avoid calling typecasts in Val when we have direct access to the underlying value object (Tim Wojtulewicz, Corelight)

7.0.0-dev.187 | 2024-04-26 12:29:18 -0700

  * Gracefully handle empty/missing shadow file (Peter Cullen, Corelight)

    When a shadow file is empty/missing during rotation, Zeek aborts
    with an error message, but if the shadow file was empty, it'll still
    be there after the restart, causing an endless restart loop. This
    solution gracefully handles the rotation in such cases using the
    default file extension and post processing function.

7.0.0-dev.184 | 2024-04-26 11:17:52 -0700

  * GH-3671: Factor in caplens in ICMPAnalyzer::DeliverPacket length calculations (Christian Kreibich, Corelight)

  * Update binpac submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update gen-zam submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update doc submodule [nomail] [skip ci] (zeek-bot)

7.0.0-dev.179 | 2024-04-25 09:15:30 -0700

  * rewrite of ZAM optimization of BiFs and script functions/idioms (Vern Paxson, Corelight)

  * flag base script as being known to ZAM optimization (Vern Paxson, Corelight)

  * ZAM optimization for constructing records w/ fields initialized to network_time (Vern Paxson, Corelight)

  * factor some functionality used by BiFs to make accessible to ZAM instructions (Vern Paxson, Corelight)

  * factor script optimization Expr AST nodes out of main AST header (Vern Paxson, Corelight)

  * new internal AST node for expression idioms with corresponding ZAM built-ins (Vern Paxson, Corelight)

  * streamlining of expressions only used for script optimization (Vern Paxson, Corelight)

  * reordering of expressions to match main usage vs. script-optimization extras (Vern Paxson, Corelight)

  * support for conditional expressions transforming into interal has-elements expr (Vern Paxson, Corelight)

  * make same_expr() functionality accessible as a utility (Vern Paxson, Corelight)

  * unify functionality across EqExpr and RelExpr classes (Vern Paxson, Corelight)

  * introduce notions of script functions/BiFs that are (1) foldable, (2) replaceable (Vern Paxson, Corelight)

  * optimization of scripting idioms - min/max, has-elements (Vern Paxson, Corelight)

  * hooks for ZAM optimization of calls to particular functions (Vern Paxson, Corelight)

  * shift ZAM maintenance monitoring of new BiFs to a BTest so it automatically runs (Vern Paxson, Corelight)

  * make externally available the expression used for initializating a record field (Vern Paxson, Corelight)

  * record field initialization optimization: do coercions at compile-time if applicable (Vern Paxson, Corelight)

  * $ZAM_PROFILE_ALL set tells ZAM to profile function bodies even if not executed (Vern Paxson, Corelight)

  * performance speed-up for SMB base scripts (Vern Paxson, Corelight)

  * fix for ZAM optimization pruning of unnecessary instructions (Vern Paxson, Corelight)

  * bug fix for ZAM code generation (Vern Paxson, Corelight)

  * optimize generation of "-O gen-C++" code for table/vector size operations (Vern Paxson, Corelight)

  * removing vestigial same_val() function (Vern Paxson, Corelight)

  * fix for ZAM optimization of '!' expressions (Vern Paxson, Corelight)

  * fix for ZAM tracking of return values when in-lining (Vern Paxson, Corelight)

  * fix for ZAM profiling potentially accessing freed memory (Vern Paxson, Corelight)

  * Fix typo in hook name (Benjamin Bannier, Corelight)

    While in Spicy code a hook priority is spelled `priority=4711` the
    attribute is still called `&priority` (like in HILTI) and we rely on
    exactly that name when e.g., extracting hook priorities for scheduling.

    This change was introduced as part of
    db98dc419334667e9299ef00670f4d435f3e408c and caused the default hook
    priority for hooks defined in EVT files (intended to be -1000 to likely
    schedule after e.g., hooks in the Spicy grammars) to be ignored. This
    could then e.g., introduce issue when a `%done` hook would mutate state
    exposed in an EVT hook (which now might not have seen the updated state
    due to different scheduling).

7.0.0-dev.147 | 2024-04-22 17:08:25 -0700

  * Don't attempt to stop or flush disabled writer frontends (Tim Wojtulewicz, Corelight)

7.0.0-dev.145 | 2024-04-22 15:55:53 -0700

  * Allow SMB_TCP record to contain multiple protocol identifiers/headers (Tim Wojtulewicz, Corelight)

7.0.0-dev.143 | 2024-04-22 15:15:55 -0700

  * Check for valid identifier in WhenStmt::Describe (Tim Wojtulewicz, Corelight)

  * Bump zeek-aux submodule to pull in zeek-archiver addition (Christian Kreibich, Corelight)

  * Remove zeek-archiver from build config, deprecate --disable-archiver in configure (Christian Kreibich, Corelight)

  * Drop zeek-archiver submodule (Christian Kreibich, Corelight)

    zeek-archiver now lives in the zeek-aux submodule.

7.0.0-dev.136 | 2024-04-18 09:02:14 -0700

  * Update core.pcap.filter-warning baseline (Peter Cullen, Corelight)

    Only the line numbers changed.

  * Add PacketFilter::remove_exclude function (Peter Cullen, Corelight)

    This adds a public function to the PacketFilter framework that
    allows the caller to remove an exclude filter by filter id.

7.0.0-dev.132 | 2024-04-17 14:59:43 -0700

  * Parse and store localversion string (Peter Cullen, Corelight)

  * Update version string btests for localversion (Peter Cullen, Corelight)

  * Support for configurable localversion (Peter Cullen, Corelight)

7.0.0-dev.123 | 2024-04-17 14:33:55 -0700

  * fix for ZAM optimization of "while" loops (Vern Paxson, Corelight)

7.0.0-dev.121 | 2024-04-17 09:20:53 -0700

  * Add Opensuse leap 15.6 to CI (Johanna Amann, Corelight)

7.0.0-dev.119 | 2024-04-15 17:52:44 +0200

  * Bump Spicy. (Robin Sommer, Corelight)

    Includes a couple of updates for the QUIC analyzer.

  * Remove support for old Spicy versions from QUIC analyzer. (Robin Sommer, Corelight)

7.0.0-dev.116 | 2024-04-11 15:26:05 -0700

  * Make sure that vcpkg isn't preferred if pcap_root_dir is passed in (Tim Wojtulewicz)

7.0.0-dev.114 | 2024-04-10 11:02:32 +0200

  * Bump Spicy, including necessary changes to work with the current
    Spicy version. (Robin Sommer, Corelight)

  * Remove some unused Spicy state. (Robin Sommer, Corelight)

7.0.0-dev.111 | 2024-04-09 15:12:13 -0700

  * ZAM fix for concretizing vectors in record constructors (Vern Paxson, Corelight)

  * improve ZAM's estimation of profiling overheads (Vern Paxson, Corelight)

7.0.0-dev.108 | 2024-04-08 12:02:03 -0700

  * CI: Remove commented openssl 1.1 workaround from macOS preparation script (Tim Wojtulewicz, Corelight)

  * CI: Fix installation of python package on macOS (Tim Wojtulewicz, Corelight)

  * fix ZAM "cat" of doubles/times to include trailing ".0" per normal BiF behavior (Vern Paxson, Corelight)

7.0.0-dev.102 | 2024-04-02 08:17:08 -0700

  * fix ZAM "cat" of doubles/times to include trailing ".0" per normal BiF behavior (Vern Paxson, Corelight)

7.0.0-dev.100 | 2024-03-29 11:15:24 -0700

  * CI: Specify the xcode version of the macOS Sonoma instance (Tim Wojtulewicz, Corelight)

7.0.0-dev.98 | 2024-03-28 11:09:48 -0700

  * Remove vestigial Conan bit in CMakeLists.txt (Christian Kreibich, Corelight)

  * When configuring Spicy, be prepated for zeek_lib or zeek_exe targets. (Christian Kreibich, Corelight)

  * Fix a typo in CMakeLists.txt when building Zeek as a library (Christian Kreibich, Corelight)

7.0.0-dev.94 | 2024-03-25 11:25:47 +0100

  * Bump Spicy to current `main`. (Robin Sommer, Corelight)

7.0.0-dev.92 | 2024-03-19 14:39:26 -0700

  * ZAM documentation updated to reflect finer-grained profiling (Vern Paxson, Corelight)

  * ZAM-specific BTest baseline changes for tweak to how ZAM bodies print (Vern Paxson, Corelight)

  * BTest baseline changes for tweak to how ZAM bodies print (Vern Paxson, Corelight)

  * ZAM execution changes to support richer profiling (Vern Paxson, Corelight)

  * use richer block-aware location information for ZAM instructions (Vern Paxson, Corelight)

  * better isolation of ZAM instruction elements (Vern Paxson, Corelight)
    hooks for tracking extended ZAM profiling location

  * framework for --enable-ZAM-profiling configuration (Vern Paxson, Corelight)
    profiles go to zprof.log rather than stdout

  * ZAM classes in support of finer-grained profiling (Vern Paxson, Corelight)

  * refined ZAM function profiling to include (correct) statement line number blocks (Vern Paxson, Corelight)

  * avoid potentially expensive mallinfo() call if result won't be used (Vern Paxson, Corelight)

7.0.0-dev.80 | 2024-03-19 10:59:22 -0700

  * Remove variant from StdFunctionStmt (Tim Wojtulewicz, Corelight)

    The variant ended up conflicting with std::bind, which resulted in failures
    on the btest invoking it. Change back to a single function that takes a
    flow, and default it to a value in Exec.

7.0.0-dev.78 | 2024-03-18 16:37:46 -0700

  * Add a method to register an event handler to a std::function via C++ (Tim Wojtulewicz, Corelight)

7.0.0-dev.76 | 2024-03-18 16:15:44 -0700

  * Update Broker submodule (Dominik Charousset, Corelight)

  * cirrus: Remove misleading and always empty AWS_ECR_USERNAME (Arne Welzel, Corelight)

7.0.0-dev.72 | 2024-03-18 09:55:51 +0100

  * btest/spicy: Remove most port usages (Arne Welzel, Corelight)

  * spicy: Deprecate port/ports in .evt files (Arne Welzel, Corelight)

  * Update doc submodule (Arne Welzel, Corelight)

    For spicy-pygments.py sync.

  * github/generate-docs: Only commit if there are staged changes (Arne Welzel, Corelight)

    git diff-index by default includes staged and non-staged changes.
    The autogen-spicy-docs script copies over spicy-pygments.py from
    the Spicy tree into doc/ext.

    The job would attempt to commit scripts and script-reference even
    though nothing actually is staged when a spurious diff existed in
    ext/spicy-pygments.py. Guard from this by using --cached.

7.0.0-dev.66 | 2024-03-16 11:14:25 +0100

  * Bump Spicy to latest version reworking AST memory management. (Robin Sommer, Corelight)

    Includes the necessary Zeek-side changes.

    Goes with https://github.com/zeek/spicy/pull/1691.

  * GH-3647: Add a CI test with the same options as we used for binary builds. (Johanna Amann, Corelight)

    We already do have a test that check static builds, but none that tests
    the exact same build flags we use for binary builds on OBS. This commit
    fixes this oversight.

  * GH-3647: Fix binary build of `spicyz`. (Robin Sommer, Corelight)

    We need to link against the Spicy toolchain's object libraries but
    were linking against static libraries instead.

7.0.0-dev.61 | 2024-03-15 13:14:47 -0700

  * CI: Remove CentOS 7 and Debian 10 builds (Tim Wojtulewicz, Corelight)

7.0.0-dev.59 | 2024-03-15 13:36:30 +0100

  * testing/external/cluster: Switch to docker-compose v2 (Arne Welzel, Corelight)

    The Python docker-compose executable in the docker_builder image is not
    functional anymore (TypeError: kwargs_from_env() got an unexpected
    keyword argument 'ssl_version').

    docker-compose v1 has been sun-setted for quite some time. Do the
    minimal to switch to docker compose v2.

7.0.0-dev.57 | 2024-03-13 10:17:48 -0700

  * Add community contributions for the 6.2 timeframe to NEWS. [skip ci] (Christian Kreibich, Corelight)

7.0.0-dev.54 | 2024-03-12 10:31:19 +0100

  * GH-3640: Expr: Handle TYPE_VOID in SizeExpr and AssignExpr::Typecheck() (Arne Welzel, Corelight)

    @vpax reported surprising behavior when working with "void values".
    While these are not exposed to script land, plumb the places he
    pointed out are causing confusing behavior.

    Closes #3640.

7.0.0-dev.52 | 2024-03-08 19:10:06 +0100

  * AST location fixes for -O gen-C++ (Vern Paxson, Corelight)

  * script optimization support for clearing tables/vectors using "delete" (Vern Paxson, Corelight)

  * fix for ZAM printing of instructions that modify slots other than slot 1 (Vern Paxson, Corelight)

  * fixed bug where appending an empty vector to a vector-of-vector's had no effect (Vern Paxson, Corelight)

7.0.0-dev.47 | 2024-03-07 09:52:29 +0100

  * Bump Spicy. (Robin Sommer, Corelight)

7.0.0-dev.45 | 2024-03-06 10:38:55 +0100

  * Make worker restart in cluster btest race-proof (Jan Grashoefer, Corelight)

7.0.0-dev.43 | 2024-03-05 19:23:09 +0100

  * highwayhash: Point to github.com/google/highwayhash, bump to master (Arne Welzel, Corelight)

  * RE/Specific_RE_Matcher: Make Compile() return false for syntax errors (Arne Welzel, Corelight)

    When creating RE_Matcher instances at runtime and verifying the pattern
    compiles via Compile(), the syntax_error flag wasn't respected and
    Compile() would return true even for some invalid regular expressions.

    For example, compiling /a{1,b}/, Compile() would return true even though
    it produced a reporter error while parsing complaining about b not
    being valid.

    This patch improves the error handling, so that calling Compile() returns
    false whenever zeek::detail::synerr() was called while a pattern was
    parsed. The use-case is creation of patterns at runtime based on
    JavaScript strings. These might be entered or received at runtime via
    an API. This change allows to be a bit more robust to detect invalid
    input and raising exceptions to notify the user.

    This also move syntax_error and csize out of global scope.

    If RE_Matcher was to be used as an actual API, we likely should squelch
    the reporter errors and mark it as not thread safe, but this is a small
    step forward.

7.0.0-dev.38 | 2024-03-04 12:32:59 -0700

  * CI: Bump FreeBSD 13 build to 13.3 (Tim Wojtulewicz, Corelight)

7.0.0-dev.36 | 2024-03-04 18:22:34 +0100

  * Stmt: Fix assert evaluating cond twice (Arne Welzel, Corelight)

    Since 81a9745fb36fb6705873921423364bd2c438bfc4, the assert condition is
    evaluated twice. This leads to unexpected behavior when cond has a side
    effect like publishing a message or creating a log stream or filter.

    Found while using the following in ad-hoc testing code and wondering
    why two messages were published.

        assert publish(Cluster::worker_topic, hello, "abc")

7.0.0-dev.34 | 2024-03-04 15:49:19 +0100

  * Port Spicy integration to new AST API. (Robin Sommer, Corelight)

7.0.0-dev.32 | 2024-02-28 17:10:26 +0100

  * Bump zeekjs to 0.12.0 (Arne Welzel, Corelight)

      0a89ca6 doc: Expand zeek.as() description and add an example
      7e814d7 Types: Implement basic pattern support
      43df9d2 Update docs to provide example of shared Node.js openSSL configuration
      3bf2ea5 lsan suppressions: Add some for 21.11
      640affa zeek.global_vars: Remove leftover internal field usage
      3ee53c7 zeek.global_vars: Implement setter
      8144061 zeek.as: Support more Zeek types
      b453483 zeek.as: Fix crash for non-atomic types

7.0.0-dev.29 | 2024-02-27 15:18:49 +0100

  * GH-3619: spicy/zeekygen: Remove mtime from generated code (Arne Welzel, Corelight)

    Zeekygen implements its own make-style update logic to prevent
    re-creation of files that have not changed. To fulfill this, we
    currently encode the current time into spicyz generated .cc files.

    This degrades ccache efficiency for built-in analyzers and also
    for all .evt files compiled during testing. Switch SpicyModuleInfo
    to return current time instead. This results in the re-generation
    of documentation files unconditionally when running Zeekygen, but
    that seems more acceptable IMO.

    Generally wonder if Zeekygen should produce output unconditionally
    and if we need to clobber prevention, compare with the content of
    the existing file.

7.0.0-dev.26 | 2024-02-26 21:15:59 +0100

  * signatures/iso-9660: Add \x01 suffix to CD001 (Arne Welzel, Corelight)

    As discussed with Tim, that should make it a bit more robust against
    false positives.

  * test-all-policy: Do not load iso-9660.zeek (Arne Welzel, Corelight)

    Changing the default_file_bof_buffer_size has subtle impact on
    MIME type detection and changed the zeek-testing baseline. Do
    not load this new script via test-all-policy to avoid this.

    The new test was mainly an aid to understand what is actually going on.
    In short, if default_file_bof_buffer_size is larger than the file MIME
    detection only runs when the buffer is full, or when the file is removed.
    When a file transfer happens over multiple HTTP connections, only
    some or one of the http.log entries will have a proper response MIME type.

    PCAP extracted from 2009-M57-day11-18.trace.gz.

  * signatures: Move ISO 9660 signature to policy (Arne Welzel, Corelight)

    The previous "fix" caused significant performance degradation without
    the signature ever having a chance to trigger. Moving it to policy
    seems the best compromise, the alternative being outright removing it.

  * GH-3490: global_ids: Align script_id$type_name field with type_name() (Arne Welzel, Corelight)

    Populate script_id$type_name with what the type_name() bif
    would produce for the same identifier.

    Closes #3490

  * utils: Introduce packages.zeek with can_load() helper (Arne Welzel, Corelight)

  * GH-3594: zeek.bif: Add find_in_zeekpath() helper (Arne Welzel, Corelight)

    Relates to #3594. This helper can be used to determine the path that
    will be used by @load, if at all.

7.0.0-dev.16 | 2024-02-26 11:09:57 -0700

  * Update Mozilla CA and Google CT list and related tests. (Johanna Amann, Corelight)

7.0.0-dev.13 | 2024-02-22 17:00:29 +0100

  * GH-3139: spicy: Remove Zeek version from spicyz/config.h.in (Arne Welzel, Corelight)

    It seems that Zeek's version number and string only need to be
    available at runtime, so this change removes it from spicyz/configh.in
    to avoid needlessly busting ccache for the src/spicyz tree for on a
    Zeek version bump.

  * spicy: Drop ZEEK_VERSION_NUMBER ifdef'ery (Arne Welzel, Corelight)

    Given src/spicy is part of the Zeek tree, these are not necessary and
    are probably just remains from the spicy-plugin era.

7.0.0-dev.10 | 2024-02-22 12:38:38 +0100

  * signatures: Fix ISO 9960 signature (Arne Welzel, Corelight)

    This signature only really works when default_file_bof_buffer_size is bumped
    to a sufficient value (40k).

7.0.0-dev.8 | 2024-02-22 12:22:56 +0100

  * testing: Update zeek-testing-private commit hash (Arne Welzel, Corelight)

  * ftp: Reset fuid after logging (Arne Welzel, Corelight)

    A user reported being confused about the fuid association of subsequent
    FTP commands when a data transfer has completed. It seems reasonable to
    unset fuid upon logging a FTP command which had a fuid.

    The current behavior results in the PORT or PASV commands after a RETR or STOR
    to have the fuid of the prior file transfer. Similarly, any CWD or DEL commands
    following a file transfer will unnecessarily be logged with the fuid of the
    prior file transfer.

    This tickles the baselines for the private testing PCAP a lot, primarily
    because there data connections in that pcap are never established properly.
    E.g, the fuids FzDzid1Dxm9srVKHXf and FEfYX73q5C6GEQZXX9 have been re-used
    for multiple commands.

    This may look like we're losing information, but the fuids vanishing
    in the normal btests belong to a LIST command that isn't logged by
    default into ftp.log. If it was, the fuid would be attached to it.

7.0.0-dev.5 | 2024-02-22 12:01:33 +0100

  * GH-3472: Allow delete statement for tables, sets and vectors (Arne Welzel, Corelight)

    Relates to #3472. This allow "delete tbl" as an alternative for
    clear_table(tbl). Also works for vectors.

  * Update cmake submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Update cmake submodule [nomail] (Tim Wojtulewicz, Corelight)

  * Point cmake submodule at master branch (Tim Wojtulewicz, Corelight)

  * Start of 7.0.0 development (Tim Wojtulewicz, Corelight)

  * Update zkg submodule to v3.0.1 (Tim Wojtulewicz, Corelight)

6.2.0-dev.545 | 2024-02-20 10:57:30 -0700

  * Pull in variant-enabled Broker (Dominik Charousset, Corelight)

    Switch the Broker submodule to a version with `broker::variant` enabled
    and provide new overloads for `broker::variant` in the Broker manager.

6.2.0-dev.543 | 2024-02-15 11:08:16 -0500

  * Bump zkg to v3.0.0 (Tim Wojtulewicz, Corelight)

6.2.0-dev.541 | 2024-02-15 11:07:17 -0500

  * Bump Spicy to latest dev snapshot. (Benjamin Bannier, Corelight)

6.2.0-dev.539 | 2024-02-13 20:10:06 +0100

  * zeek.bif: Booleanate String constructor calls (Arne Welzel, Corelight)

  * Conn/net_utils/fmt_mac: Avoid snprintf(), memcpy() and allocation (Arne Welzel, Corelight)

    The fmt_mac() function returning a std::string means the resulting mac
    is copied at least once upon returning. Then, the Assign() in GetVal()
    taking a std::string internally allocates a new zeek::String which
    hits a malloc (no short-string optimization for zeek::String) and then
